function Library.LibFluff.Border(name, parent)
  local border = UI.CreateFrame("Frame",name, parent)
  border:SetAllPoints()
  border.left = UI.CreateFrame("Frame", name .. " Left", border)
  border.top = UI.CreateFrame("Frame", name .." Top", border)
  border.right = UI.CreateFrame("Frame",name .. " Right", border)
  border.bottom = UI.CreateFrame("Frame",name .." Bottom", border)

  border.left:SetPoint("TOPRIGHT", border, "TOPLEFT")
  border.left:SetPoint("BOTTOMRIGHT", border, "BOTTOMLEFT")
  border.right:SetPoint("TOPLEFT", border, "TOPRIGHT")
  border.right:SetPoint("BOTTOMLEFT", border, "BOTTOMRIGHT")



  function border:SetBorderColor(r, g, b, a)
    self.left:SetBackgroundColor(r, g, b, a)
    self.top:SetBackgroundColor(r, g, b, a)
    self.right:SetBackgroundColor(r, g, b, a)
    self.bottom:SetBackgroundColor(r, g, b, a)
  end

  local oldSetParent = border.SetParent
  function border:SetParent(parent)
    oldSetParent(self, parent)
    border:SetAllPoints(parent)
  end

  function border:SetBorderWidth(first, second, third, fourth)
    -- top, right, bottom, left
    -- Check that all parameters are valid
    if first then if type(first) ~= "number" then print("Invalid parameters! Usage: Border:SetWidth(top, right, bottom, left)")return end end
    if second then if type(second) ~= "number" then print("Invalid parameters! Usage: Border:SetWidth(top, right, bottom, left)")return end end
    if third then if type(third) ~= "number" then print("Invalid parameters! Usage: Border:SetWidth(top, right, bottom, left)")return end end
    if fourth then if type(fourth) ~= "number" then print("Invalid parameters! Usage: Border:SetWidth(top, right, bottom, left)")return end end

    local top, right, bottom, left

    if fourth then
    --four parameters
    top, right, bottom, left = first, second, third, fourth
    elseif third then
      --three parameters
      top, right, bottom, left = first, second, third, second
    elseif second then
      --two parameters
     top, right, bottom, left = first, second, first, second
    elseif first then
      --one parameter
      top, right, bottom, left = first, first, first, first
    else
      print("No parameters! Usage: Border:SetWidth(first, second, third, fourth)")
      return
    end

    if top == 0 then
      self.top:SetVisible(false)
    else
      self.top:SetVisible(true)
      self.top:SetHeight(top)
      self.top:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0 - left, 0)
      self.top:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", right, 0)
    end

    if right == 0 then
      self.right:SetVisible(false)
    else
      self.right:SetVisible(true)
      self.right:SetWidth(right)
    end

    if bottom == 0 then
      self.bottom:SetVisible(false)
    else
      self.bottom:SetVisible(true)
      self.bottom:SetHeight(bottom)
      self.bottom:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 0 - left, 0)
      self.bottom:SetPoint("TOPRIGHT", self, "BOTTOMRIGHT", right, 0)
    end
    if left == 0 then
      self.left:SetVisible(false)
    else
      self.left:SetVisible(true)
      self.left:SetWidth(left)
    end
  end

  return border
end