kAlert.config = {}
kAlert.config.movers = {}
kAlert.config.mainFrame = nil
kAlert.config.layoutFrame = nil
kAlert.config.importExportFrame = nil
kAlert.config.helpFrame = nil
kAlert.config.aboutFrame = nil
kAlert.config.active = false
kAlert.config.tLocation = {"CENTER","TOPCENTER","BOTTOMCENTER","LEFTCENTER","RIGHTCENTER"}
kAlert.config.recources = {kAlertTexts.resHealth,kAlertTexts.resMana,kAlertTexts.resEnergy,kAlertTexts.resPower,kAlertTexts.resCharge,kAlertTexts.resComboPoints}
kAlert.config.units = {kAlertTexts.unitPlayer,kAlertTexts.unitTarget,kAlertTexts.unitFocus,kAlertTexts.unitPet}
kAlert.config.evaluationTypes = {kAlertTexts.buff,kAlertTexts.ability,kAlertTexts.resource,kAlertTexts.casting}

function kAlert.config.main()

	kAlert.config.active = true
	if kAlert.config.mainFrame == nil then
		kAlert.config.buildMainFrame()
	else
		kAlert.config.mainFrame:SetVisible(true)
	end
	kAlert.config.mainFrame.btClear.Event:LeftPress()
	kAlert.config.mainFrame.frScreenObjects.fillList(kAlert.alertSet.alerts)
	kAlert.config.set = kAlertSet
	kAlert.config.subSet = kAlertSubSet
	if kAlertSet < 6 then
		kAlert.config.mainFrame.txtASNumber:SetText("Set " .. tostring(kAlertSet))
	else
		kAlert.config.mainFrame.txtASNumber:SetText("Sub Set " .. tostring(kAlertSet-5))
	end
	kAlertSubSet = 0
	
end

function kAlert.config.buildLayoutFrame()
	local window = UI.CreateFrame("RiftWindow", "kAlertConfigLayoutFrame", kAlert.context)
	window:SetTitle(kAlertTexts.titleLayout)
	window:SetHeight(100)
	window:SetWidth(260)
	window:SetPoint("TOPLEFT", UIParent, "TOPLEFT",UIParent:GetWidth()/2-100,UIParent:GetHeight()/2-50)
	window:SetLayer(99)
	-- Mover Box
	window.frMoveBar = kUtils.buildWindowMover("frMoveBar", window, true)

	window.btSave = kUtils.buildButton("btSave",window,35,120,kAlertTexts.btSave)
	window.btSave:SetPoint ("TOPCENTER", window, "TOPCENTER", -60, 50)

	function window.btSave.Event:LeftPress()
		for id, details in pairs(kAlert.screenObjects.object) do
			if details.name ~= nill then
				kAlert.config.movers.object[id].clearTarget()
				if kAlert.alertSet.alerts[details.name] ~= nil then
					kAlert.alertSet.alerts[details.name].imageX = details:GetLeft()
					kAlert.alertSet.alerts[details.name].imageY = details:GetTop()
				end
			end
		end
		kAlert.screenObjects.hide()
		window:SetVisible(false)
		kAlert.config.mainFrame:SetVisible(true)
	end
	
	window.btCancel = kUtils.buildButton("btCancel",window,35,120,kAlertTexts.btCancel)
	window.btCancel:SetPoint ("LEFTCENTER", window.btSave, "RIGHTCENTER")
	
	function window.btCancel.Event:LeftPress()
		for id, details in pairs(kAlert.screenObjects.object) do
			if details.name ~= nill then
				kAlert.config.movers.object[id].clearTarget()
			end
		end
		kAlert.screenObjects.hide()
		window:SetVisible(false)
		kAlert.config.mainFrame:SetVisible(true)
	end

	kAlert.config.layoutFrame = window
	
end

function kAlert.config.buildAboutFrame()
	local window = UI.CreateFrame("RiftWindow", "kAlertAboutFrame", kAlert.context)
	window:SetTitle(kAlertTexts.miAbout)
	window:SetHeight(500)
	window:SetWidth(460)
	window:SetPoint("TOPLEFT", UIParent, "TOPLEFT",UIParent:GetWidth()/2-(window:GetWidth()/2),UIParent:GetHeight()/2-(window:GetHeight()/2))
	window:SetLayer(99)
	-- Mover Box
	window.frMoveBar = kUtils.buildWindowMover("frMoveBar", window, true)

	window.txtAboutTitle = kUtils.buildLabel("txtAboutTitle", window, 15, window:GetWidth() - 60, kAlertTexts.abtTitle,true)
	window.txtAboutTitle:SetPoint("TOPLEFT", window, "TOPLEFT", 30, 65)

	window.txtAboutVersion = kUtils.buildLabel("txtAboutVersion", window, 15, window:GetWidth() - 60, kAlertTexts.abtVersion .. tostring(kAlert.version),true)
	window.txtAboutVersion:SetPoint("TOPLEFT", window.txtAboutTitle, "BOTTOMLEFT")

	window.txtAboutInfo = kUtils.buildLabel("txtAboutInfo", window, 15, window:GetWidth() - 60, kAlertTexts.abtInfo,true)
	window.txtAboutInfo:SetPoint("TOPLEFT", window.txtAboutVersion, "BOTTOMLEFT" )
	window.txtAboutInfo.setWrapText(kAlertTexts.abtInfo)

	window.btClose = kUtils.buildButton("btClose",window,35,120,kAlertTexts.btClose,"close")
	window.btClose:SetPoint ("TOPRIGHT", window, "TOPRIGHT", -9, 16)
	
	function window.btClose.Event:LeftPress()
		window:SetVisible(false)
	end

	kAlert.config.aboutFrame = window
	
end

function kAlert.config.buildHelpFrame()
	local window = UI.CreateFrame("RiftWindow", "kAlertConfigImportExportFrame", kAlert.context)
	window:SetTitle("Karuul Alert Help")
	window:SetHeight(600)
	window:SetWidth(700)
	window:SetPoint("TOPLEFT", UIParent, "TOPLEFT",UIParent:GetWidth()/2-(window:GetWidth()/2),UIParent:GetHeight()/2-(window:GetHeight()/2))
	window:SetLayer(100)
	window:SetVisible(false)
	-- Mover Box
	window.frMoveBar = kUtils.buildWindowMover("frMoveBar", window, true)
	
	window.frIndex = kUtils.buildListPane("frIndex",window, table.getn(kAlertHelpIndex)*20,160,table.getn(kAlertHelpIndex))
	window.frIndex:SetPoint ("TOPLEFT", window, "TOPLEFT", 30, 65)
	window.frIndex.fillTextList(kAlertHelpIndex)

	function window.frIndex.click(button)
	
		window.sections.clear()
		local topic = kAlertHelpTopic[window.frIndex.getSelected()]
		for i = 1, table.getn(topic), 1 do
			window.sections.add(topic[i].label, topic[i].text)
		end
		window.frPage:SetPoint("TOPLEFT", window.frView, "TOPLEFT")
		if window.frIndex.getSelected() == "Configuration Screen" then
			window.ibConfig:SetVisible(true)
			window.sections.section[1].label:SetPoint("TOPLEFT", window.frPage, "TOPLEFT",0,window.ibConfig:GetHeight()+2)
			window.frPage:SetHeight(math.max(window.ibConfig:GetHeight()+2+window.sections.getHeight(),window.frView:GetHeight()))
		else
			window.ibConfig:SetVisible(false)
			window.sections.section[1].label:SetPoint("TOPLEFT", window.frPage, "TOPLEFT")
			window.frPage:SetHeight(math.max(window.sections.getHeight(),window.frView:GetHeight()))
		end
		window.scrPage:SetRange(window.frView:GetHeight(),window.frPage:GetHeight())
	end
	
	window.frView = UI.CreateFrame("Mask", "frView", window)
	window.frView:SetHeight(window:GetHeight() - 120)
	window.frView:SetWidth(window:GetWidth() - window.frIndex:GetWidth() - 70)
	window.frView:SetPoint ("TOPLEFT", window.frIndex, "TOPRIGHT", 10, 0)
	window.frView.outline = kUtils.setOutline(window.frView)
	
	window.frPage = kUtils.buildFrame("frPage", window.frView, window.frView:GetHeight(), window.frView:GetWidth())
	window.frPage:SetBackgroundColor(0,0,0,0.5)
	window.frPage:SetPoint("TOPLEFT", window.frView, "TOPLEFT")
	
	window.scrPage = kUtils.buildScroller("scrPage", window, window.frView:GetHeight(), 12)
	window.scrPage:SetPoint("TOPLEFT", window.frView, "TOPRIGHT")
	window.scrPage:SetRange(window.frView:GetHeight(),window.frPage:GetHeight())
	function window.scrPage.Callback(value)
		window.frPage:SetPoint("TOPLEFT", window.frView, "TOPLEFT",0,-1*value)
	end
	
	window.ibConfig = UI.CreateFrame("Texture", "ibConfig", window.frPage)
	window.ibConfig:SetTexture("kAlert", "images\\ConfigScreen.png")
	window.ibConfig:ResizeToTexture()
	window.ibConfig:SetVisible(false)
	window.ibConfig:SetPoint("TOPCENTER", window.frPage, "TOPCENTER",0,2)
	
	window.sections = {}
	window.sections.section = {}
	window.sections.count = 0
	function window.sections.clear()
		for i = 1, table.getn(window.sections.section), 1 do
			window.sections.section[i].label.setWrapText("")
			window.sections.section[i].labelLine:SetVisible(false)
			window.sections.section[i].text.setWrapText("")
		end
		window.sections.count = 0
	end
	function window.sections.add(label,text)
		local index = window.sections.count + 1
		if window.sections.section[index] == nil then
			local section = {}
			if index == 1 then 
				section.label = kUtils.buildLabel("lblSection" .. tostring(index), window.frPage, 22, window.frPage:GetWidth(), "",true)
				section.label:SetPoint("TOPLEFT", window.frPage, "TOPLEFT")
				section.label:SetFontColor(0,0,0)
				section.label:SetBackgroundColor(.75,.60,0)
			else
				section.label = kUtils.buildLabel("lblSection" .. tostring(index), window.frPage, 18, window.frPage:GetWidth(), "",true)
				section.label:SetPoint("TOPLEFT", window.sections.section[index-1].text, "BOTTOMLEFT",-20,10)
				section.label:SetFontColor(.75,.60,0)
			end
			section.label:SetFont("Rift","$Flareserif_bold")
			section.labelLine = UI.CreateFrame("Frame", "lblSectionLine" .. tostring(index), section.label)
			section.labelLine:SetPoint("CENTERTOP", section.label, "CENTERTOP")
			section.labelLine:SetHeight (1)
			section.labelLine:SetWidth (section.label:GetWidth())
			section.labelLine:SetBackgroundColor(.52,.51,.42)
			section.text = kUtils.buildLabel("txtSection" .. tostring(index), section.label, 15, window.frPage:GetWidth()-40, "",true)
			section.text:SetPoint("TOPLEFT", section.label, "BOTTOMLEFT",20,0)
			section.text:SetFontColor(.9,.9,.9)
			window.sections.section[index] = section
		end
		window.sections.section[index].label.setWrapText(label)
		window.sections.section[index].labelLine:SetVisible(true)
		window.sections.section[index].text.setWrapText(text)
		window.sections.count = window.sections.count + 1
	end
	function window.sections.getHeight()
		local height = 0
		for i = 1, table.getn(window.sections.section), 1 do
			height = height + window.sections.section[i].label:GetHeight() + 10
			height = height + window.sections.section[i].text:GetHeight()
		end
		return height
	end

	for id, details in pairs(kAlertHelpTopic) do
		window.sections.clear()
		for i = 1, table.getn(details), 1 do
			window.sections.add(details[i].label, details[i].text)
		end
	end
	window.sections.clear()
	window.sections.add(kAlertHelpTopic["Intro"][1].label, kAlertHelpTopic["Intro"][1].text)
	window.frPage:SetHeight(math.max(window.sections.getHeight(),window.frView:GetHeight()))
	
	window.btClose = kUtils.buildButton("btClose",window,35,120,kAlertTexts.btClose,"close")
	window.btClose:SetPoint ("TOPRIGHT", window, "TOPRIGHT", -9, 16)
	
	function window.btClose.Event:LeftPress()
		window:SetVisible(false)
		window.sections.clear()
		window.ibConfig:SetVisible(false)
		window.sections.section[1].label:SetPoint("TOPLEFT", window.frPage, "TOPLEFT")
		window.sections.add(kAlertHelpTopic["Intro"][1].label, kAlertHelpTopic["Intro"][1].text)
		window.frPage:SetHeight(math.max(window.sections.getHeight(),window.frView:GetHeight()))
		window.scrPage:SetRange(window.frView:GetHeight(),window.frPage:GetHeight())
		window.frIndex.clearSelected()
	end

	kAlert.config.helpFrame = window
	
end

function kAlert.config.buildImportExportFrame()
	local window = UI.CreateFrame("RiftWindow", "kAlertConfigImportExportFrame", kAlert.context)
	window:SetTitle("")
	window:SetHeight(150)
	window:SetWidth(500)
	window:SetPoint("TOPLEFT", UIParent, "TOPLEFT",UIParent:GetWidth()/2-(window:GetWidth()/2),UIParent:GetHeight()/2-(window:GetHeight()/2))
	window:SetLayer(99)
	window:SetVisible(false)
	-- Mover Box
	window.frMoveBar = kUtils.buildWindowMover("frMoveBar", window, true)
	
	window.ebData = kUtils.buildEditBox("ebData",window,20,window:GetWidth() - 60,"")
	window.ebData:SetPoint ("TOPLEFT", window, "TOPLEFT", 30, 65)
	
	window.btImport = kUtils.buildButton("btImport",window,35,120,kAlertTexts.btImport)
	window.btImport:SetPoint ("BOTTOMCENTER", window, "BOTTOMCENTER",-60,-20)
	
	function window.btImport.Event:LeftPress()
		if window:GetTitle() == kAlertTexts.btImportAlert then
			kAlert.alertSet.add(kAlert.config.formatAlertImport(window.ebData.text:GetText()))
		elseif window:GetTitle() == kAlertTexts.btImportSet then
			kAlert.config.formatSetImport(window.ebData.text:GetText(),kAlertSet)
		end
		kAlert.screenObjects.refresh()
		kAlert.config.mainFrame.btClear.Event:LeftPress()
		kAlert.config.mainFrame.frScreenObjects.fillList(kAlert.alertSet.alerts)
		kAlert.screenObjects.hide()
		window:SetVisible(false)
	end

	window.btCancel = kUtils.buildButton("btCancel",window,35,120,kAlertTexts.btCancel)
	window.btCancel:SetPoint ("LEFTCENTER", window.btImport, "RIGHTCENTER")
	
	function window.btCancel.Event:LeftPress()
		window:SetVisible(false)
	end

	kAlert.config.importExportFrame = window
	
end

function kAlert.config.buildMainFrame()

	local window = UI.CreateFrame("RiftWindow", "kAlertConfigMainFrame", kAlert.context)
	window:SetTitle(kAlertTexts.addonName)
	window:SetHeight(625)
	window:SetWidth(890)
	window:SetPoint("TOPLEFT", UIParent, "TOPLEFT",UIParent:GetWidth()/2-445,UIParent:GetHeight()/2-280)

	-- Mover Box
	window.frMoveBar = kUtils.buildWindowMover("frMoveBar", window, true)
	
	-- Main Menu
	window.mbMain = kUtils.buildMenuBar("mbMain", window, 20, window:GetWidth() - 60 , {kAlertTexts.miFile,kAlertTexts.miHelp})
	window.mbMain:SetPoint ("TOPLEFT", window, "TOPLEFT", 30, 65)
	window.mbMain:SetLayer (41)
	window.mbMain.setItems(kAlertTexts.miFile,150,{kAlertTexts.btImportAlert,kAlertTexts.btImportSet,kAlertTexts.btExportAlert,kAlertTexts.btExportSet})
	window.mbMain.setItems(kAlertTexts.miHelp,100,{kAlertTexts.miAbout,kAlertTexts.miContents})
	function window.mbMain.click(item)
		window.mbMain.itemsEnabled(kAlertTexts.miFile,false)
		local exportAlert = ""
		if string.len(window.ebAlertName.text:GetText()) > 0 then
			exportAlert = window.ebAlertName.text:GetText()
			window.mbMain.itemEnabled(kAlertTexts.miFile,kAlertTexts.btExportAlert,true)
		elseif string.len(window.frScreenObjects.getSelected()) > 0 then
			exportAlert = window.frScreenObjects.getSelected()
			window.mbMain.itemEnabled(kAlertTexts.miFile,kAlertTexts.btExportAlert,true)
		end
		if not window.frScreenObjects.full() then
			window.mbMain.itemEnabled(kAlertTexts.miFile,kAlertTexts.btImportAlert,true)
			window.mbMain.itemEnabled(kAlertTexts.miFile,kAlertTexts.btImportSet,true)
		end
		if window.frScreenObjects.itemCount > 0 then
			window.mbMain.itemEnabled(kAlertTexts.miFile,kAlertTexts.btExportSet,true)
		end

		if item == kAlertTexts.btImportAlert or item == kAlertTexts.btImportSet or item == kAlertTexts.btExportAlert or item == kAlertTexts.btExportSet then
			if kAlert.config.importExportFrame == nil then
				kAlert.config.buildImportExportFrame()
			end
			kAlert.config.importExportFrame.ebData.text:SetText("")
			if item == kAlertTexts.btImportAlert or item == kAlertTexts.btImportSet then
				kAlert.config.importExportFrame.btImport:SetVisible(true)
				kAlert.config.importExportFrame.btCancel:SetPoint ("LEFTCENTER", kAlert.config.importExportFrame.btImport, "RIGHTCENTER")
			elseif item == kAlertTexts.btExportAlert then
				local dataAlert = kAlert.config.formatAlertExport(exportAlert)
				kAlert.config.importExportFrame.ebData.text:SetText(dataAlert)
				kAlert.config.importExportFrame.btImport:SetVisible(false)
				kAlert.config.importExportFrame.btCancel:SetPoint ("LEFTCENTER", kAlert.config.importExportFrame.btImport, "RIGHTCENTER",-60,0)
			elseif item == kAlertTexts.btExportSet then
				local dataSet = kAlert.config.formatSetExport(kAlertSet)
				kAlert.config.importExportFrame.ebData.text:SetText(dataSet)
				kAlert.config.importExportFrame.btImport:SetVisible(false)
				kAlert.config.importExportFrame.btCancel:SetPoint ("LEFTCENTER", kAlert.config.importExportFrame.btImport, "RIGHTCENTER",-60,0)
			end
			kAlert.config.importExportFrame:SetTitle(item)
			kAlert.config.importExportFrame:SetVisible(true)
		end
		if item == kAlertTexts.miAbout then
			if kAlert.config.aboutFrame == nil then
				kAlert.config.buildAboutFrame()
			end
			kAlert.config.aboutFrame:SetVisible(true)
		end
		if item == kAlertTexts.miContents then
			if kAlert.config.helpFrame == nil then
				kAlert.config.buildHelpFrame()
			end
			kAlert.config.helpFrame:SetVisible(true)
		end
	end
	
	-- Alert Set Controls
	window.btASLeft = kUtils.buildButton("btASLeft",window,25,60,"<-")
	window.btASLeft:SetPoint ("TOPLEFT", window.mbMain, "BOTTOMLEFT", 0, 5)

	function window.btASLeft.Event:MouseIn()
		window.mbMain.clear()
	end
	
	function window.btASLeft.Event:LeftPress()
		if kAlertSet > 1 then
			kAlertSet = kAlertSet - 1
			if kAlertSet < 6 then
				window.txtASNumber:SetText("Set " .. tostring(kAlertSet))
			else
				window.txtASNumber:SetText("Sub Set " .. tostring(kAlertSet-5))
			end
			kAlertSubSet = 0
			kAlert.screenObjects.refresh()
			window.frScreenObjects.fillList(kAlert.alertSet.alerts)
			kAlert.screenObjects.hide()
		end
	end
	
	window.frASFrame = kUtils.buildFrame("frASFrame",window,25,80)
	window.frASFrame:SetPoint("BOTTOMLEFT", window.btASLeft, "BOTTOMRIGHT", 0, 0)
	
	window.txtASNumber = kUtils.buildLabel("txtASNumber", window, 15, 80, "Set " .. tostring(kAlertSet))
	window.txtASNumber:SetPoint("CENTER", window.frASFrame, "CENTER")

	function window.txtASNumber.Event:MouseIn()
		window.mbMain.clear()
	end

	window.btASRight = kUtils.buildButton("btASRight",window,25,60,"->")
	window.btASRight:SetPoint ("BOTTOMLEFT", window.frASFrame, "BOTTOMRIGHT", 0, 0)

	function window.btASRight.Event:MouseIn()
		window.mbMain.clear()
	end

	function window.btASRight.Event:LeftPress()
		if kAlertSet < kAlert.alertSet.max then
			kAlertSet = kAlertSet + 1
			if kAlertSet < 6 then
				window.txtASNumber:SetText("Set " .. tostring(kAlertSet))
			else
				window.txtASNumber:SetText("Sub Set " .. tostring(kAlertSet-5))
			end
			kAlertSubSet = 0
			kAlert.screenObjects.refresh()
			window.frScreenObjects.fillList(kAlert.alertSet.alerts)
			kAlert.screenObjects.hide()
		end
	end
	
	window.frScreenObjects = kUtils.buildListPane("frScreenObjects",window, 410,200,kAlert.screenObjects.max)
	window.frScreenObjects:SetPoint("TOPLEFT", window.btASLeft, "BOTTOMLEFT", 0, 5)
	window.frScreenObjects.fillList(kAlert.alertSet.alerts)

	function window.frScreenObjects.onMouseOver()
		window.mbMain.clear()
	end
	
	function window.frScreenObjects.click(button)
	
		if window.frScreenObjects.lastSelected == window.frScreenObjects.getSelected() and window.frScreenObjects.lastSelectedTime == math.floor(Inspect.Time.Real()) then
			window.btEdit.Event:LeftPress()
		else
			window.frScreenObjects.lastSelected = window.frScreenObjects.getSelected()
		end
		
		window.frScreenObjects.lastSelectedTime = math.floor(Inspect.Time.Real())
		
	end

	window.btEdit = kUtils.buildButton("btEdit",window,35,100,kAlertTexts.btEdit)
	window.btEdit:SetPoint ("TOPLEFT", window.frScreenObjects, "BOTTOMLEFT", 0, 5)
	
	function window.btEdit.Event:LeftPress()
		window.setStatus("")
		local alertData = kAlert.alertSet.alerts[window.frScreenObjects.getSelected()]
		if alertData ~= nil then
			--dump(alertData)
			window.btClear.Event:LeftPress()
			window.ebAlertName.text:SetText(alertData.name)
			window.ebAlertLayer.text:SetText(tostring(alertData.layer))
			window.tbRelation.setSelected(alertData.unitRelation)
			for i = 1, table.getn(kAlert.units), 1 do
				if kAlert.units[i] == alertData.unit then window.tbUnit.setSelected(i) end
			end
			window.tbAlertTypes.setSelected(alertData.type)
			if alertData.typeToggle then
				window.tbAlertToggle.setSelected(1)
				window.tbResourceToggle.setSelected(1)
			else
				window.tbAlertToggle.setSelected(2)
				window.tbResourceToggle.setSelected(2)
			end
			local tValue = tostring(alertData.itemValue)
			if tValue ~= 'nil' then
				if alertData.itemValuePercent then
					tValue = tValue .. "%"
				end
				window.ebValue.text:SetText(tValue)
			end
			if alertData.type == 3 then
				window.ebAlertItem.text:SetText("")
				window.tbResourceTypes.setSelected(alertData.itemId)
				if alertData.range then
					window.tbResourceToggle.setSelected(3)
					if alertData.rangeLow == alertData.rangeHigh then
						tValue = tostring(alertData.rangeLow)
					else
						tValue = tostring(alertData.rangeLow) .. '-' .. tostring(alertData.rangeHigh)
					end
					if alertData.itemValuePercent then
						tValue = tValue .. "%"
					end
					window.ebValue.text:SetText(tValue)
				end
			else
				window.ebAlertItem.text:SetText(alertData.itemName)
				window.tbResourceTypes.setSelected(1)
			end
			window.ckSelfCast:SetChecked(alertData.selfCast)
			if alertData.itemLength > 0 then
				window.ebBuffLength.text:SetText(tostring(alertData.itemLength))
			end
			window.ckDisableAlert:SetChecked(not alertData.active)
			window.ckCombatOnly:SetChecked(alertData.combatOnly)
			for id, itemName in pairs(kUtils.split(",",alertData.itemName)) do
				if kAlertGlobalItems[itemName] ~= nil then
					window.ebImage.setDefault(kAlertGlobalItems[itemName].icon)
				end
			end
			if alertData.imageSource ~= "Rift" then
				window.ckDefaultImage:SetChecked(false)
				if string.sub(alertData.image,1,6) == "custom" then
					window.btImageBack:SetVisible(false)
					window.btImageNext:SetVisible(false)
					window.ebImage.index = 0
					window.ebCustomImage.text:SetText(string.sub(alertData.image,8))
				else
					window.btImageBack:SetVisible(true)
					window.btImageNext:SetVisible(true)
					local posStart = string.find(alertData.image,"-") + 1
					local posEnd = string.find(alertData.image,".tga") - 1
					window.ebImage.index = tonumber(string.sub(alertData.image,posStart,posEnd))
					if window.ebImage.index == 1 then
						window.btImageBack:SetVisible(false)
						window.btImageNext:SetVisible(true)
					elseif window.ebImage.index == window.ebImage.count then
						window.btImageBack:SetVisible(true)
						window.btImageNext:SetVisible(false)
					end
				end
			else
				window.ebImage.index = 0
				window.ckDefaultImage:SetChecked(true)
			end
			window.ebImage.setImage(alertData.imageSource,alertData.image)
			window.ebImageX.text:SetText(tostring(alertData.imageX))
			window.ebImageY.text:SetText(tostring(alertData.imageY))
			window.ebImageScale.text:SetText(tostring(alertData.imageScale))
			window.ebImageOpacity.text:SetText(tostring(alertData.imageOpacity*100))
			window.ebText.text:SetText(alertData.text)
			window.ebTextOpacity.text:SetText(tostring(alertData.textOpacity*100))
			if string.sub(alertData.textFont,1,6) == "custom" then
				window.ebTextFont.text:SetText(string.sub(alertData.textFont,8))
			end
			window.ebRed.text:SetText(tostring(alertData.textRed*100))
			window.ebGreen.text:SetText(tostring(alertData.textGreen*100))
			window.ebBlue.text:SetText(tostring(alertData.textBlue*100))
			window.slRed:SetPosition(math.floor(alertData.textRed*100))
			window.slGreen:SetPosition(math.floor(alertData.textGreen*100))
			window.slBlue:SetPosition(math.floor(alertData.textBlue*100))
			window.frColor.setColor()
			window.ebTextSize.text:SetText(tostring(alertData.textSize))
			for i = 1, table.getn(kAlert.config.tLocation), 1 do
				if kAlert.config.tLocation[i] == alertData.textLocation then
					window.tbTextLocation.setSelected(i)
				end
			end
			if alertData.textInside then
				window.tbTextInside.setSelected(1)
			else
				window.tbTextInside.setSelected(2)
			end
			window.ckTimer:SetChecked(alertData.timer)
			window.ebTimerSize.text:SetText(tostring(alertData.timerSize))
			for i = 1, table.getn(kAlert.config.tLocation), 1 do
				if kAlert.config.tLocation[i] == alertData.timerLocation then
					window.tbTimerLocation.setSelected(i)
				end
			end
			if alertData.timerInside then
				window.tbTimerInside.setSelected(1)
			else
				window.tbTimerInside.setSelected(2)
			end
			window.ebTimerLength.text:SetText(tostring(alertData.timerLength-1))
			window.frScreenObjects.clearSelected()
			window.ebAlertName.text:SetKeyFocus(true)
			window.setStatus(kAlertTexts.statLoaded)
		end
	end
	
	window.btDelete = kUtils.buildButton("btDelete",window,35,100,kAlertTexts.btDelete)
	window.btDelete:SetPoint ("TOPLEFT", window.btEdit, "TOPRIGHT")
	
	function window.btDelete.Event:LeftPress()
		window.setStatus("")
		local alertName = window.frScreenObjects.getSelected()
		if kAlert.alertSet.alerts[alertName] ~= nil then
			kAlert.alertSet.delete(alertName)
			window.frScreenObjects.fillList(kAlert.alertSet.alerts)
			window.btClear.Event:LeftPress()
		end
		kAlert.screenObjects.refresh()
	end
	
	window.btEditLayout = kUtils.buildButton("btEditLayout",window,35,100,kAlertTexts.btEditLayout)
	window.btEditLayout:SetPoint("TOPLEFT", window.btEdit, "BOTTOMLEFT", 50, 0)
	
	function window.btEditLayout.Event:LeftPress()
		window:SetVisible(false)
		kAlert.config.mainFrame.btClear.Event:LeftPress()
		kAlert.config.movers.init()
		for id, details in pairs(kAlert.screenObjects.object) do
			if details.name ~= nill then
				details:SetVisible(true)
				kAlert.config.movers.object[id].setTarget(details)
			end
		end
		if kAlert.config.layoutFrame == nil then
			kAlert.config.buildLayoutFrame()
		else
			kAlert.config.layoutFrame:SetVisible(true)
		end
	end

	-- Alert Info Controls
	window.ebAlertName = kUtils.buildEditBox("ebAlertName",window,20,200,kAlertTexts.ebAlertName .. ":")
	window.ebAlertName:SetPoint("TOPLEFT", window.btASRight, "TOPRIGHT", 10, 0)

	window.ebAlertLayer = kUtils.buildEditBox("ebAlertLayer",window,20,100,kAlertTexts.ebScreenLayer .. ":")
	window.ebAlertLayer:SetPoint ("TOPLEFT", window.ebAlertName, "TOPRIGHT", 10, 0)
	function window.ebAlertLayer.text.Event:KeyUp()
		local layer = tonumber(window.ebAlertLayer.text:GetText())
		if layer ~= nil then
			if layer < 1 then window.ebAlertLayer.text:SetText("1") end
			if layer > 40 then window.ebAlertLayer.text:SetText("40") end
		end
	end

	window.ckDisableAlert = kUtils.buildCheckBox("ckDisableAlert",window,20,180,kAlertTexts.ckDisableAlert)
	window.ckDisableAlert:SetPoint ("TOPLEFT", window.ebAlertLayer, "TOPRIGHT", 10, 0)
	
	-- Trigger Info
	window.tbAlertTypes = kUtils.buildToggleBox("tbAlertTypes",window, 20, 200, kAlert.config.evaluationTypes)
	window.tbAlertTypes:SetPoint("TOPLEFT", window.ebAlertName, "BOTTOMLEFT", 0, 5)
	function window.tbAlertTypes.change()
		local checkType = window.tbAlertTypes.getSelected()
		if checkType == 1 then
			window.ebAlertItem:SetVisible(true)
			window.ebAlertItem.label:SetText(kAlertTexts.buff .. ":")
			window.tbResourceTypes:SetVisible(false)
			window.ebBuffLength:SetVisible(true)
			window.ckSelfCast:SetVisible(true)
			window.tbUnit:SetVisible(true)
			window.tbUnit:SetPoint("TOPLEFT", window.ckSelfCast, "BOTTOMLEFT", 0, 5)
			window.tbAlertToggle:SetVisible(true)
			window.tbAlertToggle.setOptions({kAlertTexts.tbAlertToggleActive,kAlertTexts.tbAlertToggleMissing})
			window.tbAlertToggle:SetPoint("TOPLEFT", window.tbRelation, "BOTTOMLEFT", 0, 5)
			window.tbResourceToggle:SetVisible(false)
			window.ebValue:SetVisible(true)
			window.ebValue.label:SetText(kAlertTexts.ebStacks .. ":")
			window.ebValue:SetPoint("TOPLEFT", window.tbAlertToggle, "BOTTOMLEFT", 0, 5)
			window.ckCombatOnly:SetPoint("TOPLEFT", window.ebValue, "BOTTOMLEFT", 0, 5)
			window.ckTimer:SetVisible(true)
		elseif checkType == 2 then
			window.ebAlertItem:SetVisible(true)
			window.ebAlertItem.label:SetText(kAlertTexts.ability .. ":")
			window.tbResourceTypes:SetVisible(false)
			window.ebBuffLength:SetVisible(false)
			window.ckSelfCast:SetVisible(false)
			window.tbUnit:SetVisible(false)
			window.tbUnit.setSelected(1)
			window.tbRelation.setSelected(0)
			window.tbAlertToggle:SetVisible(true)
			window.tbAlertToggle.setOptions({kAlertTexts.tbAlertToggleReady,kAlertTexts.tbAlertToggleCooldown})
			window.tbAlertToggle:SetPoint("TOPLEFT", window.ebAlertItem, "BOTTOMLEFT", 0, 5)
			window.tbResourceToggle:SetVisible(false)
			window.ebValue:SetVisible(false)
			window.ckCombatOnly:SetPoint("TOPLEFT", window.tbAlertToggle, "BOTTOMLEFT", 0, 5)
			window.ckTimer:SetVisible(true)
		elseif checkType == 3 then
			window.ebAlertItem:SetVisible(false)
			window.tbResourceTypes:SetVisible(true)
			window.ebBuffLength:SetVisible(false)
			window.ckSelfCast:SetVisible(false)
			window.tbUnit:SetVisible(true)
			window.tbUnit:SetPoint("TOPLEFT", window.tbResourceTypes, "BOTTOMLEFT", 0, 5)
			window.tbAlertToggle:SetVisible(false)
			window.tbResourceToggle:SetVisible(true)
			window.tbResourceToggle:SetPoint("TOPLEFT", window.tbRelation, "BOTTOMLEFT", 0, 5)
			window.ebValue:SetVisible(true)
			window.ebValue.label:SetText(kAlertTexts.ebValue .. ":")
			window.ebValue:SetPoint("TOPLEFT", window.tbResourceToggle, "BOTTOMLEFT", 0, 5)
			window.ckCombatOnly:SetPoint("TOPLEFT", window.ebValue, "BOTTOMLEFT", 0, 5)
			window.ckTimer:SetVisible(false)
			window.ckTimer:SetChecked(false)
		elseif checkType == 4 then
			window.ebAlertItem:SetVisible(true)
			window.ebAlertItem.label:SetText(kAlertTexts.ability .. ":")
			window.tbResourceTypes:SetVisible(false)
			window.ebBuffLength:SetVisible(false)
			window.ckSelfCast:SetVisible(false)
			window.tbUnit:SetVisible(true)
			window.tbUnit:SetPoint("TOPLEFT", window.ebAlertItem, "BOTTOMLEFT", 0, 5)
			window.tbAlertToggle:SetVisible(false)
			window.tbResourceToggle:SetVisible(false)
			window.ebValue:SetVisible(false)
			window.ckCombatOnly:SetPoint("TOPLEFT", window.tbRelation, "BOTTOMLEFT", 0, 5)
			window.ckTimer:SetVisible(false)
			window.ckTimer:SetChecked(false)
		end
		window.tbAlertToggle.change()
	end

	window.ebAlertItem = kUtils.buildEditBox("ebAlertItem",window,20,200,kAlertTexts.ability .. ":")
	window.ebAlertItem:SetPoint("TOPLEFT", window.tbAlertTypes, "BOTTOMLEFT", 0, 5)
	function window.ebAlertItem.text.Event:KeyFocusLoss()
		window.frItemDrop:SetVisible(false)
	end
	function window.ebAlertItem.text.Event:KeyUp()
	
		local itemName = window.ebAlertItem.text:GetText()
		if itemName ~= nil and string.len(itemName) > 0 then
			if window.ebAlertItem.label:GetText() == kAlertTexts.buff .. ":" then
				local pos = string.find(string.reverse(itemName),",")
				if pos ~= nil then itemName = string.sub(itemName,2+string.len(itemName)-pos) end
			end
			if string.len(itemName) > 0 then
				window.frItemDrop:SetVisible((window.frItemDrop.fillListSubSet(kAlertGlobalItems,itemName) > 0))
			end
		else
			window.frItemDrop:SetVisible(false)
		end
		itemName = kUtils.split(",",window.ebAlertItem.text:GetText())[1]
		if kAlertGlobalItems[itemName] ~= nil then
			window.ebImage.setDefault(kAlertGlobalItems[itemName].icon)
		else
			window.ebImage.clear()
		end

	end
	window.frItemDrop = kUtils.buildListPane("frItemDrop",window, 200,200,10)
	window.frItemDrop:SetPoint("TOPRIGHT", window.ebAlertItem.text, "BOTTOMRIGHT", 0, 0)
	window.frItemDrop:SetBackgroundColor(0, 0, 0, 1)
	window.frItemDrop:SetLayer(2)
	window.frItemDrop:SetVisible(false)
	
	function window.frItemDrop.click(button)
	
		if window.frItemDrop.lastSelected == window.frItemDrop.getSelected() and window.frItemDrop.lastSelectedTime == math.floor(Inspect.Time.Real()) then
			local itemPre = ""
			if window.ebAlertItem.label:GetText() == kAlertTexts.buff .. ":" then
				local itemName = window.ebAlertItem.text:GetText()
				if itemName ~= nil and string.len(itemName) > 0 then
					local pos = string.find(string.reverse(itemName),",")
					if pos ~= nil then itemPre = string.sub(itemName,1,string.len(itemName)-pos) .. "," end
				end
			end
			window.ebAlertItem.text:SetText(itemPre .. window.frItemDrop.getSelected())
			window.ebAlertItem.text.Event:KeyUp()
			window.ebAlertItem.text:SetCursor(string.len(window.ebAlertItem.text:GetText()))
			window.frItemDrop:SetVisible(false)
		else
			window.frItemDrop.lastSelected = window.frItemDrop.getSelected()
		end
		
		window.frItemDrop.lastSelectedTime = math.floor(Inspect.Time.Real())
		
	end

	window.tbResourceTypes = kUtils.buildToggleBox("tbResourceTypes",window, 20, 200, kAlert.config.recources)
	window.tbResourceTypes:SetPoint("TOPLEFT", window.tbAlertTypes, "BOTTOMLEFT", 0, 5)

	window.ebBuffLength = kUtils.buildEditBox("ebBuffLength",window,20,200,kAlertTexts.buff .. " " .. kAlertTexts.ebTimerLength .. ":")
	window.ebBuffLength:SetPoint("TOPLEFT", window.ebAlertItem, "BOTTOMLEFT", 0, 5)
	window.ebBuffLength.text:SetText("")
	
	window.ckSelfCast = kUtils.buildCheckBox("ckSelfCast",window, 20, 200, kAlertTexts.ckSelfCast)
	window.ckSelfCast:SetPoint("TOPLEFT", window.ebBuffLength, "BOTTOMLEFT", 0, 5)

	-- Trigger Condition
	window.tbUnit = kUtils.buildToggleBox("tbUnit",window, 20, 100, kAlert.config.units,2)
	window.tbUnit:SetPoint("TOPLEFT", window.ckSelfCast, "BOTTOMLEFT", 0, 5)
	
	window.tbRelation = kUtils.buildToggleBox("tbRelation",window.tbUnit, 20, 100, {kAlertTexts.ckFriend,kAlertTexts.ckFoe},2,true)
	window.tbRelation:SetPoint("TOPLEFT", window.tbUnit, "BOTTOMLEFT", 0, 5)
	
	window.tbAlertToggle = kUtils.buildToggleBox("tbAlertToggle",window, 20, 100, {kAlertTexts.tbAlertToggleAbove,kAlertTexts.tbAlertToggleBelow},2)
	window.tbAlertToggle:SetPoint("TOPLEFT", window.tbRelation, "BOTTOMLEFT", 0, 5)
	function window.tbAlertToggle.change()
		local checkType = window.tbAlertTypes.getSelected()
		local toggleType = window.tbAlertToggle.getSelected()
		if checkType == toggleType then
			window.ckTimer.label:SetText(kAlertTexts.ckTimerTimer)
			window.ebTimerLength:SetVisible(false)
		else
			window.ckTimer.label:SetText(kAlertTexts.ckTimerWarning)
			window.ebTimerLength:SetVisible(true)
		end
	end

	window.tbResourceToggle = kUtils.buildToggleBox("tbResourceToggle",window, 20, 100, {kAlertTexts.tbAlertToggleAbove,kAlertTexts.tbAlertToggleBelow,kAlertTexts.tbAlertToggleRange},2)
	window.tbResourceToggle:SetPoint("TOPLEFT", window.tbUnit, "BOTTOMLEFT", 0, 5)
	window.tbResourceToggle:SetVisible(false)

	window.ebValue = kUtils.buildEditBox("ebValue",window,20,200,kAlertTexts.ebStacks .. ":")
	window.ebValue:SetPoint("TOPLEFT", window.tbResourceToggle, "BOTTOMLEFT", 0, 5)
	
	window.ckCombatOnly = kUtils.buildCheckBox("ckCombatOnly",window, 20, 200, kAlertTexts.ckCombatOnly)
	window.ckCombatOnly:SetPoint("TOPLEFT", window.ebValue, "BOTTOMLEFT", 0, 5)
	
	-- Display Controls
	-- Display Image
	window.ebImage = kUtils.buildImageBox("ebImage", window, 200, 200, "kAlert", "images\\Aura-1.tga")
	window.ebImage:SetPoint("TOPLEFT", window.tbAlertTypes, "TOPRIGHT", 10, 0)
	window.ebImage:SetLayer(-1)
	window.ebImage.count = 75
	function window.ebImage.clear()
		window.ebImage.index = 1
		window.ebImage.defSorce = nil
		window.ebImage.defImage = nil
		window.ckDefaultImage:SetVisible(false)
		window.ckDefaultImage:SetChecked(false)
		window.btImageBack:SetVisible(false)
		window.ebImage.setImage("kAlert", "images\\Aura-1.tga")
	end
	
	function window.ebImage.setDefault(image)
		window.ebImage.defSorce = "Rift"
		window.ebImage.defImage = image
		if window.ebImage.index <= 1 then
			window.ebImage.index = 0
			window.ebImage.setImage("Rift", image)
			window.ckDefaultImage:SetChecked(true)
		end
		window.ckDefaultImage:SetVisible(true)
	end

	window.ckDefaultImage = kUtils.buildCheckBox("ckDefaultImage",window, 20, 195, kAlertTexts.ckUseDefaultImage)
	window.ckDefaultImage:SetPoint("TOPLEFT", window.ebImage, "TOPLEFT", 5, 2)
	window.ckDefaultImage.label:SetBackgroundColor(0, 0, 0, 0.5)
	window.ckDefaultImage:SetVisible(false)

	function window.ckDefaultImage.Event:CheckboxChange()
		if window.ckDefaultImage:GetChecked() then
			window.btImageBack:SetVisible(false)
			window.btImageNext:SetVisible(false)
			window.ebImage.index = 0
			window.ebImage.setImage(window.ebImage.defSorce, window.ebImage.defImage)
		else
			window.btImageBack:SetVisible(false)
			window.btImageNext:SetVisible(true)
			window.ebImage.index = 1
			window.ebImage.setImage("kAlert", "images\\Aura-1.tga")
		end
	end
	
	window.btImageBack = kUtils.buildLabel("btImageBack",window,35,30,"<")
	window.btImageBack:SetBackgroundColor(0, 0, 0, 0.5)
	window.btImageBack:SetPoint ("LEFTCENTER", window.ebImage, "LEFTCENTER",1,0)
	function window.btImageBack.Event:LeftClick()
	
		if window.ebImage.index > 1 then
			window.ebImage.index = window.ebImage.index - 1
			window.ebImage.setImage("kAlert", "images\\Aura-" .. tostring(window.ebImage.index) .. ".tga")
			if window.ebImage.index == 1 and window.ebImage.index < window.ebImage.count then
				window.btImageBack:SetVisible(false)
			end
			window.btImageNext:SetVisible(true)
		end
		
			
	end

	window.btImageNext = kUtils.buildLabel("btImageNext",window,35,30,">")
	window.btImageNext:SetBackgroundColor(0, 0, 0, 0.5)
	window.btImageNext:SetPoint ("RIGHTCENTER", window.ebImage, "RIGHTCENTER",-1,0)
	
	function window.btImageNext.Event:LeftClick()
	
		if window.ebImage.index < window.ebImage.count then
			window.ebImage.index = window.ebImage.index + 1
			window.ebImage.setImage("kAlert", "images\\Aura-" .. tostring(window.ebImage.index) .. ".tga")
			if window.ebImage.index == window.ebImage.count and window.ebImage.index > 1 then
				window.btImageNext:SetVisible(false)
			end
			window.btImageBack:SetVisible(true)
		end
		
			
	end
	
	window.ebCustomImage = kUtils.buildEditBox("ebCustomImage",window,20,200,kAlertTexts.ebCustomImage .. ":")
	window.ebCustomImage:SetPoint("TOPLEFT", window.ebImage, "BOTTOMLEFT", 0, 5)
	function window.ebCustomImage.text.Event:KeyUp()
		
		if string.len(window.ebCustomImage.text:GetText()) > 0 then
			window.btImageBack:SetVisible(false)
			window.btImageNext:SetVisible(false)
			window.ebImage.setImage("kAlert", "custom\\" .. window.ebCustomImage.text:GetText())
		else
			window.btImageBack:SetVisible(true)
			window.btImageNext:SetVisible(true)
			if window.ebImage.index == 0 then
				if window.ebImage.defSorce ~= nil then
					window.ebImage.setImage(window.ebImage.defSorce, window.ebImage.defImage)
				else
					window.ebImage.index = 1
					window.ebImage.setImage("kAlert", "images\\Aura-1.tga")
				end
			else
				window.ebImage.setImage("kAlert", "images\\Aura-" .. tostring(window.ebImage.index) .. ".tga")
			end
		end

	end	
	
	window.ebImageX = kUtils.buildEditBox("ebImageX",window,20,95,kAlertTexts.ebImageX .. ":")
	window.ebImageX:SetPoint("TOPLEFT", window.ebCustomImage, "BOTTOMLEFT", 0, 5)
	
	window.ebImageY = kUtils.buildEditBox("ebImageY",window,20,95,kAlertTexts.ebImageY .. ":")
	window.ebImageY:SetPoint("TOPLEFT", window.ebImageX, "TOPRIGHT", 10, 0)

	window.ebImageScale = kUtils.buildEditBox("ebImageScale",window,20,95,kAlertTexts.ebImageScale .. ":")
	window.ebImageScale:SetPoint("TOPLEFT", window.ebImageX, "BOTTOMLEFT", 0, 5)

	window.ebImageOpacity = kUtils.buildEditBox("ebImageOpacity",window,20,95,kAlertTexts.ebOpacity .. ":")
	window.ebImageOpacity:SetPoint("TOPLEFT", window.ebImageScale, "TOPRIGHT", 10, 0)
	function window.ebImageOpacity.text.Event:KeyUp()
		local opacity = tonumber(window.ebImageOpacity.text:GetText())
		if opacity ~= nil then
			opacity = math.floor(opacity)
			opacity = math.max(0,opacity)
			opacity = math.min(100,opacity)
			window.ebImageOpacity.text:SetText(tostring(opacity))
		end
	end

	-- Display Text
	window.ebText = kUtils.buildEditBox("ebText",window,20,200,kAlertTexts.ebText .. ":")
	window.ebText:SetPoint("TOPLEFT", window.ebImage, "TOPRIGHT", 10, 0)

	window.ebTextOpacity = kUtils.buildEditBox("ebTextOpacity",window.ebText,20,90,kAlertTexts.ebOpacity .. ":")
	window.ebTextOpacity:SetPoint("TOPLEFT", window.ebText, "BOTTOMLEFT", 0, 5)
	function window.ebTextOpacity.text.Event:KeyUp()
		local opacity = tonumber(window.ebTextOpacity.text:GetText())
		if opacity ~= nil then
			opacity = math.floor(opacity)
			opacity = math.max(0,opacity)
			opacity = math.min(100,opacity)
			window.ebTextOpacity.text:SetText(tostring(opacity))
		end
	end

	window.ebTextSize = kUtils.buildEditBox("ebTextSize",window.ebText,20,90,kAlertTexts.ebSize .. ":")
	window.ebTextSize:SetPoint("TOPLEFT", window.ebTextOpacity, "BOTTOMLEFT", 0, 5)
	window.ebTextSize.text:SetText("30")

	window.tbTextInside = kUtils.buildToggleBox("tbTextInside",window.ebTextSize, 20, 90, {kAlertTexts.tbInsideInside,kAlertTexts.tbInsideOutside})
	window.tbTextInside:SetPoint("TOPLEFT", window.ebTextSize, "BOTTOMLEFT", 0, 5)

	window.tbTextLocation = kUtils.buildToggleBox("tbTextLocation",window.ebTextSize, 20, 100, {kAlertTexts.tbLocationCenter,kAlertTexts.tbLocationTop,kAlertTexts.tbLocationBottom,kAlertTexts.tbLocationLeft,kAlertTexts.tbLocationRight})
	window.tbTextLocation:SetPoint("TOPLEFT", window.ebTextOpacity, "TOPRIGHT", 10, 0)

	window.ebTextFont = kUtils.buildEditBox("ebTextFont",window.ebText, 20, 200, kAlertTexts.ebTextFont .. ":")
	window.ebTextFont:SetPoint("TOPLEFT", window.tbTextInside, "BOTTOMLEFT", 0, 15)
	
	-- Display Color
	window.txtColor = kUtils.buildLabel("txtColor", window,15,50,kAlertTexts.lblColor .. ":")
	window.txtColor:SetPoint("TOPLEFT", window.ebTextFont, "BOTTOMLEFT", 0, 5)

	window.frColor = kUtils.buildFrame("frColor", window, 20, 140)
	window.frColor:SetPoint("TOPLEFT", window.txtColor, "TOPRIGHT", 10, 0)
	function window.frColor.setColor()
		local red = tonumber(window.ebRed.text:GetText())
		if red ~= nil then
			red = math.floor(red)
			red = math.max(0,red)
			red = math.min(100,red)
			window.ebRed.text:SetText(tostring(red))
		end
		local green = tonumber(window.ebGreen.text:GetText())
		if green ~= nil then
			green = math.floor(green)
			green = math.max(0,green)
			green = math.min(100,green)
			window.ebGreen.text:SetText(tostring(green))
		end
		local blue = tonumber(window.ebBlue.text:GetText())
		if blue ~= nil then
			blue = math.floor(blue)
			blue = math.max(0,blue)
			blue = math.min(100,blue)
			window.ebBlue.text:SetText(tostring(blue))
		end
		if red ~= nil and green ~= nil and blue ~= nil then
			window.frColor:SetBackgroundColor(red/100,green/100,blue/100,1)
		end
	end

	window.ebRed = kUtils.buildEditBox("ebRed",window,20,50,kAlertTexts.ebRed .. ":")
	window.ebRed.text:SetText("100")
	window.ebRed:SetPoint("TOPLEFT", window.txtColor, "BOTTOMLEFT", 0, 5)
	function window.ebRed.text.Event:KeyUp()
		window.frColor.setColor()
		window.slRed:SetPosition(tonumber(window.ebRed.text:GetText()))
	end
	
	window.slRed = kUtils.buildSlider("slRed",window.ebRed,20,140,0,100)
	window.slRed:SetPoint("CENTERLEFT", window.ebRed, "CENTERRIGHT", 10, 5)
	function window.slRed.Event:MouseMove()
		window.slRed:SetPosition(tonumber(window.ebRed.text:GetText()))
	end
	function window.slRed.Event:SliderChange()
		window.ebRed.text:SetText(tostring(window.slRed:GetPosition()))
		window.frColor.setColor()
	end

	window.ebGreen = kUtils.buildEditBox("ebGreen",window,20,50,kAlertTexts.ebGreen .. ":")
	window.ebGreen.text:SetText("100")
	window.ebGreen:SetPoint("TOPLEFT", window.ebRed, "BOTTOMLEFT", 0, 5)
	function window.ebGreen.text.Event:KeyUp()
		window.frColor.setColor()
	end
	
	window.slGreen = kUtils.buildSlider("slGreen",window.ebGreen,20,140,0,100)
	window.slGreen:SetPoint("CENTERLEFT", window.ebGreen, "CENTERRIGHT", 10, 5)
	function window.slGreen.Event:MouseMove()
		window.slGreen:SetPosition(tonumber(window.ebGreen.text:GetText()))
	end
	function window.slGreen.Event:SliderChange()
		window.ebGreen.text:SetText(tostring(window.slGreen:GetPosition()))
		window.frColor.setColor()
	end

	window.ebBlue = kUtils.buildEditBox("ebBlue",window,20,50,kAlertTexts.ebBlue .. ":")
	window.ebBlue.text:SetText("100")
	window.ebBlue:SetPoint("TOPLEFT", window.ebGreen, "BOTTOMLEFT", 0, 5)
	function window.ebBlue.text.Event:KeyUp()
		window.frColor.setColor()
	end
	
	window.slBlue = kUtils.buildSlider("slBlue",window.ebBlue,20,140,0,100)
	window.slBlue:SetPoint("CENTERLEFT", window.ebBlue, "CENTERRIGHT", 10, 5)
	function window.slBlue.Event:MouseMove()
		window.slBlue:SetPosition(tonumber(window.ebBlue.text:GetText()))
	end
	function window.slBlue.Event:SliderChange()
		window.ebBlue.text:SetText(tostring(window.slBlue:GetPosition()))
		window.frColor.setColor()
	end
	
	window.frColor.setColor()
	
	-- Display Timer
	window.ckTimer = kUtils.buildCheckBox("ckTimer",window.ebAlertItem, 20, 90, kAlertTexts.ckTimerTimer)
	window.ckTimer:SetPoint("TOPLEFT", window.ebBlue, "BOTTOMLEFT", 0, 10)
	
	function window.ckTimer.Event:CheckboxChange()
		window.ebTimerSize:SetVisible(window.ckTimer:GetChecked())
	end

	window.ebTimerSize = kUtils.buildEditBox("ebTimerSize",window.ebAlertItem,20,90,kAlertTexts.ebSize .. ":")
	window.ebTimerSize:SetPoint("TOPLEFT", window.ckTimer, "BOTTOMLEFT", 0, 5)
	window.ebTimerSize.text:SetText("30")
	window.ebTimerSize:SetVisible(false)

	window.tbTimerInside = kUtils.buildToggleBox("tbTimerInside",window.ebTimerSize, 20, 90, {kAlertTexts.tbInsideInside,kAlertTexts.tbInsideOutside})
	window.tbTimerInside:SetPoint("TOPLEFT", window.ebTimerSize, "BOTTOMLEFT", 0, 5)

	window.tbTimerLocation = kUtils.buildToggleBox("tbTimerLocation",window.ebTimerSize, 20, 100, {kAlertTexts.tbLocationCenter,kAlertTexts.tbLocationTop,kAlertTexts.tbLocationBottom,kAlertTexts.tbLocationLeft,kAlertTexts.tbLocationRight})
	window.tbTimerLocation:SetPoint("TOPLEFT", window.ckTimer.label, "TOPRIGHT", 10, 0)

	window.ebTimerLength = kUtils.buildEditBox("ebTimerLength",window.ebTimerSize,20,90,kAlertTexts.ebTimerLength .. ":")
	window.ebTimerLength:SetPoint("TOPLEFT", window.tbTimerInside, "BOTTOMLEFT", 0, 5)
	window.ebTimerLength.text:SetText("5")
	
	-- Display Base
	window.btSave = kUtils.buildButton("btSave",window,35,100,kAlertTexts.btSave)
	window.btSave:SetPoint ("BOTTOMLEFT", window.btDelete, "BOTTOMRIGHT", 440, 10)

	function window.btSave.Event:LeftPress()
		window.setStatus("")
		
		local alertData = {}
		alertData.name = window.ebAlertName.text:GetText()
		if tonumber(window.ebAlertLayer.text:GetText()) ~= nil then
			alertData.layer = tonumber(window.ebAlertLayer.text:GetText())
		else
			alertData.layer = 1
		end
		alertData.unit = kAlert.units[window.tbUnit.getSelected()]
		alertData.unitRelation = window.tbRelation.getSelected()
		local tValue = window.ebValue.text:GetText()
		alertData.itemValuePercent = (string.sub(tValue,string.len(tValue)) == "%")
		if alertData.itemValuePercent then
			tValue = string.sub(tValue,0,string.len(tValue)-1)
		end
		alertData.itemValue = tonumber(string.match(tValue,"(%d+)"))
		alertData.type = window.tbAlertTypes.getSelected()
		if alertData.type == 3 then
			alertData.typeToggle = (window.tbResourceToggle.getSelected() == 1)
			alertData.range = (window.tbResourceToggle.getSelected() == 3)
			if alertData.range then
				if string.find(tValue,"-") then
					local rangeLow, rangeHigh = string.match(tValue,"(%d+)-(%d+)")
					alertData.rangeLow = tonumber(rangeLow)
					alertData.rangeHigh = tonumber(rangeHigh)
				else
					alertData.rangeLow = tonumber(tValue)
					alertData.rangeHigh = tonumber(tValue)
				end
			end
		else
			alertData.typeToggle = (window.tbAlertToggle.getSelected() == 1)
		end
		if alertData.itemValue == nil then alertData.itemValue = 1 end
		if alertData.rangeLow == nil then alertData.rangeLow = 0 end
		if alertData.rangeHigh == nil then alertData.rangeHigh = 0 end
		alertData.itemId = nil
		alertData.itemName = window.ebAlertItem.text:GetText()
		alertData.selfCast = window.ckSelfCast:GetChecked()
		if tonumber(window.ebBuffLength.text:GetText()) then
			alertData.itemLength = tonumber(window.ebBuffLength.text:GetText())
		else
			alertData.itemLength = 0
		end
		alertData.active = not window.ckDisableAlert:GetChecked()
		alertData.combatOnly = window.ckCombatOnly:GetChecked()
		alertData.image = window.ebImage.image
		alertData.imageSource = window.ebImage.source
		alertData.imageX = tonumber(window.ebImageX.text:GetText())
		alertData.imageY = tonumber(window.ebImageY.text:GetText())
		alertData.imageScale = tonumber(window.ebImageScale.text:GetText())
		alertData.imageWidth = window.ebImage:GetTextureWidth() * alertData.imageScale
		alertData.imageHeight = window.ebImage:GetTextureHeight() * alertData.imageScale
		alertData.imageOpacity = tonumber(window.ebImageOpacity.text:GetText())/100
		alertData.text = window.ebText.text:GetText()
		alertData.textOpacity = tonumber(window.ebTextOpacity.text:GetText())/100
		if string.len(window.ebTextFont.text:GetText()) > 0 then
			alertData.textFont = "custom\\" .. window.ebTextFont.text:GetText()
		else
			alertData.textFont = ""
		end
		alertData.textRed = tonumber(window.ebRed.text:GetText())/100
		alertData.textGreen = tonumber(window.ebGreen.text:GetText())/100
		alertData.textBlue = tonumber(window.ebBlue.text:GetText())/100
		alertData.textSize = tonumber(window.ebTextSize.text:GetText())
		alertData.textLocation = kAlert.config.tLocation[window.tbTextLocation.getSelected()]
		alertData.textInside = (window.tbTextInside.getSelected() == 1)
		alertData.timer = window.ckTimer:GetChecked()
		alertData.timerLength = tonumber(window.ebTimerLength.text:GetText())+1
		alertData.timerSize = tonumber(window.ebTimerSize.text:GetText())
		alertData.timerLocation = kAlert.config.tLocation[window.tbTimerLocation.getSelected()]
		alertData.timerInside = (window.tbTimerInside.getSelected() == 1)
		alertData.sound = false
		alertData.set = kAlertSet
		
		local alertAddStatus = kAlertTexts.statAlertNameMissing
		local addAlert = false
		if not window.frScreenObjects.full() then
			if string.len(alertData.name) > 0 then
				if window.tbAlertTypes.getSelected() == 4 then
					addAlert = true
				elseif window.tbAlertTypes.getSelected() == 3 then
					alertData.itemId = window.tbResourceTypes.getSelected()
					alertData.itemName = kAlert.config.recources[alertData.itemId]
					addAlert = true
				elseif window.tbAlertTypes.getSelected() == 1 then
					alertAddStatus = kAlertTexts.statItemNotFound
					for id, itemName in pairs(kUtils.split(",",alertData.itemName)) do
						local itemDetails = kAlertGlobalItems[itemName]
						if itemDetails ~= nil then
							if itemDetails.ability ~= nil then
								alertData.itemId = itemDetails.ability
							else
								alertData.itemId = "none"
							end
							addAlert = true
						end
					end
				else
					alertAddStatus = kAlertTexts.statItemNotFound
					local itemDetails = kAlertGlobalItems[alertData.itemName]
					if itemDetails ~= nil then
						if itemDetails.ability ~= nil then
							alertData.itemId = itemDetails.ability
						else
							alertData.itemId = "none"
						end
						addAlert = true
					end
				end
				if addAlert then
					if kAlert.alertSet.alerts[alertData.name] == nil then
						alertAddStatus = kAlertTexts.statAlertAdded
					else
						alertAddStatus = kAlertTexts.statAlertUpdated
					end
					kAlert.alertSet.add(alertData)
					kAlert.screenObjects.refresh()
					window.btClear.Event:LeftPress()
				end
			end
		end
		--dump(alertData)
		window.frScreenObjects.fillList(kAlert.alertSet.alerts)
		kAlert.screenObjects.hide()
		window.setStatus(alertAddStatus)
	end

	window.btClear = kUtils.buildButton("btClear",window,35,100,kAlertTexts.btClear)
	window.btClear:SetPoint ("TOPLEFT", window.btSave, "TOPRIGHT")
	
	function window.btClear.Event:LeftPress()
		window.setStatus("")
		window.ebAlertName.text:SetText("")
		window.ebAlertLayer.text:SetText("1")
		window.tbUnit.setSelected(1)
		window.tbAlertTypes.setSelected(1)
		window.tbAlertToggle.setSelected(1)
		window.tbResourceToggle.setSelected(1)
		window.tbResourceTypes.setSelected(1)
		window.ebAlertItem.text:SetText("")
		window.ebValue.text:SetText("")
		window.ckSelfCast:SetChecked(false)
		window.ebBuffLength.text:SetText("")
		window.ebImage.clear()
		window.ebCustomImage.text:SetText("")
		window.ebImageX.text:SetText("0")
		window.ebImageY.text:SetText("0")
		window.ebImageScale.text:SetText("1")
		window.ebImageOpacity.text:SetText("100")
		window.ebText.text:SetText("")
		window.ebTextOpacity.text:SetText("100")
		window.ebTextFont.text:SetText("")
		window.slRed:SetPosition(100)
		window.slGreen:SetPosition(100)
		window.slBlue:SetPosition(100)
		window.ebRed.text:SetText("100")
		window.ebGreen.text:SetText("100")
		window.ebBlue.text:SetText("100")
		window.frColor.setColor()
		window.ebTextSize.text:SetText("30")
		window.tbTextLocation.setSelected(1)
		window.tbTextInside.setSelected(1)
		window.ckTimer:SetChecked(false)
		window.ebTimerSize.text:SetText("30")
		window.tbTimerLocation.setSelected(1)
		window.tbTimerInside.setSelected(1)
		window.ebTimerLength.text:SetText("5")
		window.tbAlertTypes.change()
		window.frScreenObjects.clearSelected()
		window.ckDisableAlert:SetChecked(false)
		window.ckCombatOnly:SetChecked(false)
		window.tbRelation.setSelected(0)
		window.ebAlertName.text:SetKeyFocus(true)
	end
	
	-- System Elements
	window.btClose = kUtils.buildButton("btClose",window,35,100,kAlertTexts.btClose,"close")
	window.btClose:SetPoint ("TOPRIGHT", window, "TOPRIGHT", -9, 16)
	
	function window.btClose.Event:LeftPress()
		window.setStatus("")
		window:SetVisible(false)
		kAlert.changeHandler.changeOccured = true
		window.btClear.Event:LeftPress()
		kAlert.config.active = false
		if kAlertSet > 5 then
			kAlertSubSet = kAlertSet - 5
			kAlertSet = kAlert.config.set
		else
			kAlertSubSet = kAlert.config.subSet
		end
		kAlert.screenObjects.refresh()
		window.ebAlertName.text:SetKeyFocus(false)
	end

	window.ckScanBuffs = kUtils.buildCheckBox("ckScanBuffs",window,20,180,kAlertTexts.ckScanBuffs,true)
	window.ckScanBuffs:SetPoint ("BOTTOMRIGHT", window, "BOTTOMRIGHT", -30, -20)
	
	function window.ckScanBuffs.Event:CheckboxChange()
		kAlert.systemScanner.scan()
		kAlert.systemScanner.activeScanning = window.ckScanBuffs:GetChecked()
	end

	-- Satus Output
	window.txtStatus = kUtils.buildLabel("txtStatus", window, 15, 410, "")
	window.txtStatus:SetPoint("TOPLEFT", window.btDelete, "TOPRIGHT", 10, 5)

	function window.setStatus(message)
		window.txtStatus:SetText(message)
		--if string.len(message) > 0 then print(message) end
	end

	window:SetVisible(true)

	kAlert.config.mainFrame = window
	
end

function kAlert.config.movers.init()

	if kAlert.config.movers.object == nil then
		kAlert.config.movers.object = {}
		for i = 1, kAlert.screenObjects.max, 1 do
			kAlert.config.movers.object[i] = kAlert.config.movers.addObject(i)
		end
	end
	
end

function kAlert.config.movers.addObject(id)

	local iID = tostring(id)
	local object = UI.CreateFrame("Frame", "objectMoverFrame" .. iID, kAlert.context)
	object:SetWidth(75)
	object:SetHeight(75)
	object:SetPoint ("TOPLEFT", kAlert.context, "TOPLEFT")
	object:SetVisible(false)
	object:SetBackgroundColor(0, 0, 0, 0.5)
	object.movable = true
	object.target = nil
	
	function object.clearTarget()
		object.target = nil
		object:SetVisible(false)
	end
	
	function object.setTarget(target)
		object.movable = true
		object.target = target
		object:SetVisible(true)
		object:SetWidth(target:GetWidth())
		object:SetHeight(target:GetHeight())
		object:SetPoint("TOPLEFT", target, "TOPLEFT")
	end
	
	function object.Event:LeftDown()
		self.MouseDown = self.movable
		mouseData = Inspect.Mouse()
		self.MyStartX = self:GetLeft()
		self.MyStartY = self:GetTop()
		self.StartX = mouseData.x - self.MyStartX
		self.StartY = mouseData.y - self.MyStartY
	end
	
	function object.Event:MouseMove(mouseX, mouseY)
		if self.MouseDown then
			self:SetPoint("TOPLEFT", UIParent, "TOPLEFT", math.floor(mouseX - self.StartX), math.floor(mouseY - self.StartY))
			if object.target ~= nil then
				object.target:SetPoint("TOPLEFT", UIParent, "TOPLEFT", math.floor(mouseX - self.StartX), math.floor(mouseY - self.StartY))
			end
		end
	end
	
	function object.Event:LeftUp()
		self.MouseDown = false
	end
	
	return object
	
end

function kAlert.config.formatSetExport(set)
	local exportData = ""
	for id, details in pairs (kAlert.alertSet.alerts) do
		if string.len(exportData) == 0  then
			exportData = kAlert.config.formatAlertExport(id)
		else
			exportData = exportData .. "|" .. kAlert.config.formatAlertExport(id)
		end
	end
	return exportData
end

function kAlert.config.formatAlertExport(alert)
	local alertData = kAlert.alertSet.alerts[alert]
	local exportData = ""
	if alertData ~= nil then
		exportData = exportData .. alertData.name .. ";"
		exportData = exportData .. tostring(alertData.layer) .. ";"
		exportData = exportData .. kUtils.booltostring(alertData.active) .. ";"
		exportData = exportData .. alertData.unit .. ";"
		exportData = exportData .. tostring(alertData.type) .. ";"
		exportData = exportData .. kUtils.booltostring(alertData.typeToggle) .. ";"
		exportData = exportData .. kUtils.booltostring(alertData.combatOnly) .. ";"
		exportData = exportData .. kUtils.booltostring(alertData.selfCast) .. ";"
		exportData = exportData .. alertData.itemName .. ";"
		exportData = exportData .. alertData.itemId .. ";"
		exportData = exportData .. tostring(alertData.itemLength) .. ";"
		exportData = exportData .. tostring(alertData.itemValue) .. ";"
		exportData = exportData .. kUtils.booltostring(alertData.itemValuePercent) .. ";"
		exportData = exportData .. kUtils.booltostring(alertData.range) .. ";"
		exportData = exportData .. tostring(alertData.rangeLow) .. ";"
		exportData = exportData .. tostring(alertData.rangeHigh) .. ";"
		exportData = exportData .. alertData.imageSource .. ";"
		exportData = exportData .. alertData.image .. ";"
		exportData = exportData .. tostring(alertData.imageX) .. ";"
		exportData = exportData .. tostring(alertData.imageY) .. ";"
		exportData = exportData .. tostring(alertData.imageHeight) .. ";"
		exportData = exportData .. tostring(alertData.imageWidth) .. ";"
		exportData = exportData .. tostring(alertData.imageScale) .. ";"
		exportData = exportData .. tostring(alertData.imageOpacity) .. ";"
		exportData = exportData .. alertData.text .. ";"
		exportData = exportData .. alertData.textLocation .. ";"
		exportData = exportData .. tostring(alertData.textOpacity) .. ";"
		exportData = exportData .. alertData.textFont .. ";"
		exportData = exportData .. tostring(alertData.textRed) .. ";"
		exportData = exportData .. tostring(alertData.textGreen) .. ";"
		exportData = exportData .. tostring(alertData.textBlue) .. ";"
		exportData = exportData .. tostring(alertData.textSize) .. ";"
		exportData = exportData .. kUtils.booltostring(alertData.textInside) .. ";"
		exportData = exportData .. kUtils.booltostring(alertData.timer) .. ";"
		exportData = exportData .. alertData.timerLocation .. ";"
		exportData = exportData .. tostring(alertData.timerSize) .. ";"
		exportData = exportData .. kUtils.booltostring(alertData.timerInside) .. ";"
		exportData = exportData .. tostring(alertData.timerLength) .. ";"
		exportData = exportData .. kUtils.booltostring(alertData.sound) .. ";"
		exportData = exportData .. tostring(alertData.unitRelation)
	end
	return exportData
end

function kAlert.config.formatSetImport(data,set)
	local importData = kUtils.split("|",data)
	for id, details in pairs(importData) do
		kAlert.alertSet.add(kAlert.config.formatAlertImport(details))
	end
end

function kAlert.config.formatAlertImport(data)
	local importData = kUtils.split(";",data)
	local alertData = {}
	local i = 1
	if importData[i] ~= nil then alertData.name = importData[i] else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.layer = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.active = kUtils.stringtobool(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.unit = importData[i] else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.type = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.typeToggle = kUtils.stringtobool(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.combatOnly = kUtils.stringtobool(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.selfCast = kUtils.stringtobool(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.itemName = importData[i] else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.itemId = importData[i] else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.itemLength = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.itemValue = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.itemValuePercent = kUtils.stringtobool(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.range = kUtils.stringtobool(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.rangeLow = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.rangeHigh = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.imageSource = importData[i] else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.image = importData[i] else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.imageX = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.imageY = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.imageHeight = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.imageWidth = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.imageScale = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.imageOpacity = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.text = importData[i] else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.textLocation = importData[i] else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.textOpacity = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.textFont = importData[i] else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.textRed = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.textGreen = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.textBlue = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.textSize = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.textInside = kUtils.stringtobool(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.timer = kUtils.stringtobool(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.timerLocation = importData[i] else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.timerSize = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.timerInside = kUtils.stringtobool(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.timerLength = tonumber(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.sound = kUtils.stringtobool(importData[i]) else return nil end
	i = i + 1
	if importData[i] ~= nil then alertData.unitRelation = tonumber(importData[i]) else alertData.unitRelation = 0 end
	alertData.set = kAlertSet
	if alertData.type == 1 then
		if alertData.itemName ~= nil and alertData.imageSource == "Rift" then
			local itemName =  kUtils.split(",",alertData.itemName)[1]
			if kAlertGlobalItems[itemName] == nil then
				kAlertGlobalItems[itemName] = {ability = alertData.itemId, name = itemName, icon = alertData.image, update = true}
				print(kAlertTexts.msgNewBuff .. ': ' .. itemName) -- .. '-' .. alertData.ability)
			end
		end
	elseif alertData.type == 2 then
		if alertData.itemName ~= nil and alertData.imageSource == "Rift" then
			if kAlertGlobalItems[alertData.itemName] == nil then
				kAlertGlobalItems[alertData.itemName] = {ability = alertData.itemId, name = alertData.itemName, icon = alertData.image, update = true}
				print(kAlertTexts.msgNewAbility .. ': ' .. alertData.itemName) -- .. '-' .. alertData.ability)
			end
		end
	end
	return alertData
end
