
local ifnil = myUI.global.ifnil
local iif = myUI.global.iif
local nilstr = myUI.string.isempty
local nilstr = myUI.string.nilstr
local notnil = myUI.global.notnil

local debug = {}

debug._enabled = true;
debug._indent = 0;

function debug.setEnabled(enabled)
	debug._enabled = enabled
end

function debug.getEnabled()
	return debug._enabled
end

function debug.toggleEnabled()
	debug._enabled = not debug._enabled
end

function debug.indent(steps)
	steps = ifnil(steps,1)
	steps = iif(steps <= 0, 1, steps)
	
	debug._indent = debug._indent + steps
end

function debug.unindent(steps)
	steps = ifnil(steps,1)
	steps = iif(steps <= 0, 1, steps)
	
	local indent = debug._indent
	indent = indent - steps
	indend = iif(indent < 0, 0, indent)
	
	debug._indent = indent
end

function debug.clearindent()
	debug._indent = 0
end

function debug.write(...)
	if (not debug._enabled) then return end
	
	local msg = ""
	if (debug._indent > 0) then
		msg = string.rep(" ", 4 * debug._indent) .. msg
	end
	
	local n = select ('#', ...)
	for i = 1, n do
		local v = select (i, ...)
		msg = msg .. nilstr(v);
	end
	
	print(msg)
end

function debug.writeif(test, ...)
	if (not debug._enabled) then return end
	
	if (test) then debug.write(...) end
end



myUI.debug = debug;
