local global ={}

function global.iif(test,rtrue,rfalse)
	if (test) then return rtrue; else return rfalse; end
end

function global.ifnil(test,rfalse)
	if (nil == test) then return rfalse; else return test; end
end

function global.isnil(test)
	return (nil == test);
end

function global.notnil(test)
	return (nil ~= test);
end


function global.minmax(value, minimum, maximum)
	if (value < minimum) then
		return minimum
	elseif (value > maximum) then
		return maximum
	else
		return value
	end
end

function global.dump(t, indent, label)
	indent = global.ifnil(indent, "");
	label = indent .. global.ifnil(label, "");
	
	if (t == nil) then
		print(label .. "nil")
	elseif (type(t) == "table") then
		print (label)
		for k, v in pairs(t) do
			global.dump(v, indent .. "    ", tostring(k) .. " = ")
		
		end
	else
		print (label .. tostring(t));
	end

end

function global.shallowCopy(t)
	if (t == nil) then
		return nil
	elseif (type(t) ~= "table") then
		return t
	else
		local r = {}
		
		for k, v in pairs(t) do
			if (type(v) == "table") then
				r[k] = global.shallowCopy(v)
			else
				r[k] = v
			end
		end
	
		return r
	end
end

myUI.global = global