function nkGenie.ExtTabPane:new (name, parent, settings)

	if settings == nil then return nil end
	
	local this = settings
	this.name = name
	this.parent = parent
	
	if this.template ~= nil then
		for k, value in pairs (this.template) do
			if this[k] == nil then this[k] = value end
		end
		this.template = nil
	end	
	
	if this.activePane == nil then this.activePane = 1 end
	if this.fontsize == nil then this.fontsize = 14 end
	
	local element = UI.CreateFrame ('nkExtFrame', name, parent, { width = this.width, height = this.height, anchors = this.anchors })
	element.body = UI.CreateFrame ('nkExtFrame', name .. 'body', element:getElement(), { color = {border = this.color.border, body = this.color.body}, width = this.width, height = (this.height-(this.fontsize * 2 + 1)), anchors = {{from = "BOTTOMLEFT", object = element:getElement(), to ="BOTTOMLEFT"}}})	

	local lastObject = element:getElement()
	local lastObjectTo = "TOPLEFT"
	local index = 1
	
	this.header = {}
	
	for k, pane in pairs(this.panes) do	
	
		local layer = 1
		if settings.contentLayer ~= nil then layer = settings.contentLayer end
		
		pane.content:update ({ visible = false, layer = layer })
		local thisName = name .. 'header' .. k
		local header = UI.CreateFrame ('nkExtFrame', thisName, element.body:getElement(true), { color = {border = this.color.border, body = this.color.inactive}, width = 150, height = this.fontsize * 2 + 2, anchors = {{from = "TOPLEFT", object = lastObject, to = lastObjectTo }}})
		header.label = UI.CreateFrame ('nkExtText', thisName .. 'label', header:getElement(true), { fontsize = this.fontsize, text = pane.label, color = this.color.label, anchors = {{from = "CENTER", object = header:getElement(true), to = "CENTER" , x = -1, y = 0}} })
		header.line = UI.CreateFrame ('nkExtFrame', thisName .. 'line', header:getElement(true), { color = {body = this.color.body}, width = 148, height = 1, visible = false, anchors = {{from = "BOTTOMLEFT", object = header:getElement(false), to = "BOTTOMLEFT", x=1, y=0 }}})
		
		pane.content:update( {anchors = {{ from = "TOPLEFT", object = element.body:getElement(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = element.body:getElement(), to = "BOTTOMRIGHT"}} })
		local body = header:getElement()
		body.paneNo = index
		
		function body.Event:LeftClick()
			this.header[this.activePane]:update({ color = {body = this.color.inactive, border = this.color.border} })
			this.header[this.activePane].line:update({ visible = false })
			this.panes[this.activePane].content:update ({visible = false })
			
			this.activePane=self.paneNo
			
			this.header[this.activePane]:update({ color = {body = this.color.body, border = this.color.border} })
			this.header[this.activePane].line:update({ visible = true })
			
			if this.panes[this.activePane].initFunc ~= nil then
				if this.panes[this.activePane].initialized ~= true then
					this.panes[this.activePane].initFunc()
					this.panes[this.activePane].initialized = true
				end
			end
			this.panes[this.activePane].content:update ({visible = true })			
		end
		
		lastObjectTo = "TOPRIGHT"
		lastObject = header:getElement(false)
	
		table.insert(this.header, header)
		index = index + 1
	end
	
	if this.panes[1].initFunc ~= nil then 
		this.panes[1].initFunc() 
		this.panes[1].initialized = true
	end
	
	this.header[1]:update({ color = {body = this.color.body, border = this.color.border} })
	this.header[1].line:update({ visible = true })
	this.panes[1].content:update ({visible = true })

	this.element = element
	
	setmetatable(this, self)
	self.__index = self
	return this

end

function nkGenie.ExtTabPane:update () end
function nkGenie.ExtTabPane:getBody (innerFlag) return self.element.body:getElement(innerFlag) end