nkTools = {}
nkTools.table = {}

nkTools.table.isMember = function (table, element)
  
  for idx, value in pairs(table) do
    if value == element then
		return true
    end
  end
  
  return false
  
end

nkTools.table.getTablePos = function (table, element)

	for idx, value in pairs (table) do
		if value == element then
			return idx
		end
	end
	
	return -1

end

nkTools.table.getSortedKeys = function (tableData)

	local tempTable = {}
    
    for k, data in pairs(tableData) do 
        table.insert(tempTable, k) 
    end
	
	table.sort(tempTable, function (a, b) return string.lower(a) < string.lower(b) end)
	return tempTable
	
end

nkTools.table.merge = function (table1, table2)

	for k, v in pairs (table2) do
		table.insert (table1, v)
	end

end

nkTools.table.mergeIndexed = function (table1, table2)

	for k, v in pairs (table2) do
		table1[k] = v
	end

end

function string:split(delimiter)
  local result = { }
  local from = 1
  local delim_from, delim_to = string.find( self, delimiter, from )
  while delim_from do
    table.insert( result, string.sub( self, from , delim_from-1 ) )
    from = delim_to + 1
    delim_from, delim_to = string.find( self, delimiter, from )
  end
  table.insert( result, string.sub( self, from ) )
  return result
end

nkTools.table.getKeyByValue = function (tableData, value)

	for k, v in pairs (tableData) do
		if v == value then return k end
	end
	
	return nil

end

nkTools.table.copy = function (tableToCopy)

    local lookup_table = {}
    local function _copy(tableToCopy)
        if type(tableToCopy) ~= "table" then
            return tableToCopy
        elseif lookup_table[tableToCopy] then
            return lookup_table[tableToCopy]
        end
        local new_table = {}
        lookup_table[tableToCopy] = new_table
        for index, value in pairs(tableToCopy) do
            new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(tableToCopy))
    end
    return _copy(tableToCopy)
end

function nkTools.round (num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end