nkRebuff.Config = { 
	frame = nil,
	selectedBar = 1
}

nkRebuff.MoveBar = {}
nkRebuff.HideDialog = {}

function nkRebuff.Config:new(settings)
	
	local this = settings or {}
	
	self:CreateUI()	
	
	setmetatable(this, self)
	self.__index = self
	return this

end

function nkRebuff.Config:Show(flag) 
	
	if flag == true then self:Update() end
	self.frame:SetVisible(flag) 
	
end

function nkRebuff.Config:Update()

	local selection = self.frame.paneTab3.selSetting:getValue()
	if selection == 1 then
		self:PopulateGrid('buffdura', self.frame.paneTab3.cbActiveOnly:getChecked(), self.frame.paneTab3.cbUseableOnly:getChecked())
	elseif selection == 2 then
		self:PopulateGrid('buffperma', self.frame.paneTab3.cbActiveOnly:getChecked(), self.frame.paneTab3.cbUseableOnly:getChecked())
	elseif selection == 3 then
		self:PopulateGrid('buffother', self.frame.paneTab3.cbActiveOnly:getChecked(), self.frame.paneTab3.cbUseableOnly:getChecked())
	elseif selection == 4 then
		self:PopulateGrid('buff3rd', self.frame.paneTab3.cbActiveOnly:getChecked(), self.frame.paneTab3.cbUseableOnly:getChecked())
	elseif selection == 5 then
		self:PopulateGrid('debuff', self.frame.paneTab3.cbActiveOnly:getChecked(), self.frame.paneTab3.cbUseableOnly:getChecked())
	elseif selection == 6 then
		self:PopulateGrid('cooldowns', self.frame.paneTab3.cbActiveOnly:getChecked(), self.frame.paneTab3.cbUseableOnly:getChecked())
	end

	local selection = {{ label = nkRebuffSettings.setName1, value = 1}, { label = nkRebuffSettings.setName2, value = 2}, { label = nkRebuffSettings.setName3, value = 3}, { label = nkRebuffSettings.setName4, value = 4}, { label = nkRebuffSettings.setName5, value = 5}, { label = nkRebuffSettings.setName6, value = 6}  }
	self.frame.fldSelSet:updateSelection(selection)
	for k, v in pairs (selection) do
		if v.value == nkRebuffSettings.activeSet then
			self.frame.fldSelSet:setValue(v.label)
			break
		end
	end	
	
	selection = {{label = nkRebuffTexts.set0, value = 0 }, {label = nkRebuffSettings.setName1, value = 1}, { label = nkRebuffSettings.setName2, value = 2}, { label = nkRebuffSettings.setName3, value = 3}, { label = nkRebuffSettings.setName4, value = 4}, { label = nkRebuffSettings.setName5, value = 5}, { label = nkRebuffSettings.setName6, value = 6}}
	self.frame.paneTab2.setSection.selSupportSet:updateSelection(selection)
	self.frame.paneTab2.setSection.selHealerSet:updateSelection(selection)
	self.frame.paneTab2.setSection.selTankSet:updateSelection(selection)
	self.frame.paneTab2.setSection.selDPSSet:updateSelection(selection)
	
	
end

function nkRebuff.Config:Close() 
	
	self.frame.paneTab1.basicSection.cbLocked:toggle(true)
	
	nkRebuffSettings.setName1 = self.frame.paneTab2.nameSection.fldSetName1:getValue()
	nkRebuffSettings.setName2 = self.frame.paneTab2.nameSection.fldSetName2:getValue()
	nkRebuffSettings.setName3 = self.frame.paneTab2.nameSection.fldSetName3:getValue()
	nkRebuffSettings.setName4 = self.frame.paneTab2.nameSection.fldSetName4:getValue()
	nkRebuffSettings.setName5 = self.frame.paneTab2.nameSection.fldSetName5:getValue()
	nkRebuffSettings.setName6 = self.frame.paneTab2.nameSection.fldSetName6:getValue()
	
	self.frame.paneTab2.nameSection.fldSetName1:leave()
	self.frame.paneTab2.nameSection.fldSetName2:leave()
	self.frame.paneTab2.nameSection.fldSetName3:leave()
	self.frame.paneTab2.nameSection.fldSetName4:leave()
	self.frame.paneTab2.nameSection.fldSetName5:leave()
	self.frame.paneTab2.nameSection.fldSetName6:leave()
	
	self:Show(false)
	nkRebuff.performanceCheck()
	nkRebuff.buildBars()
	
	if nkRebuff.buffBar ~= nil then nkRebuff.buffBar:Update() end 
	if nkRebuff.debuffBar ~= nil then nkRebuff.debuffBar:Update() end 
	if nkRebuffSettings.debuffWarning == true and nkRebuff.debuffPlayerBar ~= nil then nkRebuff.debuffPlayerBar:Update() end 
	if nkRebuff.cooldownBar ~= nil then nkRebuff.cooldownBar:Update() end 
	if nkRebuff.activeBar ~= nil then nkRebuff.activeBar:Update() end 
	
	if nkRebuff.nkButton ~= nil then nkRebuff.nkButton:update() end
	
	if nkRebuffSettings.events == true and nkRebuff.brEventInit == false then 
		table.insert(Event.Buff.Add, {nkRebuff.buff.handleNew , "nkRebuff", "buffAdded"}) 
		nkRebuff.brEventInit = true
	end
	
end

function nkRebuff.Config:CreateUI()

	self.frame = UI.CreateFrame ('nkExtWindow', 'configFrame', nkRebuff.context, {fontsize = 12, width = 685, height = 482, 
									color = {border = "000000", body = "333333", header = "3B5998", title = "FFFFFF", footer="444444"},
									title = nkRebuff.addonName .. ' ' .. nkRebuffTexts.version .. ' ' .. nkRebuff.addonVersion,
									anchors = {{from = "CENTER", object = UIParent, to = "CENTER"}}, closeable = true, collapsible = true, dragable = true, visible = true,
									closeFunc = function() nkRebuff.Config:Close() end, footer = nkRebuffTexts.msgCopyright})

	local btTemplate = { color = {body = "3B5998", border="000000", label = "FFFFFF"}}
	
	self.frame.closeButton = UI.CreateFrame ('nkExtButton', 'configFrameButtonClose', self.frame:getBody(true), { layer = 1, label = nkRebuffTexts.btClose, anchors = {{from = "BOTTOMLEFT", object = self.frame:getBody(true), to = "BOTTOMLEFT", x = 10, y = -10}}, func = function () self:Close() end, template = btTemplate})	
	self.frame.resetHiddenButton = UI.CreateFrame ('nkExtButton', 'configFrameButtonResetHidden', self.frame:getBody(true), { layer = 1, label = nkRebuffTexts.btResetHidden, anchors = {{from = "TOPLEFT", object = self.frame.closeButton:getElement(), to = "TOPRIGHT", x = 10, y = 0}}, func = function () nkRebuff.tempHides['buff'] = {}; nkRebuff.tempHides['debuff'] = {} end, template = btTemplate})	
	self.frame.resetDataButton = UI.CreateFrame ('nkExtButton', 'configFrameButtonResetData', self.frame:getBody(true), { layer = 1, label = nkRebuffTexts.btResetData, anchors = {{from = "TOPLEFT", object = self.frame.resetHiddenButton:getElement(), to = "TOPRIGHT", x = 10, y = 0}}, func = function () nkRebuff.tempHides['buff'] = {}; nkRebuff.tempHides['debuff'] = {}; self:ClearData() end, template = btTemplate})	
	
	self.frame.paneTab1 = UI.CreateFrame ('nkExtFrame', 'configFrameTab1', self.frame:getBody(true), { color = {body = "444444"}, visible = false})
	self.frame.paneTab2 = UI.CreateFrame ('nkExtFrame', 'configFrameTab2', self.frame:getBody(true), { color = {body = "444444"}, visible = false})
	self.frame.paneTab3 = UI.CreateFrame ('nkExtFrame', 'configFrameTab3', self.frame:getBody(true), { color = {body = "444444"}, visible = false})
	self.frame.paneTab4 = UI.CreateFrame ('nkExtFrame', 'configFrameTab4', self.frame:getBody(true), { color = {body = "444444"}, visible = false})
		
	self.frame.tabPane = UI.CreateFrame ('nkExtTabPane', 'configFrameTabPane', self.frame:getBody(true), { contentLayer = 3, fontsize = 12, width = 665, height = 339,  color = { body = "444444" , border = "000000" , label= "FFFFFF", inactive = "333333"}, 
											anchors = {{from = "TOPLEFT", object = self.frame:getBody(true), to = "TOPLEFT", x = 10, y = 10}}, 
											panes = {{content = self.frame.paneTab1, label = nkRebuffTexts.tabHeader1}, {content = self.frame.paneTab2, label = nkRebuffTexts.tabHeader2}, {content = self.frame.paneTab3, label = nkRebuffTexts.tabHeader3}, {content = self.frame.paneTab4, label = nkRebuffTexts.tabHeader4}}
										})
	self:SetupTab1()
	self:SetupTab2()
	self:SetupTab3()
	self:SetupTab4()
	
	local selection = {	{ label = nkRebuffSettings.setName1, value = 1}, { label = nkRebuffSettings.setName2, value = 2}, { label = nkRebuffSettings.setName3, value = 3},
						{ label = nkRebuffSettings.setName4, value = 4}, { label = nkRebuffSettings.setName5, value = 5}, { label = nkRebuffSettings.setName6, value = 6} }
	
	self.frame.selSetLabel = UI.CreateFrame ('nkExtText', 'configFrameSelSetLabel', self.frame:getBody(true), { anchors = {{ from = "TOPLEFT", object = self.frame.tabPane:getBody(false), to = "BOTTOMLEFT", x = 0, y = 10}}, fontsize = 14, text = nkRebuffTexts.setLoaded, color = 'FF0000' })
	
	self.frame.fldSelSet = UI.CreateFrame('nkExtCombo', 'configFrameSelSet', self.frame:getBody(true), { value = nkRebuffSettings.activeSet, width = 150, fontsize = 12, color = {border = '000000', body = '444444', label = 'FFFFFF'}, 
																			 selection = selection, anchors = {{ from = "TOPLEFT", object = self.frame.selSetLabel:getElement(), to = "TOPRIGHT", x = 10, y = 0}},
																			 func = function (value) self:ActivateSet(value) end})	
	
	self.frame.fldSelSet:getElement():SetLayer(2)

end

function nkRebuff.Config:ActivateSet (set)

	nkRebuffSettings.activeSet = set
	self:Update()

end

function nkRebuff.Config:SetupTab1()

	local frame = self.frame.paneTab1
	
	frame:update ({ anchors = {{ from = "TOPLEFT", object = self.frame.tabPane:getBody(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = self.frame.tabPane:getBody(), to = "BOTTOMRIGHT"} } })
	
	local secTemplate = { color = {border = "000000", body = "333333", header = "3B5998", title = "FFFFFF", footer="444444"}, closeable = false, collapsible = false, dragable = false }
	local cbTemplate = {labelinfront = true, labelwidth = 175, fontsize = 12, color = {border = 'FFFFFF', body = '333333' }}
	
	frame.basicSection = UI.CreateFrame('nkExtWindow', 'configFrameTab1Section1', frame:getElement(true), { fontsize = 12, height = 94, title = nkRebuffTexts.configHeaderGeneric, 
											anchors = {{from = "TOPLEFT", object = frame:getElement(), to = "TOPLEFT", x = 5, y = 5}, {from = "TOPRIGHT", object = frame:getElement(), to = "TOPRIGHT", x = -5, y = 5}},
											template = secTemplate })

	frame.basicSection.cbActive = UI.CreateFrame('nkExtCheckbox', 'cbActive', frame.basicSection:getBody(true), {text = nkRebuffTexts.cbActive, checked = nkRebuffSettings.active, 
														anchors = {{from = "TOPLEFT", object = frame.basicSection:getBody(true), to = "TOPLEFT", x= 10, y= 2}}, template = cbTemplate,
														func = function (this) nkRebuffSettings.active = this:getChecked(); if nkRebuff.buffBar ~= nil then nkRebuff.buffBar:SetVisible(nkRebuffSettings.active) end end})

	frame.basicSection.cbCombat = UI.CreateFrame('nkExtCheckbox', 'cbCombat', frame.basicSection:getBody(true), { text = nkRebuffTexts.cbCombat, checked = nkRebuffSettings.combatOnly, 
														anchors = {{from = "CENTERLEFT", object = frame.basicSection.cbActive:getElement(), to = "CENTERLEFT", x= 325, y= 0}}, template = cbTemplate,														
														func = function (this) nkRebuffSettings.combatOnly = this:getChecked() end})													
														
														
	frame.basicSection.cbEvents = UI.CreateFrame('nkExtCheckbox', 'cbEvents', frame.basicSection:getBody(true), {text = nkRebuffTexts.cbEvents, checked = nkRebuffSettings.events, 
														anchors = {{from = "TOPLEFT", object = frame.basicSection.cbActive:getElement(true), to = "BOTTOMLEFT", x = 0, y = 8}}, template = cbTemplate,
														func = function (this) nkRebuffSettings.events = this:getChecked() end})														
	
	frame.basicSection.slThrottle = UI.CreateFrame('nkExtSlider', 'slThrottle', frame.basicSection:getBody(true), {text = string.format(nkRebuffTexts.slThrottle, nkRebuffSettings.throttle), value = nkRebuffSettings.throttle, range = {0.5, 1}, width = 100, 
															precision = 1, anchors = {{from = "CENTERLEFT", object = frame.basicSection.cbEvents:getElement(), to = "CENTERLEFT", x= 325, y= 0}},  template = cbTemplate, 
															func = function(this) nkRebuffSettings.throttle = this.value; this:update({ text = string.format(nkRebuffTexts.slThrottle, nkRebuffSettings.throttle) }) end })

	
	frame.basicSection.cbLocked = UI.CreateFrame('nkExtCheckbox', 'cbLocked', frame.basicSection:getBody(true), { text = nkRebuffTexts.cbLocked, checked = nkRebuffSettings.locked,
														anchors = {{from = "TOPLEFT", object = frame.basicSection.cbEvents:getElement(), to = "BOTTOMLEFT", x = 0, y = 8}}, template = cbTemplate,
														func = function (this) nkRebuffSettings.locked = this:getChecked(); self:Move() end })
		
	frame.basicSection.cbDebuffWarning = UI.CreateFrame('nkExtCheckbox', 'cbDebuffWarning', frame.basicSection:getBody(true), { text = nkRebuffTexts.cbDebuffWarning, checked = nkRebuffSettings.debuffWarning,
														anchors = {{from = "CENTERLEFT", object = frame.basicSection.cbLocked:getElement(), to = "CENTERLEFT", x= 325, y= 0}}, template = cbTemplate,														
														func = function (this) nkRebuffSettings.debuffWarning = this:getChecked(); self:Move() end })


	-- Design section
	
	frame.designSection = UI.CreateFrame('nkExtWindow', 'configFrameTab1Section2', frame:getElement(true), {fontsize = 12, height = 203, title = nkRebuffTexts.configHeaderDesign,
															anchors = {{from = "TOPLEFT", object = frame.basicSection:getBody(false), to = "BOTTOMLEFT", x = 0, y = 5}, {from = "TOPRIGHT", object = frame.basicSection:getBody(false), to = "BOTTOMRIGHT", x = 0, y = 5}},
															template = secTemplate })													
	
	local comboTemplate = { color = {border = '000000', body = '444444', label = 'FFFFFF'}, width = 100, fontsize = 12, height = 19 }
	
	local selection = {{label = nkRebuffTexts.selBarBuff, value = 1 }, {label = nkRebuffTexts.selBarDebuffTarget, value = 2}, { label = nkRebuffTexts.selBarDebuffPlayer, value = 3}, { label = nkRebuffTexts.selBarCooldown, value = 4}, { label = nkRebuffTexts.selBarActive, value = 5}}
	
	frame.designSection.selBar = UI.CreateFrame ('nkExtCombo', 'selBar', frame.designSection:getBody(true), { layer = 4, value = 1, selection = selection, anchors = {{from = "CENTERLEFT", object = frame.designSection:getHeaderTitle(true), to = "CENTERLEFT", x = 178, y = 0 }}, text = nkRebuffTexts.selBar,
																											color = {border = '000000', body = '5B79B9', label = 'FFFFFF'}, width = 200, fontsize = 12, height = 19,
																											func = function (value) nkRebuff.Config.selectedBar = value; self:selectBar() end})
	

	frame.designSection.slnoOfIcons = UI.CreateFrame('nkExtSlider', 'slnoOfIcons', frame.designSection:getBody(true), {text = nkRebuffTexts.slnoOfIcons .. ' ' .. tostring(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].noOfIcons), value = nkRebuffSettings.bars[nkRebuff.Config.selectedBar].noOfIcons, range = {3, 15}, width = 100, 
															anchors = {{from = "TOPLEFT", object = frame.designSection:getBody(), to = "TOPLEFT", x= 10, y= 5}},  template = cbTemplate, 
															func = function(this) nkRebuffSettings.bars[nkRebuff.Config.selectedBar].noOfIcons = math.floor(this.value); this:update({ text = nkRebuffTexts.slnoOfIcons .. ' ' .. tostring(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].noOfIcons) }) end })
	
	frame.designSection.slRunoutDuration = UI.CreateFrame('nkExtSlider', 'slRunOutDuration', frame.designSection:getBody(true), {text = string.format (nkRebuffTexts.slRunoutDuration, nkRebuffSettings.bars[nkRebuff.Config.selectedBar].runoutDuration), value = nkRebuffSettings.bars[nkRebuff.Config.selectedBar].runoutDuration, range = {0, 60}, width = 100, 
																anchors = {{from = "CENTERLEFT", object = frame.designSection.slnoOfIcons:getElement(), to = "CENTERLEFT", x=325, y=0}}, template = cbTemplate,
																func = function (this) nkRebuffSettings.bars[nkRebuff.Config.selectedBar].runoutDuration = this.value; this:update({ text = string.format (nkRebuffTexts.slRunoutDuration, nkRebuffSettings.bars[nkRebuff.Config.selectedBar].runoutDuration)}) end })
	
	frame.designSection.slScale = UI.CreateFrame('nkExtSlider', 'slScale', frame.designSection:getBody(true), {text = nkRebuffTexts.slScale .. ' ' .. tostring(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].scale) .. '%', value = nkRebuffSettings.bars[nkRebuff.Config.selectedBar].scale, range = {1, 200}, width = 100, 
															anchors = {{from = "TOPLEFT", object = frame.designSection.slnoOfIcons:getElement(), to = "BOTTOMLEFT", x = 0, y = 10}}, template = cbTemplate,
															func = function(this) nkRebuffSettings.bars[nkRebuff.Config.selectedBar].scale = this.value; this:update({ text = nkRebuffTexts.slScale .. ' ' .. tostring(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].scale) .. '%' }); if nkRebuff.buffBar ~= nil then nkRebuff.buffBar:Update() end end })
	
	frame.designSection.selAlignLabel = UI.CreateFrame ('nkExtText', 'selAlignLabel', frame.designSection:getBody(true), { anchors = {{from = "CENTERLEFT", object = frame.designSection.slScale:getElement(), to = "CENTERLEFT", x = 325, y = 3 }}, fontsize = 12, text = nkRebuffTexts.rbAlign, color = 'FFFFFF' })
	local alignSelection = {{label = nkRebuffTexts.rbAlignLeft, value = 'left' }, {label = nkRebuffTexts.rbAlignCentered, value = 'centered'}, { label = nkRebuffTexts.rbAlignRight, value = 'right'}, { label = nkRebuffTexts.rbAlignVertical, value = 'vertical'}}
	frame.designSection.selAlign = UI.CreateFrame('nkExtCombo', 'selAlign', frame.designSection:getBody(true), { layer = 3, value = nkRebuffSettings.bars[nkRebuff.Config.selectedBar].align, selection = alignSelection, anchors = {{from = "TOPLEFT", object = frame.designSection.selAlignLabel:getElement(), to = "TOPLEFT", x = 178, y = 0 }}, template = comboTemplate, 
														func = function (value) nkRebuffSettings.bars[nkRebuff.Config.selectedBar].align = value end})

	frame.designSection.cbFadein = UI.CreateFrame('nkExtCheckbox', 'cbFadein', frame.designSection:getBody(true), { text = nkRebuffTexts.cbFadein, checked = nkRebuffSettings.bars[nkRebuff.Config.selectedBar].cbFadein,
														anchors = {{from = "TOPLEFT", object = frame.designSection.slScale:getElement(), to = "BOTTOMLEFT", x = 0, y = 10}}, template = cbTemplate,
														func = function (this) nkRebuffSettings.bars[nkRebuff.Config.selectedBar].cbFadein = this:getChecked(); end })													
	
	frame.designSection.slAlpha = UI.CreateFrame('nkExtSlider', 'slAlpha', frame.designSection:getBody(true), {text = nkRebuffTexts.slAlpha .. ' ' .. tostring(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].alpha), value = nkRebuffSettings.bars[nkRebuff.Config.selectedBar].alpha, range = {0.2, 1}, width = 100, 
															anchors = {{from = "CENTERLEFT", object = frame.designSection.cbFadein:getElement(), to = "CENTERLEFT", x=325, y=0}}, labelwidth = 174, template = cbTemplate, 
															func = function(this) nkRebuffSettings.bars[nkRebuff.Config.selectedBar].alpha = math.floor(this.value*10)/10; this:update({ text = nkRebuffTexts.slAlpha .. ' ' .. tostring(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].alpha) }) end })
	
	frame.designSection.cbNoLabel = UI.CreateFrame('nkExtCheckbox', 'cbNoLabel', frame.designSection:getBody(true), { checked = nkRebuffSettings.bars[nkRebuff.Config.selectedBar].noLabel, text = nkRebuffTexts.cbNoLabel, anchors = {{from = "TOPLEFT", object = frame.designSection.cbFadein:getElement(), to = "BOTTOMLEFT", x= 0, y = 8}},
															template = cbTemplate, func = function () nkRebuffSettings.bars[nkRebuff.Config.selectedBar].noLabel = frame.designSection.cbNoLabel:getChecked() end})													
	
	frame.designSection.cbNoBorder = UI.CreateFrame('nkExtCheckbox', 'cbNoBorder', frame.designSection:getBody(true), { checked = nkRebuffSettings.bars[nkRebuff.Config.selectedBar].noBorder, text = nkRebuffTexts.cbNoBorder, anchors = {{from = "CENTERLEFT", object = frame.designSection.cbNoLabel:getElement(), to = "CENTERLEFT", x= 325, y=0}},
															template = cbTemplate, func = function () nkRebuffSettings.bars[nkRebuff.Config.selectedBar].noBorder = frame.designSection.cbNoBorder:getChecked() end})
	
	
	frame.designSection.cbShortText = UI.CreateFrame('nkExtCheckbox', 'cbNoBorder', frame.designSection:getBody(true), { checked = nkRebuffSettings.bars[nkRebuff.Config.selectedBar].shortText, text = nkRebuffTexts.cbShortText, 
															anchors = {{from = "TOPLEFT", object = frame.designSection.cbNoLabel:getElement(), to = "BOTTOMLEFT", x= 0, y = 10}},
															template = cbTemplate, func = function () nkRebuffSettings.bars[nkRebuff.Config.selectedBar].shortText = frame.designSection.cbShortText:getChecked() end})

	frame.designSection.slFontSize = UI.CreateFrame('nkExtSlider', 'slFontSize', frame.designSection:getBody(true), {text = nkRebuffTexts.slFontSize .. ' ' .. tostring(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].fontsize), value = nkRebuffSettings.bars[nkRebuff.Config.selectedBar].fontsize, range = {10, 20}, width = 100, 
															anchors = {{from = "CENTERLEFT", object = frame.designSection.cbShortText:getElement(), to = "CENTERLEFT", x=325, y=0}}, labelwidth = 174, template = cbTemplate, 
															func = function(this) nkRebuffSettings.bars[nkRebuff.Config.selectedBar].fontsize = math.floor(this.value*10)/10; this:update({ text = nkRebuffTexts.slFontSize .. ' ' .. tostring(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].fontsize) }) end })
	
	local selection = {{label = nkRebuffTexts.ColorBlack, value = '000000' }, {label = nkRebuffTexts.ColorWhite, value = 'FFFFFF'}, { label = nkRebuffTexts.ColorRed, value = '7F0000'}, { label = nkRebuffTexts.ColorYellow, value = 'FFD800'}, { label = nkRebuffTexts.colorBlue, value = '0094FF'}}		
	
	frame.designSection.selColorBorderLabel = UI.CreateFrame ('nkExtText', 'selColorBuffLabel', frame.designSection:getBody(true), { anchors = {{from = "TOPLEFT", object = frame.designSection.cbShortText:getElement(), to = "BOTTOMLEFT", x = 0, y = 10 }}, fontsize = 12, text = nkRebuffTexts.rbColorBorder, color = 'FFFFFF' })
	frame.designSection.selColorBorder = UI.CreateFrame('nkExtCombo', 'selColorBuff', frame.designSection:getBody(true), { layer = 2, value = nkRebuffSettings.bars[nkRebuff.Config.selectedBar].bcolor, selection = selection, 
																															anchors = {{from = "CENTERLEFT", object = frame.designSection.selColorBorderLabel:getElement(), to = "CENTERLEFT", x = 178, y = 0 }}, 
																															template = comboTemplate, func = function (value) nkRebuffSettings.bars[nkRebuff.Config.selectedBar].bcolor = value end})

	frame.designSection.selColorCounterLabel = UI.CreateFrame ('nkExtText', 'selColorCounterLabel', frame.designSection:getBody(true), { anchors = {{from = "CENTERLEFT", object = frame.designSection.selColorBorderLabel:getElement(), to = "CENTERLEFT", x = 325, y = 0 }}, fontsize = 12, text = nkRebuffTexts.rbColorCounter, color = 'FFFFFF' })
	frame.designSection.selColorCounter = UI.CreateFrame('nkExtCombo', 'selColorCounter', frame.designSection:getBody(true), { layer = 2, value = nkRebuffSettings.bars[nkRebuff.Config.selectedBar].ccolor, selection = selection, anchors = {{from = "CENTERLEFT", object = frame.designSection.selColorCounterLabel:getElement(), to = "CENTERLEFT", x = 178, y = 0 }}, template = comboTemplate, func = function (value) nkRebuffSettings.bars[nkRebuff.Config.selectedBar].ccolor = value end})																													
	
	frame.designSection.selColorLabelLabel = UI.CreateFrame ('nkExtText', 'selColorDebuffLabel', frame.designSection:getBody(true), { anchors = {{from = "TOPLEFT", object = frame.designSection.selColorBorderLabel:getElement(), to = "BOTTOMLEFT", x = 0, y = 4 }}, fontsize = 12, text = nkRebuffTexts.rbColorLabel, color = 'FFFFFF' })
	frame.designSection.selColorLabel = UI.CreateFrame('nkExtCombo', 'selColorDebuff', frame.designSection:getBody(true), { layer = 1, value = nkRebuffSettings.bars[nkRebuff.Config.selectedBar].lcolor, selection = selection, anchors = {{from = "CENTERLEFT", object = frame.designSection.selColorLabelLabel:getElement(), to = "CENTERLEFT", x = 178, y = 0 }}, template = comboTemplate, func = function (value) nkRebuffSettings.bars[nkRebuff.Config.selectedBar].lcolor = value end})

end

function nkRebuff.Config:selectBar()

	local frame = self.frame.paneTab1.designSection
	
	frame.slnoOfIcons:SetValue(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].noOfIcons)
	frame.slnoOfIcons:update({ text = nkRebuffTexts.slnoOfIcons .. ' ' .. tostring(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].noOfIcons) })
	
	frame.slRunoutDuration:SetValue(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].runoutDuration)
	frame.slRunoutDuration:update({ text = string.format (nkRebuffTexts.slRunoutDuration, nkRebuffSettings.bars[nkRebuff.Config.selectedBar].runoutDuration) })
	
	frame.slScale:SetValue(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].scale)
	frame.slScale:update({ text = nkRebuffTexts.slScale .. ' ' .. tostring(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].scale) .. '%' })

	frame.selAlign:setByValue(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].align)

	frame.cbFadein:toggle(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].cbFadein)
	
	frame.slAlpha:SetValue(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].alpha)
	frame.slAlpha:update({ text = nkRebuffTexts.slAlpha .. ' ' .. tostring(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].alpha) })
	
	frame.cbNoLabel:toggle(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].noLabel)	
	frame.cbNoBorder:toggle(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].noBorder)
	frame.cbShortText:toggle(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].shortText)
	
	frame.slFontSize:SetValue(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].fontsize)
	frame.slFontSize:update({ text = nkRebuffTexts.slFontSize .. ' ' .. tostring(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].fontsize) })
	
	frame.selColorBorder:setByValue(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].bcolor)
	frame.selColorCounter:setByValue(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].ccolor)
	frame.selColorLabel:setByValue(nkRebuffSettings.bars[nkRebuff.Config.selectedBar].lcolor)
	
		
end

function nkRebuff.Config:SetupTab2() 

	local frame = self.frame.paneTab2
	frame:update ({ anchors = {{ from = "TOPLEFT", object = self.frame.tabPane:getBody(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = self.frame.tabPane:getBody(), to = "BOTTOMRIGHT"} } })
	
	local secTemplate = { color = {border = "000000", body = "333333", header = "3B5998", title = "FFFFFF", footer="444444"}, closeable = false, collapsible = false, dragable = false }	
	local cbTemplate = {labelinfront = true, labelwidth = 175, fontsize = 12, color = {border = 'FFFFFF', body = '333333' }}	
	local setTemplate = { width = 100, fontsize = 12, color = {border = '000000', body = '444444', label = 'FFFFFF'} }

	frame.nameSection = UI.CreateFrame('nkExtWindow', 'configFrameTab2Section2', frame:getElement(true), {fontsize = 12, height = 95, title = nkRebuffTexts.configHeaderNames,
															anchors = {{from = "TOPLEFT", object = frame:getElement(), to = "TOPLEFT", x = 5, y = 5}, {from = "TOPRIGHT", object = frame:getElement(), to = "TOPRIGHT", x = -5, y = 5}},															
															template = secTemplate })
	
	frame.nameSection.fldSetName1 = UI.CreateFrame ('nkExtTextField', 'fldSetName1', frame.nameSection:getBody(true), { value = nkRebuffSettings.setName1, width = 125, height = 20, label = nkRebuffTexts.set1, fontsize = 12, labelwidth = 175, color = { label = 'FFFFFF', border = 'FFFFFF', body = '333333' }, anchors = {{ from = "TOPLEFT", object = frame.nameSection:getBody(true), to = "TOPLEFT", x = 10, y = 5 }}, func = function (value) nkRebuffSettings.setName1 = value; self:Update() end })
	frame.nameSection.fldSetName2 = UI.CreateFrame ('nkExtTextField', 'fldSetName2', frame.nameSection:getBody(true), { value = nkRebuffSettings.setName2, width = 125, height = 20, label = nkRebuffTexts.set2, fontsize = 12, labelwidth = 175, color = { label = 'FFFFFF', border = 'FFFFFF', body = '333333' }, anchors = {{ from = "CENTERLEFT", object = frame.nameSection.fldSetName1.element.label:getElement(), to = "CENTERLEFT", x = 325, y = 0 }}, func = function (value) nkRebuffSettings.setName2 = value; self:Update()  end })
	frame.nameSection.fldSetName3 = UI.CreateFrame ('nkExtTextField', 'fldSetName3', frame.nameSection:getBody(true), { value = nkRebuffSettings.setName3, width = 125, height = 20, label = nkRebuffTexts.set3, fontsize = 12, labelwidth = 175, color = { label = 'FFFFFF', border = 'FFFFFF', body = '333333' }, anchors = {{ from = "TOPLEFT", object = frame.nameSection.fldSetName1.element.label:getElement(), to = "BOTTOMLEFT" }}, func = function (value) nkRebuffSettings.setName3 = value; self:Update()  end })
	frame.nameSection.fldSetName4 = UI.CreateFrame ('nkExtTextField', 'fldSetName4', frame.nameSection:getBody(true), { value = nkRebuffSettings.setName4, width = 125, height = 20, label = nkRebuffTexts.set4, fontsize = 12, labelwidth = 175, color = { label = 'FFFFFF', border = 'FFFFFF', body = '333333' }, anchors = {{ from = "CENTERLEFT", object = frame.nameSection.fldSetName3.element.label:getElement(), to = "CENTERLEFT", x = 325, y = 0 }}, func = function (value) nkRebuffSettings.setName4 = value; self:Update()  end })
	frame.nameSection.fldSetName5 = UI.CreateFrame ('nkExtTextField', 'fldSetName5', frame.nameSection:getBody(true), { value = nkRebuffSettings.setName5, width = 125, height = 20, label = nkRebuffTexts.set5, fontsize = 12, labelwidth = 175, color = { label = 'FFFFFF', border = 'FFFFFF', body = '333333' }, anchors = {{ from = "TOPLEFT", object = frame.nameSection.fldSetName3.element.label:getElement(), to = "BOTTOMLEFT" }}, func = function (value) nkRebuffSettings.setName5 = value; self:Update()  end })
	frame.nameSection.fldSetName6 = UI.CreateFrame ('nkExtTextField', 'fldSetName6', frame.nameSection:getBody(true), { value = nkRebuffSettings.setName6, width = 125, height = 20, label = nkRebuffTexts.set6, fontsize = 12, labelwidth = 175, color = { label = 'FFFFFF', border = 'FFFFFF', body = '333333' }, anchors = {{ from = "CENTERLEFT", object = frame.nameSection.fldSetName5.element.label:getElement(), to = "CENTERLEFT", x = 325, y = 0 }}, func = function (value) nkRebuffSettings.setName6 = value; self:Update()  end })

	frame.setSection = UI.CreateFrame('nkExtWindow', 'configFrameTab2Section1', frame:getElement(true), {fontsize = 12, height = 135, title = nkRebuffTexts.configHeaderSets,
															anchors = {{from = "TOPLEFT", object = frame.nameSection:getBody(false), to = "BOTTOMLEFT", x = 0, y = 5}, {from = "TOPRIGHT", object = frame.nameSection:getBody(false), to = "BOTTOMRIGHT", x = 0, y = 5}},
															template = secTemplate })

	
	frame.setSection.cbAutoSwitch = UI.CreateFrame('nkExtCheckbox', 'cbAutoSwitch', frame.setSection:getBody(true), { 	checked = nkRebuffSettings.autoSwitch, text = nkRebuffTexts.cbAutoSwitch,
															anchors = {{from = "TOPLEFT", object = frame.setSection:getBody(true), to = "TOPLEFT", x = 10, y = 2}}, template = cbTemplate,
															func = function (this) nkRebuffSettings.autoSwitch = this:getChecked() end})
	
	local selection = {{label = nkRebuffTexts.set0, value = 0 }, {label = nkRebuffSettings.setName1, value = 1}, { label = nkRebuffSettings.setName2, value = 2}, { label = nkRebuffSettings.setName3, value = 3}, { label = nkRebuffSettings.setName4, value = 4}, { label = nkRebuffSettings.setName5, value = 5}}

	if nkRebuffSettings.roleSets['tank'] == nil then nkRebuffSettings.roleSets['tank'] = 0 end
	if nkRebuffSettings.roleSets['dps'] == nil then nkRebuffSettings.roleSets['dps'] = 0 end
	if nkRebuffSettings.roleSets['support'] == nil then nkRebuffSettings.roleSets['support'] = 0 end
	if nkRebuffSettings.roleSets['healer'] == nil then nkRebuffSettings.roleSets['healer'] = 0 end
	
	frame.setSection.selTankSetLabel = UI.CreateFrame ('nkExtText', 'selTankSetLabel', frame.setSection:getBody(true), { anchors = {{ from = "TOPLEFT", object = frame.setSection.cbAutoSwitch:getElement(), to = "BOTTOMLEFT", x = 0, y = 10}}, fontsize = 12, text = nkRebuffTexts.tank, color = 'FFFFFF' })		
	frame.setSection.selDPSSetLabel = UI.CreateFrame ('nkExtText', 'selDPSSetLabel', frame.setSection:getBody(true), { anchors = {{ from = "CENTERLEFT", object = frame.setSection.selTankSetLabel:getElement(), to = "CENTERLEFT", x = 325, y = 0}}, fontsize = 12, text = nkRebuffTexts.dps, color = 'FFFFFF' })	
	frame.setSection.selSupportSetLabel = UI.CreateFrame ('nkExtText', 'selSupportSetLabel', frame.setSection:getBody(true), { anchors = {{ from = "TOPLEFT", object = frame.setSection.selTankSetLabel:getElement(), to = "BOTTOMLEFT", x = 0, y = 5}}, fontsize = 12, text = nkRebuffTexts.support, color = 'FFFFFF' })
	frame.setSection.selHealerSetLabel = UI.CreateFrame ('nkExtText', 'selHealerSetLabel', frame.setSection:getBody(true), { anchors = {{ from = "CENTERLEFT", object = frame.setSection.selSupportSetLabel:getElement(), to = "CENTERLEFT", x = 325, y = 0}}, fontsize = 12, text = nkRebuffTexts.healer, color = 'FFFFFF' })

	frame.setSection.selSupportSet = UI.CreateFrame('nkExtCombo', 'selSupportSet', frame.setSection:getBody(true), { layer = 1, value = nkRebuffSettings.roleSets['support'], template = setTemplate, selection = selection, anchors = {{ from = "TOPLEFT", object = frame.setSection.selSupportSetLabel:getElement(), to = "TOPLEFT", x = 178, y = 0}}, func = function (value) nkRebuffSettings.roleSets['support'] = value end})
	frame.setSection.selHealerSet = UI.CreateFrame('nkExtCombo', 'selHealerSet', frame.setSection:getBody(true), { layer = 1, value = nkRebuffSettings.roleSets['healer'], template = setTemplate, selection = selection, anchors = {{ from = "TOPLEFT", object = frame.setSection.selHealerSetLabel:getElement(), to = "TOPLEFT", x = 178, y = 0}}, func = function (value) nkRebuffSettings.roleSets['healer'] = value end})
	frame.setSection.selTankSet = UI.CreateFrame('nkExtCombo', 'selTankSet', frame.setSection:getBody(true), { layer = 2, value = nkRebuffSettings.roleSets['tank'], template = setTemplate,  selection = selection, anchors = {{ from = "TOPLEFT", object = frame.setSection.selTankSetLabel:getElement(), to = "TOPLEFT", x = 178, y = 0}}, func = function (value) nkRebuffSettings.roleSets['tank'] = value end})
	frame.setSection.selDPSSet = UI.CreateFrame('nkExtCombo', 'selDPSSet', frame.setSection:getBody(true), { layer = 2, value = nkRebuffSettings.roleSets['dps'], template = setTemplate, selection = selection, anchors = {{ from = "TOPLEFT", object = frame.setSection.selDPSSetLabel:getElement(), to = "TOPLEFT", x = 178, y = 0}}, func = function (value) nkRebuffSettings.roleSets['dps'] = value end})

end

function nkRebuff.Config:SetupTab3()

	local frame = self.frame.paneTab3
	frame:update ({ anchors = {{ from = "TOPLEFT", object = self.frame.tabPane:getBody(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = self.frame.tabPane:getBody(), to = "BOTTOMRIGHT"} } })
		
	frame.grid = nkGenie.ExtGrid:new('nkRebuffGrid', frame:getElement(), { fontsize = 12, color = { label = 'FFFFFF', border = '000000', body = '333333', bodyhighlight = 'FFFFFF', labelhighlight = '000000'}, anchors = {{ from = 'TOPLEFT', object = frame:getElement(true), to = "TOPLEFT", x = 10, y = 33}} })
	frame.grid:getElement():SetLayer(1)
	
	local cols = {{align = 'left', header = nkRebuffTexts.headerDescription, width = 400 }, { header = nkRebuffTexts.headerStatus, width = 100 }, { header = nkRebuffTexts.headerInfo, width = 100 }}
	
	frame.grid:layout (cols, 13, {})

	self:PopulateGrid('buffdura', false, true)
	
	local selection = {	{ value = 1, label = nkRebuffTexts.selBuffsDura}, { value = 2, label = nkRebuffTexts.selBuffsPerma}, { value = 3, label = nkRebuffTexts.selUseable },
						{ value = 4, label = nkRebuffTexts.selBuffsOtherPlayer}, { value = 5, label = nkRebuffTexts.selDebuffs}, { value = 6, label = nkRebuffTexts.selCooldown} }
	
	frame.selSettingLabel = UI.CreateFrame ('nkExtText', 'selSetting', frame:getElement(), { anchors = {{from = "TOPLEFT", object = frame:getElement(true), to = "TOPLEFT", x = 10, y = 5 }}, fontsize = 12, text = nkRebuffTexts.selSetting, color = 'FFFFFF' })
	
	local activateSettings = function (value)
		if value == 1 then
			self:PopulateGrid('buffdura', frame.cbActiveOnly:getChecked(), frame.cbUseableOnly:getChecked())
		elseif value == 2 then
			self:PopulateGrid('buffperma', frame.cbActiveOnly:getChecked(), frame.cbUseableOnly:getChecked())
		elseif value == 3 then
			self:PopulateGrid('buffother', frame.cbActiveOnly:getChecked(), frame.cbUseableOnly:getChecked())
		elseif value == 4 then
			self:PopulateGrid('buff3rd', frame.cbActiveOnly:getChecked(), frame.cbUseableOnly:getChecked())
		elseif value == 5 then
			self:PopulateGrid('debuff', frame.cbActiveOnly:getChecked(), frame.cbUseableOnly:getChecked())
		elseif value == 6 then
			self:PopulateGrid('cooldowns', frame.cbActiveOnly:getChecked(), frame.cbUseableOnly:getChecked())
		end
	end
	
	frame.selSetting = UI.CreateFrame('nkExtCombo', 'selSetting', frame:getElement(), { value = 1, selection = selection, anchors = {{from = "TOPLEFT", object = frame.selSettingLabel:getElement(), to = "TOPLEFT", x = 80, y = 0 }}, width = 200, fontsize = 12, color = {border = '000000', body = '333333', label = 'FFFFFF'}, func = function (value) activateSettings(value) end})
	frame.selSetting:getElement():SetLayer(2)

	local cbTemplate = {labelinfront = true, labelwidth = 125, fontsize = 12, color = {border = 'FFFFFF', body = '333333' }}
	
	frame.cbActiveOnly = UI.CreateFrame('nkExtCheckbox', 'cbActive', frame:getElement(), {text = nkRebuffTexts.cbActiveOnly, checked = false, 
														anchors = {{from = "CENTERLEFT", object = frame.selSettingLabel:getElement(), to = "CENTERLEFT", x= 300, y= 0}}, template = cbTemplate,
														func = function (this) self:Update() end})

	frame.cbUseableOnly = UI.CreateFrame('nkExtCheckbox', 'cbUseable', frame:getElement(), {text = nkRebuffTexts.cbUseableOnly, checked = true, 
														anchors = {{from = "CENTERLEFT", object = frame.cbActiveOnly:getElement(), to = "CENTERRIGHT", x= 10, y= 0}}, template = cbTemplate,
														func = function (this) self:Update() end})														
														
	
end

function nkRebuff.Config:SetupTab4()

	local frame = self.frame.paneTab4
	frame:update ({ anchors = {{ from = "TOPLEFT", object = self.frame.tabPane:getBody(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = self.frame.tabPane:getBody(), to = "BOTTOMRIGHT"} } })

	frame.addonNameShadow = UI.CreateFrame ('nkExtText', 'addonNameShadow', frame:getElement(), { layer = 1, text = string.format(nkRebuffTexts.about.addonName, nkRebuff.addonName), fontsize = 30, color = '000000', anchors = {{ from = "TOPCENTER", object = frame:getElement(), to = "TOPCENTER", x = 2, y = 12 }} })
	frame.addonName = UI.CreateFrame ('nkExtText', 'addonName', frame:getElement(), { layer = 2, text = string.format(nkRebuffTexts.about.addonName, nkRebuff.addonName), fontsize = 30, color = '008DF2', anchors = {{ from = "TOPCENTER", object = frame:getElement(), to = "TOPCENTER", x = 0, y = 10 }} })
	
	frame.versionShadow = UI.CreateFrame ('nkExtText', 'versionShadow', frame:getElement(), { layer = 1, text = string.format(nkRebuffTexts.about.version, nkRebuff.addonVersion), fontsize = 18, color = '000000', anchors = {{ from = "TOPCENTER", object = frame.addonName:getElement(), to = "BOTTOMCENTER", x = 2, y = 2 }} })
	frame.version = UI.CreateFrame ('nkExtText', 'version', frame:getElement(), { layer = 2, text = string.format(nkRebuffTexts.about.version, nkRebuff.addonVersion), fontsize = 18, color = '008DF2', anchors = {{ from = "TOPCENTER", object = frame.addonName:getElement(), to = "BOTTOMCENTER", x = 0, y = 0 }} })

	frame.writtenBy = UI.CreateFrame ('nkExtText', 'writteBy', frame:getElement(), { layer = 1, text = nkRebuffTexts.about.writtenBy, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.version:getElement(), to = "BOTTOMCENTER", x = 0, y = 10 }} })
	frame.patchCD = UI.CreateFrame ('nkExtText', 'patchCD', frame:getElement(), { layer = 1, text = nkRebuffTexts.about.patchCD, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.writtenBy:getElement(), to = "BOTTOMCENTER", x = 0, y = 0 }} })
	
	frame.copyright = UI.CreateFrame ('nkExtText', 'copyright', frame:getElement(), { layer = 1, text = nkRebuffTexts.about.copyright, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.patchCD:getElement(), to = "BOTTOMCENTER", x = 0, y = 10 }} })
	
	frame.donate1Shadow = UI.CreateFrame ('nkExtText', 'donate1Shadow', frame:getElement(), { layer = 1, text = nkRebuffTexts.about.donate1, fontsize = 20, color = '000000', anchors = {{ from = "TOPCENTER", object = frame.copyright:getElement(), to = "BOTTOMCENTER", x = 2, y = 17 }} })
	frame.donate1 = UI.CreateFrame ('nkExtText', 'donate1', frame:getElement(), { layer = 2, text = nkRebuffTexts.about.donate1, fontsize = 20, color = '008DF2', anchors = {{ from = "TOPCENTER", object = frame.copyright:getElement(), to = "BOTTOMCENTER", x = 0, y = 15 }} })
	
	frame.donate2Shadow = UI.CreateFrame ('nkExtText', 'donate2Shadow', frame:getElement(), { layer = 1, text = nkRebuffTexts.about.donate2, fontsize = 20, color = '000000', anchors = {{ from = "TOPCENTER", object = frame.donate1:getElement(), to = "BOTTOMCENTER", x = 2, y = 2 }} })
	frame.donate2 = UI.CreateFrame ('nkExtText', 'donate2', frame:getElement(), { layer = 2, text = nkRebuffTexts.about.donate2, fontsize = 20, color = '008DF2', anchors = {{ from = "TOPCENTER", object = frame.donate1:getElement(), to = "BOTTOMCENTER", x = 0, y = 0 }} })

	frame.twitter = UI.CreateFrame ('nkExtText', 'twitter', frame:getElement(), { layer = 1, text = nkRebuffTexts.about.twitter, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.donate2:getElement(), to = "BOTTOMCENTER", x = 0, y = 15 }} })		
	frame.blog = UI.CreateFrame ('nkExtText', 'blog', frame:getElement(), { layer = 1, text = nkRebuffTexts.about.blog, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.twitter:getElement(), to = "BOTTOMCENTER", x = 0, y = 0 }} })		
	
end

function nkRebuff.Config:HandleBuff (row, buffName)
	local frame = self.frame.paneTab3
	local curStatus = nkRebuffSettings.setsbuff[nkRebuffSettings.activeSet][buffName]
	if curStatus == false then
		nkRebuffSettings.setsbuff[nkRebuffSettings.activeSet][buffName] = true
		frame.grid.values[frame.grid.counter + row - 1][2].value = nkRebuffTexts.txtActive
	else
		nkRebuffSettings.setsbuff[nkRebuffSettings.activeSet][buffName] = false
		frame.grid.values[frame.grid.counter + row - 1][2].value = ''
	end
	frame.grid:fill()
end

function nkRebuff.Config:HandleBuff3rd (row, buffName)
	local frame = self.frame.paneTab3
	local curStatus = nkRebuffSettings.setsbuff3rd[nkRebuffSettings.activeSet][buffName]
	if curStatus == false then
		nkRebuffSettings.setsbuff3rd[nkRebuffSettings.activeSet][buffName] = true
		frame.grid.values[frame.grid.counter + row - 1][2].value = nkRebuffTexts.txtActive
	else
		nkRebuffSettings.setsbuff3rd[nkRebuffSettings.activeSet][buffName] = false
		frame.grid.values[frame.grid.counter + row - 1][2].value = ''
	end
	frame.grid:fill()
end

function nkRebuff.Config:HandleCooldowns (row, buffName)

	local frame = self.frame.paneTab3
	local curStatus = nkRebuffSettings.setsCD[nkRebuffSettings.activeSet][buffName]
	if curStatus == false then
		nkRebuffSettings.setsCD[nkRebuffSettings.activeSet][buffName] = true
		frame.grid.values[frame.grid.counter + row - 1][2].value = nkRebuffTexts.txtActive
	else
		nkRebuffSettings.setsCD[nkRebuffSettings.activeSet][buffName] = false
		frame.grid.values[frame.grid.counter + row - 1][2].value = ''
	end
	frame.grid:fill()

end

function nkRebuff.Config:HandleDebuff (row, buffName)
	local frame = self.frame.paneTab3
	local curStatus = nkRebuffSettings.setsdebuff[nkRebuffSettings.activeSet][buffName]
	if curStatus == false then
		nkRebuffSettings.setsdebuff[nkRebuffSettings.activeSet][buffName] = true
		frame.grid.values[frame.grid.counter + row - 1][2].value = nkRebuffTexts.txtActive
	else
		nkRebuffSettings.setsdebuff[nkRebuffSettings.activeSet][buffName] = false
		frame.grid.values[frame.grid.counter + row - 1][2].value = ''
	end
	frame.grid:fill()
end

function nkRebuff.Config:PopulateGrid (buffType, showActiveOnly, showOnlyCurrentRole)

	local setInfo = nil
	local abilityData = nil

	if buffType == 'debuff' then
		setInfo = nkRebuffSettings.setsdebuff[nkRebuffSettings.activeSet]		
		abilityData = nkRebuffSettings.debuffData
	elseif buffType == 'buff3rd' then
		setInfo = nkRebuffSettings.setsbuff3rd[nkRebuffSettings.activeSet]		
		abilityData = nkRebuffSettings.buffData3rd
	elseif buffType == 'cooldowns' then
		setInfo = nkRebuffSettings.setsCD[nkRebuffSettings.activeSet]
		abilityData = nkRebuffSettings.cdData
	else
		setInfo = nkRebuffSettings.setsbuff[nkRebuffSettings.activeSet]
		abilityData = nkRebuffSettings.buffData
	end		
	
	local tempData = {}
	
	if showOnlyCurrentRole == true then
		for k, v in pairs (abilityData) do
			if v.ability == nil then
				tempData[k] = v
			else
				local abilityInfo = Inspect.Ability.Detail(v.ability)
				if abilityInfo ~= nil then tempData[k] = v end
			end
		end
	else
		tempData = abilityData
	end
	
	local sortedKeys = nkTools.table.getSortedKeys(tempData)
	
	local gridValues = {}
	
	for idx = 1, #sortedKeys, 1 do
		local buffName = sortedKeys[idx]
		if setInfo[buffName] == nil then setInfo[buffName] = false end
		
		if showActiveOnly == false or setInfo[buffName] == true then
			local showFlag = false

			if buffType == 'debuff' or buffType == 'cooldowns' or buffType == 'buff3rd' then
				showFlag = true
			else
				local buffDetail = nkRebuffSettings.buffData[buffName]		

				if buffType == 'buffother' and buffDetail.ability == nil then
					if buffDetail.hidden ~= true then showFlag = true end
				elseif buffType == 'buffdura' and buffDetail.duration ~= nil and buffDetail.ability ~= nil then
					if buffDetail.hidden ~= true then showFlag = true end
				elseif buffType == 'buffperma' and buffDetail.duration == nil then
					if buffDetail.hidden ~= true then showFlag = true end
				end
			end
			
			if showFlag == true then
				local addInfo = ''
				if buffType == 'buff3rd' then addInfo = nkRebuffTexts.classes[nkRebuffSettings.buffData3rd[buffName].caster] end
				
				if setInfo[buffName] == false then
					table.insert (gridValues, {{value = buffName}, {value = ''}, { value = addInfo }})
				else
					table.insert (gridValues, {{value = buffName}, {value = nkRebuffTexts.txtActive}, { value = addInfo }})
				end
			end
		end
	end
	
	self.frame.paneTab3.grid.counter = 1
	self.frame.paneTab3.grid:fill(gridValues)
	self.frame.paneTab3.grid:setClickEvent ( function (row) 
		if gridValues[row] ~= nil then
			if buffType == 'debuff' then
				self:HandleDebuff (row, gridValues[row + self.frame.paneTab3.grid.counter - 1][1].value)
			elseif buffType == 'buff3rd' then
				self:HandleBuff3rd (row, gridValues[row + self.frame.paneTab3.grid.counter - 1][1].value)
			elseif buffType == 'cooldowns' then
				self:HandleCooldowns (row, gridValues[row + self.frame.paneTab3.grid.counter - 1][1].value)
			else
				self:HandleBuff (row, gridValues[row + self.frame.paneTab3.grid.counter - 1][1].value)
			end
		end
	end)
	
end

function nkRebuff.Config:Move()

	nkRebuff.performanceCheck()
	nkRebuff.buildBars()
	
	if self.frame.paneTab1.basicSection.cbLocked:getChecked() == true then
		self.frame:collapse(false)
		if nkRebuff.buffBar ~= nil then nkRebuff.buffBar:Moveable( false ) end
		if nkRebuff.debuffBar ~= nil then nkRebuff.debuffBar:Moveable (false) end
		if nkRebuff.cooldownBar ~= nil then nkRebuff.cooldownBar:Moveable (false) end
		if nkRebuff.activeBar ~= nil then nkRebuff.activeBar:Moveable (false) end
		if nkRebuff.debuffPlayerBar ~= nil then nkRebuff.debuffPlayerBar:Moveable (false) end
	else
		self.frame:collapse(true)
		if nkRebuff.buffBar ~= nil then nkRebuff.buffBar:Moveable( true ) end
		if nkRebuff.debuffBar ~= nil then nkRebuff.debuffBar:Moveable (true) end
		if nkRebuff.cooldownBar ~= nil then nkRebuff.cooldownBar:Moveable (true) end
		if nkRebuff.activeBar ~= nil then nkRebuff.activeBar:Moveable (true) end
		if nkRebuffSettings.debuffWarning == true and nkRebuff.debuffPlayerBar ~= nil then nkRebuff.debuffPlayerBar:Moveable (true) end
	end

end

function nkRebuff.Config:isVisible () return self.frame:isVisible() end

function nkRebuff.Config:ClearData ()

	nkRebuffSettings.buffData = {}
	nkRebuffSettings.buffData3rd = {}
	nkRebuffSettings.debuffData = {}
	nkRebuffSettings.cdData = {}

	nkRebuffSettings.setsbuff = {}
	nkRebuffSettings.setsbuff3rd = {}
	nkRebuffSettings.setsdebuff = {}
	nkRebuffSettings.setsCD = {}

	self:Update()
	
end