nkRebuff = {
	addonName = "nkRebuff",
	addonVersion = "1.7.0",
	configUI = nil,
	buffBar = nil,
	debuffBar = nil,
	cooldownBar = nil,
	activeBar = nil,
	debuffPlayerBar = nil,
	abilityBar = {},
	abilityIcon = {},
	tempHides = {['buff'] = {},['debuff'] = {}, ['cooldowns'] = {}},
	activeCDList = {},
	tooltip = nil,
	brEventInit = false,
	performance = { buffs = false, cooldowns = false, debuffs = false }
}

nkRebuff.context = UI.CreateContext("nkRebuffBar")

function nkRebuff.main(addon)

	if (addon == nkRebuff.addonName) then
	
		if nkRebuffSettings.events == true then 
			table.insert(Event.Buff.Add, {nkRebuff.buff.handleNew , "nkRebuff", "buffAdded"}) 
			nkRebuff.brEventInit = true
		end
		
		table.insert(Event.System.Update.Begin, {nkRebuff.eventHandler, "nkRebuff", "eventHandler"})
		table.insert(Event.Unit.Detail.Role	, {nkRebuff.buff.handleRoleChange, "nkRebuff", "roleChange"})
		
		local items = {
		{ label = nkRebuffTexts.buttonMenuConfig, func = function () if nkRebuff.configUI == nil then nkRebuff.configUI = nkRebuff.Config:new() else nkRebuff.configUI:Show(true) end end},
		{ seperator = true },
		{ label = nkRebuffTexts.buttonMenuResetTempHides, func = function () nkRebuff.tempHides['buff'] = {}; nkRebuff.tempHides['debuff'] = {} end},
		{ label = nkRebuffSettings.setName1, func = function() nkRebuff.activateSet (1) end },
		{ label = nkRebuffSettings.setName2, func = function() nkRebuff.activateSet (2) end },
		{ label = nkRebuffSettings.setName3, func = function() nkRebuff.activateSet (3) end },
		{ label = nkRebuffSettings.setName4, func = function() nkRebuff.activateSet (4) end },
		{ label = nkRebuffSettings.setName5, func = function() nkRebuff.activateSet (5) end },
		{ label = nkRebuffSettings.setName6, func = function() nkRebuff.activateSet (6) end }}
		
		nkManager.init('nkRebuff', items, nil)
		
		nkRebuff.performanceCheck()
				
		print (string.format(nkRebuffTexts.msgLoaded, nkRebuffTexts.version, nkRebuff.addonVersion))
	end
	
end

function nkRebuff.commandHandler(commandline)

	if string.find(commandline, 'config') ~= nil then
		if nkRebuff.configUI == nil then
			nkRebuff.configUI = nkRebuff.Config:new()
		else
			nkRebuff.configUI:Show(true)
		end
		
	elseif string.find(commandline, 'set=') ~= nil then
		local pos = string.find(commandline, 'set=')
		local setno = tonumber(string.sub(commandline, pos+4, string.len(commandline)))
		
		if setno < 1 or setno > 6 then
			print (string.format(nkRebuffTexts.commandSetRefuse, setno))
		else
			nkRebuff.activateSet (setno)
		end
	elseif string.find(commandline, 'resethidden') ~= nil then
		nkRebuff.buff.ResestAllHidden()
	elseif string.find(commandline, 'toggle') ~= nil then
		if nkRebuffSettings.active == true then nkRebuffSettings.active = false else nkRebuffSettings.active = true end		
		if nkRebuff.buffBar ~= nil then nkRebuff.buffBar.frame:SetVisible(nkRebuffSettings.active) end
		if nkRebuff.debuffBar ~= nil then nkRebuff.debuffBar.frame:SetVisible(nkRebuffSettings.active) end
		if nkRebuff.cooldownBar ~= nil then nkRebuff.cooldownBar.frame:SetVisible(nkRebuffSettings.active) end
		if nkRebuff.activeBar ~= nil then nkRebuff.activeBar.frame:SetVisible(nkRebuffSettings.active) end
		if nkRebuffSettings.debuffWarning == true and nkRebuff.debuffPlayerBar ~= nil then nkRebuff.debuffPlayerBar.frame:SetVisible(nkRebuffSettings.active) end
	elseif string.find(commandline, 'on') ~= nil then
		nkRebuffSettings.active = true
		if nkRebuff.buffBar ~= nil then nkRebuff.buffBar.frame:SetVisible(nkRebuffSettings.active) end 
		if nkRebuff.debuffBar ~= nil then nkRebuff.debuffBar.frame:SetVisible(nkRebuffSettings.active) end 
		if nkRebuff.cooldownBar ~= nil then nkRebuff.cooldownBar.frame:SetVisible(nkRebuffSettings.active) end
		if nkRebuff.activeBar ~= nil then nkRebuff.activeBar.frame:SetVisible(nkRebuffSettings.active) end
		if nkRebuffSettings.debuffWarning == true and nkRebuff.debuffPlayerBar ~= nil then nkRebuff.debuffPlayerBar.frame:SetVisible(nkRebuffSettings.active) end
	elseif string.find(commandline, 'off') ~= nil then
		nkRebuffSettings.active = false
		if nkRebuff.buffBar ~= nil then nkRebuff.buffBar.frame:SetVisible(nkRebuffSettings.active) end 		
		if nkRebuff.debuffBar ~= nil then nkRebuff.debuffBar.frame:SetVisible(nkRebuffSettings.active) end 		
		if nkRebuff.cooldownBar ~= nil then nkRebuff.cooldownBar.frame:SetVisible(nkRebuffSettings.active) end
		if nkRebuff.activeBar ~= nil then nkRebuff.activeBar.frame:SetVisible(nkRebuffSettings.active) end
		if nkRebuffSettings.debuffWarning == true and nkRebuff.debuffPlayerBar ~= nil then nkRebuff.debuffPlayerBar.frame:SetVisible(nkRebuffSettings.active) end
	else
		print (nkRebuff.addonName .. ' ' .. nkRebuffTexts.version .. ' ' .. nkRebuff.addonVersion)
		print (nkRebuffTexts.commandHelp1)
		print (nkRebuffTexts.commandHelp2)
		print (nkRebuffTexts.commandHelp3)
		print (nkRebuffTexts.commandHelp4)
	end
	
end

function nkRebuff.settingsHandler(addon) 

	if (addon == nkRebuff.addonName) then	
	
		local settings = {
			active = true,
			throttle = 1,
			combatOnly = false,
			buffData = {},
			buffData3rd = {},
			debuffData = {},
			cdData = {},
			roleSets = {},
			activeSet = 1,
			locked = true,
			autoSwitch = true,
			setName1 = nkRebuffTexts.set1,
			setName2 = nkRebuffTexts.set2,
			setName3 = nkRebuffTexts.set3,
			setName4 = nkRebuffTexts.set4,
			setName5 = nkRebuffTexts.set5,
			setName6 = nkRebuffTexts.set6,
			setsbuff = {},
			setsbuff3rd = {},
			setsdebuff = {},
			setsCD = {},
			debuffWarning = true,
			events = true,
			bars = {{runoutDuration = 6, noOfIcons = 7, xpos = 687, ypos = 315, scale = 100, noBorder = false, noLabel = false, bcolor = '000000', ccolor = '7F0000', lcolor = 'FFFFFF', fontsize =14, shortText = false, align = 'centered', cbFadein = false, alpha = 1 },
					{runoutDuration = 6, noOfIcons = 7, xpos = 687, ypos = 415, scale = 100, noBorder = false, noLabel = false, bcolor = '7F0000', ccolor = '7F0000', lcolor = 'FFFFFF', fontsize =14, shortText = false, align = 'centered', cbFadein = false, alpha = 1},
					{runoutDuration = 6, noOfIcons = 7, xpos = 687, ypos = 515, scale = 100, noBorder = false, noLabel = false, bcolor = '7F0000', ccolor = '7F0000', lcolor = 'FFFFFF', fontsize =14, shortText = false, align = 'centered', cbFadein = false, alpha = 1},
					{runoutDuration = 6, noOfIcons = 7, xpos = 687, ypos = 615, scale = 100, noBorder = false, noLabel = false, bcolor = '000000', ccolor = '7F0000', lcolor = 'FFFFFF', fontsize =14, shortText = false, align = 'centered', cbFadein = false, alpha = 1},
					{runoutDuration = 6, noOfIcons = 7, xpos = 687, ypos = 715, scale = 100, noBorder = false, noLabel = false, bcolor = '000000', ccolor = '7F0000', lcolor = 'FFFFFF', fontsize =14, shortText = false, align = 'centered', cbFadein = false, alpha = 1} }
		}
			
		if nkRebuffSettings == nil then
			nkRebuffSettings = settings
		else
			for k, v in pairs (settings) do if nkRebuffSettings[k] == nil then nkRebuffSettings[k] = v end end
		end
				
		if nkRebuffSettings.setsbuff[1] == nil then
			for idx = 1, 6, 1 do
				nkRebuffSettings.setsbuff[idx] = {}
				nkRebuffSettings.setsdebuff[idx] = {}
				nkRebuffSettings.setsCD[idx] = {}
			end
		end
		
		if 	nkRebuffSettings.setsbuff3rd[1] == nil then
			for idx = 1, 6, 1 do
				nkRebuffSettings.setsbuff3rd[idx] = {}
			end
		end

		if #nkRebuffSettings.bars == 4 then
			table.insert (nkRebuffSettings.bars, {runoutDuration = 6, noOfIcons = 7, xpos = 687, ypos = 715, scale = 100, noBorder = false, noLabel = false, bcolor = '000000', ccolor = '7F0000', lcolor = 'FFFFFF', fontsize =14, shortText = false, align = 'centered', cbFadein = false, alpha = 1} )
		end		
		
		nkRebuffSettings.addonVersion = nkRebuff.addonVersion
		
	end
		
end

function nkRebuff.eventHandler()
	
	if nkRebuffSettings.active == true and (nkRebuff.configUI == nil or nkRebuff.configUI:isVisible() == false) then
		if nkRebuffSettings.combatOnly == false or Inspect.System.Secure() == true then
			if nkRebuff.buff.changeOccured == false then
				if nkRebuff.buff.lastUpdate == nil then
					nkRebuff.buff.lastUpdate = Inspect.Time.Real()
					nkRebuff.buff.changeOccured = true
				else
					local tmpTime = Inspect.Time.Real()
					if nkTools.round((tmpTime - nkRebuff.buff.lastUpdate), 1) > nkRebuffSettings.throttle then
						nkRebuff.buff.changeOccured = true						
					end
				end
			end		
			
			if nkRebuff.buff.changeOccured then					
				nkRebuff.buff.lastUpdate = Inspect.Time.Real()
				nkRebuff.buff.changeOccured = false
							
				nkRebuff.buildBars()

				local buffs = {}
				buffs.activeAbilities = {}
				buffs.active = {}
				buffs.nearRunoutList = {}
				buffs.missing = {}
				buffs.debuffs = {}
				
				buffs.missingCount = 0
				buffs.nearRunoutListCount = 0
				buffs.debuffsCount = 0
				buffs.activeAbilitiesCount = 0
				
				if nkRebuff.performance.buffs == true or nkRebuff.performance.debuffs == true or nkRebuffSettings.debuffWarning == true then
					-- BUFFS VERARBEITEN
				
					local bufflist = Inspect.Buff.List("player")
					
					if bufflist then
						local buffDetails = Inspect.Buff.Detail("player", bufflist)
						for k, buff in pairs(buffDetails) do
							
							if nkRebuff.performance.buffs == true and nkRebuffSettings.buffData[buff.name] ~= nil and nkRebuffSettings.buffData[buff.name].hidden ~= true and nkRebuffSettings.setsbuff[nkRebuffSettings.activeSet][buff.name] == true then
								-- nur Relevant wenn getrackt werden soll						
								if buff.remaining == nil then
									buffs.active[buff.name] = buff
								elseif buff.remaining <= nkRebuffSettings.bars[1].runoutDuration then
									buffs.nearRunoutList[buff.name] = buff.remaining
								else
									buffs.active[buff.name] = buff
								end
							elseif nkRebuffSettings.debuffWarning == true and (buff.curse == true or buff.debuff == true) and nkRebuff.tempHides['debuff'][buff.name] == nil then
								buffs.debuffs[buff.name] = buff
								buffs.debuffsCount = buffs.debuffsCount + 1
							end						
							
							-- Check for active ability
							
							if nkRebuff.performance.cooldowns == true and buff.ability ~= nil then
								local details = Inspect.Ability.Detail(buff.ability)
								if details ~= nil then
									local name = string.gsub (details.name, '\n', ' ')
									if nkRebuffSettings.cdData[name] ~= nil and nkRebuffSettings.setsCD[nkRebuffSettings.activeSet][name] == true and nkRebuffSettings.buffData[buff.name].hidden ~= true then
										buffs.activeAbilities[name] = buff
										buffs.activeAbilitiesCount = buffs.activeAbilitiesCount + 1
									end
								end
							end
						end
					end
					
					if nkRebuff.performance.buffs == true then
						for name, buff in pairs(nkRebuffSettings.buffData) do
							if nkRebuffSettings.setsbuff[nkRebuffSettings.activeSet][name] == true and buffs.active[name] == nil and nkRebuff.tempHides['buff'][name] == nil then 
								buffs.missing[name] = buff
								buffs.missingCount = buffs.missingCount + 1
							end					
						end
					
						for name, buff in pairs(nkRebuffSettings.buffData3rd) do
							if nkRebuffSettings.setsbuff3rd[nkRebuffSettings.activeSet][name] == true and buffs.active[name] == nil and nkRebuff.tempHides['buff'][name] == nil then 
								buffs.missing[name] = buff
								buffs.missingCount = buffs.missingCount + 1
							end					
						end
					end
				end
				
				if nkRebuff.performance.buffs == true and (buffs.missingCount > 0 or buffs.nearRunoutListCount > 0) then 
					nkRebuff.processBuffs (buffs.missing, buffs.nearRunoutList)
				else
					if nkRebuff.buffBar ~= nil then nkRebuff.buffBar:SetVisible(false) end
				end
				
				if nkRebuffSettings.debuffWarning == true and buffs.debuffsCount > 0 then 
					nkRebuff.processDebuffsPlayer (buffs.debuffs) 
				else
					if nkRebuff.debuffPlayerBar ~= nil then nkRebuff.debuffPlayerBar:SetVisible(false) end
				end
				
				if nkRebuff.performance.debuffs == true then 
					nkRebuff.processDebuffs () 
				else
					if nkRebuff.debuffBar ~= nil then nkRebuff.debuffBar:SetVisible(false) end
				end
				
				if nkRebuff.performance.cooldowns == true then
					nkRebuff.processCooldowns()
				else
					if nkRebuff.cooldownBar ~= nil then nkRebuff.cooldownBar:SetVisible(false) end
				end
				
				if nkRebuff.performance.cooldowns == true and buffs.activeAbilitiesCount > 0 then
					nkRebuff.processAbilities(buffs.activeAbilities)
				else
					if nkRebuff.activeBar ~= nil then nkRebuff.activeBar:SetVisible(false) end
				end
			end			
		else
			if nkRebuff.buffBar ~= nil then nkRebuff.buffBar:SetVisible(false) end
			if nkRebuff.debuffBar ~= nil then nkRebuff.debuffBar:SetVisible(false) end
			if nkRebuff.debuffPlayerBar ~= nil then nkRebuff.debuffPlayerBar:SetVisible(false) end
			if nkRebuff.cooldownBar ~= nil then nkRebuff.cooldownBar:SetVisible(false) end
			if nkRebuff.activeBar ~= nil then nkRebuff.activeBar:SetVisible(false) end
		end
	end
	
end

function nkRebuff.calcIndex (counter, noOfIcons, align)
	
	local iconIndex = 0
	local iconCenter = math.floor(noOfIcons / 2)
	if math.floor(noOfIcons / 2) == noOfIcons / 2 then iconCenter = iconCenter -1  end
	
	if align == 'vertical' or align == 'left' then  
		iconIndex = counter
	elseif align == 'right' then
		iconIndex = noOfIcons - (counter-1)
	else
		if (counter / 2) == math.floor(counter/2) then
			iconIndex = math.floor(iconCenter + math.floor(counter / 2) + 1)
		else
			iconIndex = math.floor(iconCenter- math.floor(counter / 2) + 1)
		end
	end
	return iconIndex
end

function nkRebuff.processBuffs (missing, nearRunoutList)

	local counter = 1
	local iconIndex = 1
	
	for k, v in pairs(nkRebuff.buffBar.icons) do v:SetVisible(false) end								
	
	for name, buff in pairs (missing) do
		if counter <= (nkRebuffSettings.bars[1].noOfIcons) then
			iconIndex = nkRebuff.calcIndex (counter, nkRebuffSettings.bars[1].noOfIcons, nkRebuffSettings.bars[1].align)
			if nkRebuff.buffBar.icons[iconIndex] ~= nil then
				if nearRunoutList[name] ~= nil then	
					nkRebuff.buffBar.icons[iconIndex]:Update(1, { type = 'buff', label = name, texture = buff.icon, remaining = nearRunoutList[name], ability = buff.ability })
				else
					nkRebuff.buffBar.icons[iconIndex]:Update(1, { type = 'buff', label = name, texture = buff.icon, ability = buff.ability })
				end
			end
			
			counter = counter + 1
			
		end
	end
	
end

function nkRebuff.processDebuffs ()

	for k, v in pairs(nkRebuff.debuffBar.icons) do v:SetVisible(false) end

	local debuffs = {}
	debuffs.active = {}
	debuffs.nearRunoutList = {}
	debuffs.missing = {}
	
	local debuffList = Inspect.Buff.List('player.target')
					
	if debuffList then
		local debuffDetails = Inspect.Buff.Detail("player.target", debuffList)
		for k, debuff in pairs(debuffDetails) do
			local caster = debuff.caster
			local casterDetails = Inspect.Unit.Detail(caster)
			if casterDetails ~= nil and casterDetails.name == Inspect.Unit.Detail ('player').name then
				if nkRebuffSettings.debuffData[debuff.name] ~= nil and nkRebuffSettings.setsdebuff[nkRebuffSettings.activeSet][debuff.name] == true then
					if debuff.remaining == nil then
						debuffs.active[debuff.name] = buff
					elseif debuff.remaining <= nkRebuffSettings.bars[3].runoutDuration then
						debuffs.nearRunoutList[debuff.name] = debuff.remaining
					else
						debuffs.active[debuff.name] = debuff
					end
				end
			end
		end
	else
		for k, debuff in pairs(nkRebuffSettings.debuffData) do debuffs.active[k] = debuff end
	end

	for name, debuff in pairs(nkRebuffSettings.debuffData) do
		if nkRebuffSettings.setsdebuff[nkRebuffSettings.activeSet][name] == true and debuffs.active[name] == nil and nkRebuff.tempHides['debuff'][name] == nil then 
			debuffs.missing[name] = debuff 
		end					
	end
	
	local counter = 1
	local iconIndex = 1
	
	for name, buff in pairs (debuffs.missing) do
		if counter <= (nkRebuffSettings.bars[2].noOfIcons) then						
			iconIndex = nkRebuff.calcIndex (counter, nkRebuffSettings.bars[2].noOfIcons, nkRebuffSettings.bars[2].align)
			
			if nkRebuff.debuffBar.icons[iconIndex] ~= nil then
				if debuffs.nearRunoutList[name] ~= nil then	
					nkRebuff.debuffBar.icons[iconIndex]:Update(2, { type = 'debuff', label = name, texture = buff.icon, remaining = debuffs.nearRunoutList[name], ability = buff.ability })
				else
					nkRebuff.debuffBar.icons[iconIndex]:Update(2, { type = 'debuff', label = name, texture = buff.icon, ability = buff.ability })
				end
			end
			
			counter = counter + 1
			
		end
	end

end

function nkRebuff.processDebuffsPlayer (debuffs)

	local counter = 1
	local iconIndex = 1

	for k, v in pairs(nkRebuff.debuffPlayerBar.icons) do v:SetVisible(false) end

	if nkRebuffSettings.debuffWarning == true then
		for name, buff in pairs (debuffs) do					
			if counter <= (nkRebuffSettings.bars[3].noOfIcons) then							
				iconIndex = nkRebuff.calcIndex (counter, nkRebuffSettings.bars[3].noOfIcons, nkRebuffSettings.bars[3].align)
				
				if nkRebuff.debuffPlayerBar.icons[iconIndex] ~= nil then
					nkRebuff.debuffPlayerBar.icons[iconIndex]:Update(3, { type = 'debuff', label = name, texture = buff.icon, remaining = -1, desc = buff.description })
				end
				
				counter = counter + 1
				
			end
		end
	end
	
end

function nkRebuff.processCooldowns ()

	for k, v in pairs(nkRebuff.cooldownBar.icons) do v:SetVisible(false) end

	nkRebuff.CheckForCooldowns()
	
	local counter = 1
	local iconIndex = 1
	
	for ability, abilityInfo in pairs (nkRebuff.activeCDList) do
		if counter <= (nkRebuffSettings.bars[4].noOfIcons) then						
			iconIndex = nkRebuff.calcIndex (counter, nkRebuffSettings.bars[4].noOfIcons, nkRebuffSettings.bars[4].align)
			
			-- only consider spells of interest
			if nkRebuff.cooldownBar.icons[iconIndex] ~= nil then
				local remaining = abilityInfo.currentCooldownRemaining
				-- if the spell is on cooldown, we display it if the cooldown is less than the runout duration
				if remaining ~= nil then
					-- but we display it without a label if there's less than 1 second (ie, gcd) left
					if remaining <=  1.0 then
						nkRebuff.cooldownBar.icons[iconIndex]:Update(4, { type = 'cooldowns', label = abilityInfo.name, texture = abilityInfo.icon, ability = ability })
					else
						nkRebuff.cooldownBar.icons[iconIndex]:Update(4, { type = 'cooldowns', label = abilityInfo.name, texture = abilityInfo.icon, remaining = remaining, ability = ability })
					end

				-- always display spells off cooldown
				else
					nkRebuff.cooldownBar.icons[iconIndex]:Update(4, { type = 'cooldowns', label = abilityInfo.name, texture = abilityInfo.icon, ability = ability })
				end
			end
			
			counter = counter + 1
			
		end
	end

end

function nkRebuff.processAbilities(activeAbilities)

	local counter = 1
	local iconIndex = 1
	
	for k, v in pairs(nkRebuff.activeBar.icons) do v:SetVisible(false) end								
	
	for name, buff in pairs (activeAbilities) do
		if counter <= (nkRebuffSettings.bars[5].noOfIcons) then
			iconIndex = nkRebuff.calcIndex (counter, nkRebuffSettings.bars[5].noOfIcons, nkRebuffSettings.bars[5].align)
			if nkRebuff.activeBar.icons[iconIndex] ~= nil then
				nkRebuff.activeBar.icons[iconIndex]:Update(5, { type = 'cooldown', label = name, texture = buff.icon, remaining = buff.remaining, ability = buff.ability })
			end
			
			counter = counter + 1
		end
	end

end

function nkRebuff.abilityBar:new(index, settings)

	local this = settings or {}
	this.index = index
	
	local scale = nkRebuffSettings.bars[index].scale / 100
	local width, height = ((50 * nkRebuffSettings.bars[index].noOfIcons) + (30 * (nkRebuffSettings.bars[index].noOfIcons-1))) * scale , 50 * scale
	if nkRebuffSettings.bars[index].align == 'vertical' then width, height = 50 * scale, ((50 * nkRebuffSettings.bars[index].noOfIcons) + (30 * (nkRebuffSettings.bars[index].noOfIcons-1))) * scale end	
	
	local bar = UI.CreateFrame ('nkExtFrame', 'nkRebuffAbilityBar', nkRebuff.context, { layer = 1, width = width, height = height, anchors = {{from = "TOPLEFT", object = UIParent, to = "TOPLEFT", x = this.xpos, y = this.ypos}} })
	bar.moveframe = UI.CreateFrame ('nkExtFrame', 'nkRebuffAbilityBar', bar:getElement(false), { visible = false, layer = 2, color = { body = '0000FF', alphabody = 0.7}, width = width, height = height, anchors = {{from = "TOPLEFT", object = bar:getElement(), to = "TOPLEFT"}} })
	bar.moveIcon = UI.CreateFrame ('nkExtTexture', 'nkRebuffAbilityBarMoveIcon', bar.moveframe:getElement(false), { layer = 1, type = "nkRebuff", path = 'nkMoveIcon.png', alpha = 0.7, width = 20, height = 20, anchors = {{ from = "TOPLEFT", object = bar.moveframe:getElement(), to = "TOPLEFT"}} })
	bar.moveTitle = UI.CreateFrame ('nkExtText', 'nkRebuffAbilityBarMoveTitle', bar.moveframe:getElement(false), { layer = 2, text = settings.movelabel, color = 'FFFFFF', fontsize = 14, anchors = {{from = "CENTER", object = bar.moveframe:getElement(), to = "CENTER"}} })
	
	bar.moveframe:SetEvent('LeftDown', function()
		bar.MouseDown = true
		mouseData = Inspect.Mouse()
		if bar.anchors[1].x == nil then bar.anchors[1].x = 0 end
		if bar.anchors[1].y == nil then bar.anchors[1].y = 0 end
				
		bar.startX = mouseData.x - bar.anchors[1].x
		bar.startY = mouseData.y - bar.anchors[1].y
	end)
			
	bar.moveframe:SetEvent('MouseMove', function()
		if bar.MouseDown then
			mouseData = Inspect.Mouse()
			curdivX = mouseData.x - bar.startX
			curdivY = mouseData.y - bar.startY			
			bar.anchors[1].x = curdivX
			bar.anchors[1].y = curdivY
			bar:update ({ anchors = bar.anchors })
			
			settings.moveFunc (curdivX, curdivY)
		end
	end)
		
	bar.moveframe:SetEvent('LeftUp', function() if bar.MouseDown then bar.MouseDown = false end end)
	
	this.icons = {}
	local parent = bar:getElement()
	
	local anchors = {{ from = "TOPLEFT", object = parent, to = "TOPLEFT" }} 	
	
	for i = 1, nkRebuffSettings.bars[index].noOfIcons, 1 do
		local icon = nkRebuff.abilityIcon:new (index, { id = i, parent = parent, anchors = anchors })
		
		if nkRebuffSettings.bars[index].align == 'vertical' then		
			anchors = {{ from = "TOPLEFT", object = icon.element:getElement(false), to = "BOTTOMLEFT", x = 0, y = 30 * scale }} 
		else
			anchors = {{ from = "TOPLEFT", object = icon.element:getElement(false), to = "TOPRIGHT", x = 30 * scale, y = 0 }}
		end
		
		table.insert (this.icons, icon)
	end
	
	this.bar = bar
	
	setmetatable(this, self)
	self.__index = self
	return this

end

function nkRebuff.abilityBar:Update()

	local scale = nkRebuffSettings.bars[self.index].scale / 100
	local frameSize = 50 * scale
	local iconSize = frameSize - 4
	local fontsize = nkRebuffSettings.bars[self.index].fontsize * scale
	local width, height = ((50 * nkRebuffSettings.bars[self.index].noOfIcons) + (30 * (nkRebuffSettings.bars[self.index].noOfIcons-1))) * scale , 50 * scale
	if nkRebuffSettings.bars[self.index].align == 'vertical' then width, height = 50 * scale, ((50 * nkRebuffSettings.bars[self.index].noOfIcons) + (30 * (nkRebuffSettings.bars[self.index].noOfIcons-1))) * scale end	
	
	self.bar:update ({ visible = true, width = width, height = height, anchors = {{from = "TOPLEFT", object = UIParent, to = "TOPLEFT", x = self.xpos, y = self.ypos}} })
	self.bar.moveframe:update ({ width = width, height = height })
	
	local anchors = {{ from = "TOPLEFT", object = self.bar:getElement(), to = "TOPLEFT" }} 	

	local parent = self.bar:getElement()
	
	for i = 1, nkRebuffSettings.bars[self.index].noOfIcons, 1 do
		local icon = self.icons[i]
		if icon == nil then
			icon = nkRebuff.abilityIcon:new ({ id = i, parent = parent, anchors = anchors })
			table.insert (self.icons, icon)
		else
			icon.element:update({ anchors = anchors, width = frameSize, height = frameSize })
			icon.element.icon:update({ width = iconSize, height = iconSize })
			icon.element.counterShadow:update ({ fontsize = 30 * scale, anchors = {{ from = "CENTER", object = icon.element:getElement(), to = "CENTER", x = 2 * scale, y = 2 * scale} } })
			icon.element.counter:update ({ fontsize = 30 * scale })
	
			icon.element.label1:getElement():ClearAll()
			icon.element.label2:getElement():ClearAll()
			icon.element.label3:getElement():ClearAll()
			
			local showLabels = false
			if nkRebuffSettings.noLabel == false then showLabels = true end
			
			if nkRebuffSettings.bars[self.index].align == 'vertical' then  										
				icon.element.label1:update ( { visible = showLabels, anchors = {{ from = "CENTERLEFT", object = icon.element:getElement(), to = "CENTERRIGHT"}} })
				icon.element.label2:update ( { anchors = {{ from = "BOTTOMLEFT", object = icon.element.label1:getElement(), to = "TOPLEFT", x = 0, y = -3}} })				
				icon.element.label3:update ( { anchors = {{ from = "TOPLEFT", object = icon.element.label1:getElement(), to = "BOTTOMLEFT", x = 0, y = 3}} })
			else
				icon.element.label1:update ( { visible = showLabels, anchors = {{ from = "TOPCENTER", object = icon.element:getElement(), to = "BOTTOMCENTER"}} })
				icon.element.label2:update ( { anchors = {{ from = "TOPCENTER", object = icon.element.label1:getElement(), to = "BOTTOMCENTER", x = 0, y = 3}} })
				icon.element.label3:update ( { anchors = {{ from = "TOPCENTER", object = icon.element.label2:getElement(), to = "BOTTOMCENTER", x = 0, y = 3}} })
			end
		end
		
		if nkRebuffSettings.bars[self.index].align == 'vertical' then		
			anchors = {{ from = "TOPLEFT", object = icon.element:getElement(false), to = "BOTTOMLEFT", x = 0, y = 30 * scale }} 
		else
			anchors = {{ from = "TOPLEFT", object = icon.element:getElement(false), to = "TOPRIGHT", x = 30 * scale, y = 0 }}
		end

		end
	
	for i = nkRebuffSettings.bars[self.index].noOfIcons+1, 15, 1 do
		if self.icons[i] ~= nil then self.icons[i]:SetVisible(false) end
	end

end

function nkRebuff.abilityBar:setCoords ( xpos, ypos)

	self.xpos = xpos
	self.ypos = ypos

end

function nkRebuff.abilityBar:Moveable(flag)

	self.bar.moveframe:update ({ visible = flag })
	
	if flag == true then	
		for idx = 1, nkRebuffSettings.bars[self.index].noOfIcons, 1 do
			self.icons[idx]:Update(self.index, { moveable = true, label = 'label', type = 'buff' })
		end
	else
		for idx = 1, nkRebuffSettings.bars[self.index].noOfIcons, 1 do
			self.icons[idx].element:update({ visible = false })
		end
	end

end

function nkRebuff.abilityBar:SetVisible(flag) self.bar:SetVisible(flag) end
function nkRebuff.abilityBar:getElement() return self.bar:getElement() end

function nkRebuff.abilityIcon:new (index, settings)

	local this = settings or {}
	self.index = index
	
	local scale = nkRebuffSettings.bars[index].scale / 100
	local frameSize = 50 * scale
	local iconSize = frameSize - 4
	local fontsize = nkRebuffSettings.bars[index].fontsize * scale
	
	if nkRebuffSettings.bars[index].shortText == true then fontsize = fontsize + 2 end
		
	if nkRebuffSettings.bars[index].noBorder == true then 
		bgAlpha = 0 
		iconSize = 50 * scale
	else bgAlpha = 1 end
	
	local color = nkRebuffSettings.bars[index].bcolor
	
	local frame = UI.CreateFrame ('nkExtFrame', 'icon' .. this.id, this.parent, { width = frameSize, height = frameSize, color = { body = color, alphabody = bgAlpha }, anchors = this.anchors })
	frame:SetEvent('LeftClick', function () nkRebuff.tempHides[this.type][this.label] = true; if nkRebuff.tooltip ~= nil then nkRebuff.tooltip:SetVisible(false) end end )
	frame.icon = UI.CreateFrame('nkExtTexture', 'icon' .. this.id .. 'icon', frame:getElement(false), { layer = 1, width = iconSize, height = iconSize, anchors = {{ from = "CENTER", object = frame:getElement(false), to = "CENTER"}} })
	frame.counterShadow = UI.CreateFrame('nkExtText', 'icon' .. this.id .. 'counterShadow', frame:getElement(), { layer = 2, text = '9', fontsize = 30 * scale, color = "000000", anchors = {{ from = "CENTER", object = frame:getElement(), to = "CENTER", x = 2 * scale, y = 2 * scale} } })
	frame.counter = UI.CreateFrame('nkExtText', 'icon' .. this.id .. 'counter', frame.counterShadow:getElement(), { text = '9', fontsize = 30 * scale, color = nkRebuffSettings.bars[index].ccolor, anchors = {{ from = "CENTER", object = frame.icon:getElement(), to = "CENTER"}} })	
	
	local showLabels = false
	if nkRebuffSettings.bars[index].noLabel == false then showLabels = true end
	
	if nkRebuffSettings.bars[index].align == 'vertical' then
		frame.label1 = UI.CreateFrame ('nkExtText', 'icon' .. this.id .. 'label1', frame:getElement(false), {  visible = showLabels, autowidth = true, height = 12 * scale, text = 'dummy', fontsize = fontsize, color = nkRebuffSettings.bars[index].lcolor, anchors = {{ from = "CENTERLEFT", object = frame:getElement(), to = "CENTERRIGHT"}} })
		frame.label2 = UI.CreateFrame ('nkExtText', 'icon' .. this.id .. 'label2', frame.label1:getElement(), {autowidth = true, height = 12 * scale, text = 'dummy', fontsize = fontsize, color = nkRebuffSettings.bars[index].lcolor, anchors = {{ from = "BOTTOMLEFT", object = frame.label1:getElement(), to = "TOPLEFT", x = 0, y = -3}} })
		frame.label3 = UI.CreateFrame ('nkExtText', 'icon' .. this.id .. 'label3', frame.label2:getElement(), {autowidth = true, height = 12 * scale, text = 'dummy', fontsize = fontsize, color = nkRebuffSettings.bars[index].lcolor, anchors = {{ from = "TOPLEFT", object = frame.label1:getElement(), to = "BOTTOMLEFT", x = 0, y = 3}} })
	else
		frame.label1 = UI.CreateFrame ('nkExtText', 'icon' .. this.id .. 'label1', frame:getElement(false), { visible = showLabels, autowidth = true, height = 12 * scale, text = 'dummy', fontsize = fontsize, color = nkRebuffSettings.bars[index].lcolor, anchors = {{ from = "TOPCENTER", object = frame:getElement(), to = "BOTTOMCENTER"}} })
		frame.label2 = UI.CreateFrame ('nkExtText', 'icon' .. this.id .. 'label2', frame.label1:getElement(), {autowidth = true, height = 12 * scale, text = 'dummy', fontsize = fontsize, color = nkRebuffSettings.bars[index].lcolor, anchors = {{ from = "TOPCENTER", object = frame.label1:getElement(), to = "BOTTOMCENTER", x = 0, y = 3}} })
		frame.label3 = UI.CreateFrame ('nkExtText', 'icon' .. this.id .. 'label3', frame.label2:getElement(), {autowidth = true, height = 12 * scale, text = 'dummy', fontsize = fontsize, color = nkRebuffSettings.bars[index].lcolor, anchors = {{ from = "TOPCENTER", object = frame.label2:getElement(), to = "BOTTOMCENTER", x = 0, y = 3}} })
	end	

	frame.element:SetAlpha(nkRebuffSettings.bars[index].alpha)
	
	this.element = frame

	setmetatable(this, self)
	self.__index = self
	return this
	
end

function nkRebuff.abilityIcon:SetVisible (flag) self.element:SetVisible(flag) end

function nkRebuff.abilityIcon:Update (index, settings)

	if settings == nil then return end
	self.type = settings.type
	self.label = settings.label
	
	self.element:SetEvent('MouseIn', function() 
		local desc = ''
		if settings.desc ~= nil then desc = settings.desc else
			if settings.ability ~= nil then
				local abilityInfo = Inspect.Ability.Detail(settings.ability)			
				if abilityInfo ~= nil then desc = abilityInfo.description end
			end
		end
		
		local color = 'FFFFFF'
		if settings.type == 'buff' then
			color = '00FF21'
		elseif settings.type == 'debuff' then
			color = 'FF0000'
		elseif settings.type == 'cooldowns' then
			color = '0094FF'
		end
		
		nkRebuff.showTooltip(nkRebuffSettings.bars[index].align, self.element:getElement(), self.label, color, desc, nkRebuffTexts.iconHelp)
	end)
	
	self.element:SetEvent('MouseOut', function() 
		if nkRebuff.tooltip ~= nil then nkRebuff.tooltip:SetVisible(false) end
	end)

	local color = nkRebuffSettings.bars[index].bcolor
	
	if settings.remaining == -1 then
		if self.blink == true then
			self.blink = false
			bgAlpha = 0
		else
			self.blink = true
			bgAlpha = nkRebuffSettings.bars[index].alpha
		end
	elseif nkRebuffSettings.bars[index].noBorder == true then 
		bgAlpha = 0 
	else 
		bgAlpha = 1
	end
	
	self.element:update ({ color = { body = color, alphabody = bgAlpha } })

	local temp = nil
	
	if nkRebuffSettings.bars[index].noLabel == false then
		if nkRebuffSettings.bars[index].shortText == true then
			local tempValue = ''
			local shortenedText = ''
			if string.find (settings.label, ' ') == nil and string.find(settings.label, '-') ~= nil then
				 tempValue = string.split(settings.label, '-')
			else
				 tempValue = string.split(settings.label, ' ')
			end
			
			for idx2 = 1, #tempValue, 1 do
				shortenedText = shortenedText .. string.sub (tempValue[idx2], 1, 1)
			end		
			temp = {shortenedText}
		else
			temp = string.split(settings.label, ' ' )
			if string.find (settings.label, ' ') == nil and string.find(settings.label, '-') ~= nil then temp = string.split(settings.label, '-') end
		end

		if nkRebuffSettings.bars[index].align == 'vertical' then		
			if temp[3] ~= nil then 
				temp[2], temp[1] = temp[1], temp[2] 
			elseif temp[2] ~= nil then
				temp[2], temp[1] = temp[1], temp[2] 
			end
		end
		
		for idx = 1, 3, 1 do if temp[idx] == nil then temp[idx] = '' end end
				
		self.element.label1:update ({ visible = true, text = temp[1], color = nkRebuffSettings.bars[index].lcolor })
		self.element.label2:update ({ text = temp[2], color = nkRebuffSettings.bars[index].lcolor })
		self.element.label3:update ({ text = temp[3], color = nkRebuffSettings.bars[index].lcolor })
	end
	
	if settings.moveable == true then	
		self.element.icon:SetTexture({ type = "nkRebuff", path = 'nkMoveBuff.png' })		
	else
		self.element.icon:SetTexture({ type = "Rift", path = settings.texture })
	end
		
	if settings.remaining == nil or settings.remaining == -1 then 	
		self.element.counterShadow:SetVisible(false)
		self.element:getElement():SetAlpha ( nkRebuffSettings.bars[index].alpha ) 
	else
		local remainlabel = tostring(nkTools.round(settings.remaining, 0))
		
		local scale = nkRebuffSettings.bars[index].scale / 100
		local fontsize = 30 * scale
		if nkTools.round(settings.remaining, 0) < 10 then fontsize = 40 * scale end
		
		self.element.counterShadow:update({ text = remainlabel, fontsize = fontsize })
		self.element.counter:update({ text = remainlabel, fontsize = fontsize })
				
		self.element.counterShadow:SetVisible(true)
		if nkRebuffSettings.bars[index].cbFadein == true then self.element:getElement():SetAlpha ( nkRebuffSettings.bars[index].alpha - (nkRebuffSettings.bars[index].alpha / nkRebuffSettings.bars[index].runoutDuration * settings.remaining)) end
	end
	
	self:SetVisible(true)

end

function nkRebuff.activateSet (set)
	print (string.format(nkRebuffTexts.commandSetAccept, nkRebuffSettings['setName' .. set]))
	nkRebuffSettings.activeSet = set
	nkRebuff.buff.changeOccured = true		
	
	nkRebuff.performanceCheck()
	
	if nkRebuff.nkButton ~= nil then nkRebuff.nkButton.element.menu:SetVisible(false) end
	if nkRebuff.configUI ~= nil then nkRebuff.configUI:Update() end
	
end

function nkRebuff.CooldownBegin (cooldowns)
		
	for ability, cd in pairs (cooldowns) do
		if cd > 1 then
			local abilityInfo = Inspect.Ability.Detail(ability)
			if abilityInfo ~= nil then 
				
				local name = string.gsub (abilityInfo.name, '\n', ' ')
				
				if nkRebuffSettings.cdData[name] == nil then
					nkRebuffSettings.cdData[name] = { ability = ability, icon = abilityInfo.icon, duration = 0, hidden = false }
					
					for i = 1, 6, 1 do
						if nkRebuffSettings.setsCD[i] == nil then nkRebuffSettings.setsCD[i] = {} end
						nkRebuffSettings.setsCD[i][name] = false
					end
				end
			end
		end
	end
	
end

function nkRebuff.CheckForCooldowns ()

	nkRebuff.activeCDList = {}

	for k, v in pairs (nkRebuffSettings.cdData) do
		
		if nkRebuffSettings.setsCD[nkRebuffSettings.activeSet][k] == true then
		
			local details = Inspect.Ability.Detail(v.ability)
			if details ~= nil then
				if nkRebuff.activeCDList[v.ability] == nil then
					if details.currentCooldownRemaining == nil or details.currentCooldownRemaining < nkRebuffSettings.bars[4].runoutDuration then
						nkRebuff.activeCDList[v.ability] = details
					end
				end
			end
		end
		
	end

end

function nkRebuff.showTooltip(orientation, parent, title, color, descText, helpText)

	local anchors = {{ from = "TOPLEFT", object = parent, to = "BOTTOMLEFT" }}
	if orientation == 'vertical' then
		anchors = {{ from = "TOPLEFT", object = parent, to = "TOPRIGHT" }}
	end
	
	if nkRebuff.tooltip == nil then nkRebuff.tooltip = UI.CreateFrame('nkExtItemTooltip', 'nkRebuffTooltip', parent, {}) end
	
	local lines = { { text = descText, width = 300 } }
	local addInfoLines = { { text = '', width = 300, height = 8 }, { text = helpText, width = 300 } }
	
	nkRebuff.tooltip:update ({ parent = parent, title = title, titleColor = color, lines = lines, addInfoLines = addInfoLines, anchors = anchors })
	
end

function nkRebuff.performanceCheck()

	nkRebuff.performance = { buffs = false, cooldowns = false, debuffs = false }

	for k, v in pairs (nkRebuffSettings.setsbuff[nkRebuffSettings.activeSet]) do
		if v == true then
			nkRebuff.performance.buffs = true
			break
		end
	end
	
	if nkRebuff.performance.buffs == false then	
		for k, v in pairs (nkRebuffSettings.setsbuff3rd[nkRebuffSettings.activeSet]) do
			if v == true then
				nkRebuff.performance.buffs = true
				break
			end
		end
	end
	
	for k, v in pairs (nkRebuffSettings.setsdebuff[nkRebuffSettings.activeSet]) do
		if v == true then
			nkRebuff.performance.debuffs = true
			break
		end
	end
	
	for k, v in pairs (nkRebuffSettings.setsCD[nkRebuffSettings.activeSet]) do
		if v == true then
			nkRebuff.performance.cooldowns = true
			break
		end
	end

end

function nkRebuff.buildBars ()

	if nkRebuff.performance.buffs == true then
		if nkRebuff.buffBar == nil then 
			nkRebuff.buffBar = nkRebuff.abilityBar:new(1, { movelabel = nkRebuffTexts.barLabelBuffs, xpos = nkRebuffSettings.bars[1].xpos, ypos = nkRebuffSettings.bars[1].ypos, moveFunc = function (xpos, ypos) nkRebuffSettings.bars[1].xpos = xpos; nkRebuffSettings.bars[1].ypos = ypos; nkRebuff.buffBar:setCoords(xpos, ypos) end }) 
		else 
			nkRebuff.buffBar:SetVisible(true)
		end
	end
	
	if nkRebuff.performance.debuffs == true then
		if nkRebuff.debuffBar == nil then 
			nkRebuff.debuffBar = nkRebuff.abilityBar:new(2, { movelabel = nkRebuffTexts.barLabelDebuffs, xpos = nkRebuffSettings.bars[2].xpos, ypos = nkRebuffSettings.bars[2].ypos, moveFunc = function (xpos, ypos) nkRebuffSettings.bars[2].xpos = xpos; nkRebuffSettings.bars[2].ypos = ypos; nkRebuff.debuffBar:setCoords(xpos, ypos) end })
		else
			nkRebuff.debuffBar:SetVisible(true)
		end
	end
	
	if nkRebuff.performance.cooldowns == true then
		if nkRebuff.cooldownBar == nil then 
			nkRebuff.cooldownBar = nkRebuff.abilityBar:new(4, { movelabel = nkRebuffTexts.barLabelCooldowns, xpos = nkRebuffSettings.bars[4].xpos, ypos = nkRebuffSettings.bars[4].ypos, moveFunc = function (xpos, ypos) nkRebuffSettings.bars[4].xpos = xpos; nkRebuffSettings.bars[4].ypos = ypos; nkRebuff.cooldownBar:setCoords(xpos, ypos) end })
		else
			nkRebuff.cooldownBar:SetVisible(true)
		end
	
		if nkRebuff.activeBar == nil then
			nkRebuff.activeBar = nkRebuff.abilityBar:new(5, { movelabel = nkRebuffTexts.barLabelActive, xpos = nkRebuffSettings.bars[5].xpos, ypos = nkRebuffSettings.bars[5].ypos, moveFunc = function (xpos, ypos) nkRebuffSettings.bars[5].xpos = xpos; nkRebuffSettings.bars[5].ypos = ypos; nkRebuff.activeBar:setCoords(xpos, ypos) end })
		else
			nkRebuff.activeBar:SetVisible(true)
		end
	end

	if nkRebuffSettings.debuffWarning == true then
		if nkRebuff.debuffPlayerBar == nil then 
			nkRebuff.debuffPlayerBar = nkRebuff.abilityBar:new(3, { movelabel = nkRebuffTexts.barLabelDebuffsPlayer, xpos = nkRebuffSettings.bars[3].xpos, ypos = nkRebuffSettings.bars[3].ypos, moveFunc = function (xpos, ypos) nkRebuffSettings.bars[3].xpos = xpos; nkRebuffSettings.bars[3].ypos = ypos; nkRebuff.debuffPlayerBar:setCoords(xpos, ypos) end })
		else 
			nkRebuff.debuffPlayerBar:SetVisible(true)
		end
	end

end

table.insert(Event.Addon.Load.End, {nkRebuff.main, "nkRebuff", "addonLoaded"})
table.insert(Command.Slash.Register("nkRebuff"), {nkRebuff.commandHandler, "nkRebuff", "config"})
table.insert(Event.Addon.SavedVariables.Load.End, {nkRebuff.settingsHandler, "nkRebuff", "vaiablesLoaded"})
table.insert(Event.Ability.Cooldown.Begin, { nkRebuff.CooldownBegin, "nkRebuff", "CDBegin"})
