---------------------
-- Variables
---------------------

_targetcastbar = {}
_targetcastbar.version = "1.6.1"

local PrevCastbar = Inspect.Unit.Castbar("player.target")
local PrevCaster = nil
local Remaining = 0
local Couner = 0
local xPixels = 240
local yPixels = 32

_targetcastbar.configMode = false
_targetcastbar.configModeBar = "INT"

local fHeight = yPixels
local fWidth = xPixels

local defaults = {
	x=(UIParent:GetWidth()-xPixels)/2, y=(UIParent:GetHeight()-yPixels)/2,
	t="TARGET",
	scale=1,
	m="FILL",
	tsize=17,
	details="",
	cols={
		bi_r=0,
		bi_g=0.3,
		bi_b=0.52,
		bu_r=0.9,
		bu_g=0.8,
		bu_b=0.2,
		ti_r=1,
		ti_g=0.95,
		ti_b=0,
		tu_r=1,
		tu_g=0,
		tu_b=0
	},
	alpha={
		bi=1,
		ti=1,
		bu=1,
		tu=1,
		bar=0.75,
	},
	nl=1,
	bd="Y",
	bg="Y",
	chnl="Y",
	texture="N",
	texturename="LiteStep.tga",
	truncate="N",
	align="C",
	show="ALL",
	dp=2,
	sz="DEFAULT",
	custom = {
		sx=120,
		sy=120
	}
}

local adelea = {
	align = "C",alpha = {bar = 0.8,bi = 0.75,bu = 1,ti = 1,	tu = 1},bd = "Y",chnl = "N",
	cols = {bi_b = 0.5,bi_g = 0,bi_r = 0,bu_b = 0,bu_g = 0.42,bu_r = 1,ti_b = 1,ti_g = 1,ti_r = 1,tu_b = 1,tu_g = 1,tu_r = 1},
	custom = {sx = 300,sy = 20},details = "rt",dp = 2,m = "DEPLETE",nl = 1,scale = 2.5,show = "ALL",
	sz = "DEFAULT",t = "TARGET",texture = "Y",truncate = "N",tsize = 12,x = 896.75012207031,y = 1065.2498779297, texturename = "LiteStep.tga"
}

local TCBBU_Settings = {}

-- Set defaults for saved variables
if (not TCB_Settings) then
	TCB_Settings = defaults
end

if (not TCB_Profiles) then
	TCB_Profiles = {}
end
---------------------
-- Utilities
---------------------

function _targetcastbar.Resize()
	if TCB_Settings.sz == "DEFAULT" then
		fWidth = xPixels*TCB_Settings.scale
		fHeight = yPixels*TCB_Settings.scale
		_targetcastbar.TCBFrame.text:SetFontSize(TCB_Settings.tsize*TCB_Settings.scale)
	else
		fWidth = TCB_Settings.custom.sx
		fHeight = TCB_Settings.custom.sy
		_targetcastbar.TCBFrame.text:SetFontSize(TCB_Settings.tsize)
	end
	_targetcastbar.TCBFrame:SetWidth(fWidth)
	_targetcastbar.TCBFrame:SetHeight(fHeight)
	_targetcastbar.TCBFrameTexture:SetWidth(fWidth)
	_targetcastbar.TCBFrameTexture:SetHeight(fHeight)
	_targetcastbar.TCBFrame.solid:SetHeight(fHeight)
	_targetcastbar.TCBFrame.background:SetWidth(fWidth)
	_targetcastbar.TCBFrame.background:SetHeight(fHeight)
	_targetcastbar.TCBFrame.borderT:SetHeight(2)
	_targetcastbar.TCBFrame.borderT:SetWidth(fWidth+4)
	_targetcastbar.TCBFrame.borderB:SetHeight(2)
	_targetcastbar.TCBFrame.borderB:SetWidth(fWidth+4)
	_targetcastbar.TCBFrame.borderL:SetHeight(fHeight+4)
	_targetcastbar.TCBFrame.borderL:SetWidth(2)
	_targetcastbar.TCBFrame.borderR:SetHeight(fHeight+4)
	_targetcastbar.TCBFrame.borderR:SetWidth(2)
end

function _targetcastbar.SetupFrames()
	_targetcastbar.context = UI.CreateContext("TCB")
	_targetcastbar.TCBFrame = UI.CreateFrame("Frame", "_targetcastbar.TCBFrame", _targetcastbar.context)
	_targetcastbar.TCBFrameTexture = UI.CreateFrame("Texture", "_targetcastbar.TCBFrame", _targetcastbar.TCBFrame)
	
	_targetcastbar.TCBFrame:SetLayer(0)
	_targetcastbar.TCBFrame:SetPoint("CENTER", UIParent, "CENTER", 0,0)
	_targetcastbar.TCBFrame:SetAlpha(TCB_Settings.alpha.bar)
	_targetcastbar.TCBFrame:SetVisible(false)

	_targetcastbar.TCBFrameTexture:SetPoint("CENTER", _targetcastbar.TCBFrame, "CENTER", 0,0)
	_targetcastbar.TCBFrameTexture:SetLayer(-3)
	
	_targetcastbar.TCBFrame.borderT = UI.CreateFrame("Frame", "borderT", _targetcastbar.TCBFrame)
	_targetcastbar.TCBFrame.borderT:SetLayer(-5)
	_targetcastbar.TCBFrame.borderT:SetPoint("TOPLEFT", _targetcastbar.TCBFrame, "TOPLEFT", -2,-2)
	_targetcastbar.TCBFrame.borderT:SetBackgroundColor(0,0,0,0.75)
	
	_targetcastbar.TCBFrame.borderL = UI.CreateFrame("Frame", "borderL", _targetcastbar.TCBFrame)
	_targetcastbar.TCBFrame.borderL:SetLayer(-5)
	_targetcastbar.TCBFrame.borderL:SetPoint("TOPLEFT", _targetcastbar.TCBFrame, "TOPLEFT", -2,-2)
	_targetcastbar.TCBFrame.borderL:SetBackgroundColor(0,0,0,0.75)

	_targetcastbar.TCBFrame.borderB = UI.CreateFrame("Frame", "borderB", _targetcastbar.TCBFrame)
	_targetcastbar.TCBFrame.borderB:SetLayer(-5)
	_targetcastbar.TCBFrame.borderB:SetPoint("BOTTOMRIGHT", _targetcastbar.TCBFrame, "BOTTOMRIGHT", 2,2)
	_targetcastbar.TCBFrame.borderB:SetBackgroundColor(0,0,0,0.75)

	_targetcastbar.TCBFrame.borderR = UI.CreateFrame("Frame", "borderR", _targetcastbar.TCBFrame)
	_targetcastbar.TCBFrame.borderR:SetLayer(-5)
	_targetcastbar.TCBFrame.borderR:SetPoint("BOTTOMRIGHT", _targetcastbar.TCBFrame, "BOTTOMRIGHT", 2,2)
	_targetcastbar.TCBFrame.borderR:SetBackgroundColor(0,0,0,0.75)
	
	_targetcastbar.TCBFrame.text = UI.CreateFrame("Text", "Text", _targetcastbar.TCBFrame)
	_targetcastbar.TCBFrame.text:SetLayer(1)
	_targetcastbar.TCBFrame.text:SetFontSize(20)
	_targetcastbar.TCBFrame.text:SetVisible(true)

	_targetcastbar.TCBFrame.solid = UI.CreateFrame("Frame", "Solid", _targetcastbar.TCBFrame)
	_targetcastbar.TCBFrame.solid:SetLayer(-1)  -- Put it behind every other element.
	_targetcastbar.TCBFrame.solid:SetPoint("TOPLEFT", _targetcastbar.TCBFrame, "TOPLEFT", 0,0)
	_targetcastbar.TCBFrame.solid:SetVisible(true)
	
	_targetcastbar.TCBFrame.background = UI.CreateFrame("Frame", "Background", _targetcastbar.TCBFrame)
	_targetcastbar.TCBFrame.background:SetLayer(-2)  -- Put it behind every other element.
	_targetcastbar.TCBFrame.background:SetPoint("TOPLEFT", _targetcastbar.TCBFrame, "TOPLEFT", 0,0)
	_targetcastbar.TCBFrame.background:SetVisible(true)

	-- movement code stolen/adapted from MinUI, which credits Gumaden.
	function _targetcastbar.TCBFrame.Event:LeftDown()
		if not _targetcastbar.configMode then
			return
		end
		self.MouseDown = true
		mouseData = Inspect.Mouse()
		self.sx = mouseData.x - _targetcastbar.TCBFrame:GetLeft()
		self.sy = mouseData.y - _targetcastbar.TCBFrame:GetTop()
	end

	function _targetcastbar.TCBFrame.Event:MouseMove()
		if not _targetcastbar.configMode then
			return
		end
		if self.MouseDown then
			local nx, ny
			mouseData = Inspect.Mouse()
			nx = mouseData.x - self.sx
			ny = mouseData.y - self.sy
			_targetcastbar.TCBFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx, ny)
		end
	end

	function _targetcastbar.TCBFrame.Event:LeftUp()
		if not _targetcastbar.configMode then
			return
		end
		if self.MouseDown then
			self.MouseDown = false
		end
		TCB_Settings.x = _targetcastbar.TCBFrame:GetLeft()
		TCB_Settings.y = _targetcastbar.TCBFrame:GetTop()
	end
end

---------------------
-- Slash Commands
---------------------

function _targetcastbar.SlashHandler(args)
	local r = {}
	local numargs = 0
	for token in string.gmatch(args, "[^%s]+") do
		r[numargs] = token
		numargs=numargs+1
	end
	if numargs>0 then
		if r[0] == "this" then
			local d = Inspect.Unit.Lookup("player.target")
			if not d then
				print("No such target...")
				return
			end
			TCB_Settings.t = "THIS"
			_targetcastbar.uid = Inspect.Unit.Lookup("player.target")
			print("Watching UID: ".._targetcastbar.uid.." as target")
			return
		end
		if r[0] == "focus" then
			print("TCB watching FOCUS target")
			TCB_Settings.t = "FOCUS"
			return
		end
		if r[0] == "targettarget" then
			print("TCB watching targets target")
			TCB_Settings.t = "TARGETTARGET"
			return
		end
		if r[0] == "target" then
			print("TCB watching TARGET as target")
			TCB_Settings.t = "TARGET"
			return
		end
		if r[0] == "scale" then
			if numargs == 1 then				
				if TCB_Settings.sz == "CUSTOM" then
					TCB_Settings.sz = "DEFAULT"
					_targetcastbar.Resize()
					print "Reverting to scaled barsize mode"
				else
					print("Current scale = "..TCB_Settings.scale)
				end
			else
				local n = tonumber(r[1])
				if n and n > 0 then
					TCB_Settings.scale = n
					_targetcastbar.Resize()
				else
					print("That is not a number...")
				end
			end
			return
		end
		if r[0] == "fill" then
			TCB_Settings.m = "FILL"
			print("Now filling castbar as spell progresses")
			return
		end
		if r[0] == "deplete" then
			TCB_Settings.m = "DEPLETE"
			print("Now emptying castbar as spell progresses")
			return
		end
		if r[0] == "textsize" then
			if numargs == 1 then
				print("TCB Text size scale = "..TCB_Settings.tsize)
			else
				local n = tonumber(r[1])
				if n and n > 0 then
					TCB_Settings.tsize = n
					_targetcastbar.Resize()
				else
					print("That is not a number...")
				end
			end
			return
		end
		if r[0] == "remain/total" then
			TCB_Settings.details = "rt"
			print("Will show remaining and total time with spell name")
			return
		end
		if r[0] == "remain" then
			TCB_Settings.details = "r"
			print("Will show remaining time with spell name")
			return
		end
		if r[0] == "total" then
			TCB_Settings.details = "t"
			print("Will show total time with spell name")
			return
		end
		if r[0] == "nameonly" then
			TCB_Settings.details = ""
			print("Will show spell name only")
			return
		end
		if r[0] == "targetname" then
			TCB_Settings.details = "n"
			print("Will show spell name and target name")
			return
		end
		if r[0] == "col" then
			if (numargs ==5) or (numargs==6) then
				local cr,cg,cb,ca,tt,ti,ta
				cr=tonumber(r[2])
				cg=tonumber(r[3])
				cb=tonumber(r[4])
				if numargs==6 then
					ca=tonumber(r[5])
					if (not ca) or (ca<=0 or ca>1) then
						print "Alpha must be >0 and <=1"
						return
					end
					ta=string.format(",a=%.2f", ca)
				else
					ca=nil
					ta=""
				end
				if cr and cg and cb and cr>=0 and cr<=1 and cg>=0 and cg<=1 and cb>=0 and cb<=1 then
					if r[1] == "bi" then
						TCB_Settings.cols.bi_r=cr
						TCB_Settings.cols.bi_g=cg
						TCB_Settings.cols.bi_b=cb
						tt="bar"
						ti=""
						if ca then
							TCB_Settings.alpha.bi = ca
						end
					elseif r[1] == "bu" then
						TCB_Settings.cols.bu_r=cr
						TCB_Settings.cols.bu_g=cg
						TCB_Settings.cols.bu_b=cb
						tt="bar"
						ti="non-"
						if ca then
							TCB_Settings.alpha.bu = ca
						end
					elseif r[1] == "ti" then
						TCB_Settings.cols.ti_r=cr
						TCB_Settings.cols.ti_g=cg
						TCB_Settings.cols.ti_b=cb
						tt="text"
						ti=""
						if ca then
							TCB_Settings.alpha.ti = ca
						end
					elseif r[1] == "tu" then
						TCB_Settings.cols.tu_r=cr
						TCB_Settings.cols.tu_g=cg
						TCB_Settings.cols.tu_b=cb
						tt="text"
						ti="non-"
						if ca then
							TCB_Settings.alpha.ti = ca
						end
					else
						print "\t/tcb col bi|ti|bu|tu R G B [A]"
						return
					end
					print(string.format("Setting %s color for %sinterruptible spells to (r=%.2f,g=%.2f,b=%.2f%s)", tt, ti, cr,cg,cb,ta))
				else
					print "\t/tcb col bi|ti|bu|tu R G B [A]"
				end
			else
				print "\t/tcb col bi|ti|bu|tu R G B [A]"
			end
			return
		end
		if r[0] == "reset" then
			TCB_Settings = {}
			TCB_Settings = _MiscUtility.CopyTable(defaults)
			_targetcastbar.Resize()
			return
		end
		if r[0] == "lines" then
			if TCB_Settings.nl == 1 then
				TCB_Settings.nl = 2
				print("Displaying castbar text over 2 lines")
			else
				TCB_Settings.nl = 1
				print("Displaying castbar text on 1 line")
			end
			return
		end
		if r[0] == "channel" then
			if TCB_Settings.chnl == "Y" then
				print "Channeled spells operate the same as non-channeled"
				TCB_Settings.chnl = "N"
			else
				print "Channeled spells operate in reverse of non-channeled"
				TCB_Settings.chnl = "Y"
			end
			return
		end
		if r[0] == "border" then
			if TCB_Settings.bd == "Y" then
				print "Now hiding border"
				TCB_Settings.bd = "N"
			else
				print "Now showing border"
				TCB_Settings.bd = "Y"
			end
			_targetcastbar.TCBFrame.borderT:SetVisible((TCB_Settings.bd=="Y"))
			_targetcastbar.TCBFrame.borderB:SetVisible((TCB_Settings.bd=="Y"))
			_targetcastbar.TCBFrame.borderL:SetVisible((TCB_Settings.bd=="Y"))
			_targetcastbar.TCBFrame.borderR:SetVisible((TCB_Settings.bd=="Y"))
			return
		end
		if r[0] == "background" then
			local m
			if TCB_Settings.bg == "Y" then
				m = "Now hiding background"
				TCB_Settings.bg = "N"
			else
				m = "Now showing background"
				TCB_Settings.bg = "Y"
			end
			if TCB_Settings.texture == "Y" then
				m = m.." (and texture)"
			end
			print (m)
			_targetcastbar.TCBFrame.background:SetVisible((TCB_Settings.bg == "Y"))
			_targetcastbar.TCBFrameTexture:SetVisible((TCB_Settings.texture == "Y") and (TCB_Settings.bg == "Y"))
			return
		end
		if r[0] == "texture" then
			if TCB_Settings.texture == "Y" then
				print "Now using plain bar."
				TCB_Settings.texture = "N"
			else
				print "Now using textured bar."
				TCB_Settings.texture = "Y"
			end
			_targetcastbar.TCBFrameTexture:SetVisible((TCB_Settings.texture == "Y") and (TCB_Settings.bg == "Y"))
			return
		end
		if r[0] == "truncate" then
			if TCB_Settings.truncate == "Y" then
				print "Allowing bar text to overflow when required."
				TCB_Settings.truncate = "N"
			else
				print "Truncating bar text when required."
				TCB_Settings.truncate = "Y"
			end
			return
		end
		if r[0] == "align" then
			if not r[1] then
				print("Current alignment mode: "..TCB_Settings.align)
				return
			end
			if r[1] == "L" then
				TCB_Settings.align = "L"
				_targetcastbar.TCBFrame.text:ClearPoint("CENTER")
				_targetcastbar.TCBFrame.text:ClearPoint("CENTERRIGHT")
				_targetcastbar.TCBFrame.text:SetPoint("CENTERLEFT", _targetcastbar.TCBFrame, "CENTERLEFT",0,0)
				print "Aligning text to LEFT"
			elseif r[1] == "C" then
				TCB_Settings.align = "C"
				_targetcastbar.TCBFrame.text:ClearPoint("CENTERLEFT")
				_targetcastbar.TCBFrame.text:ClearPoint("CENTERRIGHT")
				_targetcastbar.TCBFrame.text:SetPoint("CENTER", _targetcastbar.TCBFrame, "CENTER",0,0)
				print "Aligning text to CENTER"
			elseif r[1] == "R" then
				TCB_Settings.align = "R"
				_targetcastbar.TCBFrame.text:ClearPoint("CENTER")
				_targetcastbar.TCBFrame.text:ClearPoint("CENTERLEFT")
				_targetcastbar.TCBFrame.text:SetPoint("CENTERRIGHT", _targetcastbar.TCBFrame, "CENTERRIGHT",0,0)
				print "Aligning text to RIGHT"
			else
				print("Unknown alignment mode: "..r[1])
			end
			return
		end
		if r[0] == "interrupt" then
			if TCB_Settings.show == "ALL" then
				TCB_Settings.show = "INT"
				print "Now showing only interruptible spells"
			else
				TCB_Settings.show = "ALL"
				print "Now showing all spells"
			end
			return
		end
		if r[0] == "alpha" then
			if numargs==2 then
				local ca = tonumber(r[1])
				if ca and ca>0 and ca<=1 then
					TCB_Settings.alpha.bar = ca
					_targetcastbar.TCBFrame:SetAlpha(TCB_Settings.alpha.bar)
					print("Setting overall alpha to "..ca)
				else
					print "Alpha must be >0 and <=1"
				end
			else
				print("Current alpha="..TCB_Settings.alpha.bar)
			end
			return
		end
		if r[0] == "prec" then
			if numargs==2 then
				local dp = tonumber(r[1])
				if dp==0 or dp==1 or dp==2 then
					TCB_Settings.dp = dp
					print("Setting precision to "..dp.." decimal places")
				else
					print "Precision must be 0,1 or 2"
				end
			else
				print("Current precision = "..TCB_Settings.dp.." decimal places")
			end
			return
		end
		if r[0] == "custom" then
			if numargs == 3 then
				local sx, sy
				sx = tonumber(r[1])
				sy = tonumber(r[2])
				if sx and sy then
					print("Setting bar to "..sx.." x "..sy.." pixels")
					TCB_Settings.sz = "CUSTOM"
					TCB_Settings.custom.sx = sx
					TCB_Settings.custom.sy = sy
					_targetcastbar.Resize()
				else
					print "Invalid values"
				end
			else
				print "Custom requires an X and a Y value to change."
				print ("Current settings are: X="..TCB_Settings.custom.sx..",Y="..TCB_Settings.custom.sy)
			end
			return
		end
		if r[0] == "config" then
			if numargs == 1 then
				_targetcastbar.configMode = not _targetcastbar.configMode
			end
			if not _targetcastbar.configMode then
				_targetcastbar.TCBFrame:SetVisible(false)
				CastBar=nil
			end
			if numargs == 2 then
				if r[1] == "int" then
					_targetcastbar.configModeBar = "INT"
				elseif r[1] == "nonint" then
					_targetcastbar.configModeBar = "UNT"
				else
					print "Unknown bar to display"
					return
				end
			end
			return
		end
		if r[0] == "undo" then
			TCB_Settings = {}
			TCB_Settings = _MiscUtility.CopyTable(TCBBU_Settings)
			_targetcastbar.Resize()
			return
		end
		if r[0] == "texturename" then
			if numargs == 2 then
				TCB_Settings.texturename = r[1]
				print ("Attempting to use texture: ".. TCB_Settings.texturename)
				_targetcastbar.TCBFrameTexture:SetTexture("TCB", TCB_Settings.texturename)
			else
				print ("Current texture in use: ".. TCB_Settings.texturename)
			end
			return
		end
		if r[0] == "saveprofile" then
			if numargs == 2 then
				local pn = r[1]
				TCB_Profiles[pn] = {}
				TCB_Profiles[pn] = _MiscUtility.CopyTable(TCB_Settings)
				print ("Saving current settings as profilename: "..pn)
			else
				print ("Usage: saveprofile PROFILENAME")
			end
			return
		end
		if r[0] == "listprofile" then
			if not TCB_Profiles then
				print ("You have no saved profiles.")
				return
			end
			local c = 1
			for k,_ in pairs(TCB_Profiles) do
				print (c..": Profilename: "..k)
				c=c+1
			end
			if (c==1) then
				print ("You have no saved profiles.")
			end
			return
		end
		if r[0] == "loadprofile" then
			if numargs == 2 then
				local pn = r[1]
				if TCB_Profiles[pn] then			
					print ("attempting to loadprofile: "..pn)
					TCB_Settings = {}
					TCB_Settings = _MiscUtility.CopyTable(TCB_Profiles[pn])
					_targetcastbar.Resize()
					_targetcastbar.TCBFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", TCB_Settings.x, TCB_Settings.y)
				else
					print ("Profilename: "..pn.." does not exist")
				end
			else
				print ("Usage: loadprofile PROFILENAME")
			end
			return
		end
		if r[0] == "adelea" then
			TCB_Settings = {}
			TCB_Settings = _MiscUtility.CopyTable(adelea)
			_targetcastbar.Resize()
			return
		end
	end
	
	print "TCB:"
    print "\t/tcb target - watches your active target"
    print "\t/tcb targettarget - watches your active targets target"
    print "\t/tcb focus - watches your focus target"
    print "\t/tcb this - watches current target even if target changes"
	print "\t/tcb config [int|nonint] - toggles display of static bar on screen to see changes"
	print "\t/tcb scale #.## - scales the bar size up or down by the given amount. Note using this will reset the custom setting"
	print "\t/tcb custom X Y - Overrides scale and sets bar to X by Y pixels"
	print "\t/tcb fill|deplete - changes the way the castbar moves (empty->full, or full->empty)"
	print "\t/tcb truncate - Toggles truncation of bartext as required"
	-- added by Kalvir 	(Zelandonii on Steampike).
	print "\t/tcb textsize ## - changes the text size"
	print "\t/tcb remain/total - Shows cast remaining and total time"
	print "\t/tcb remain - Shows cast remaining time"
	print "\t/tcb total - Shows cast total time"
	print "\t/tcb nameonly - Shows only the ability name"
	print "\t/tcb targetname - Shows the ability name and the target name"	
-- end
	print "\t/tcb lines - Toggles display between 1 and 2 lines"
	print "\t/tcb prec 0|1|2 - Sets number of decimal places to display on times"
	print "\t/tcb align L C R - Aligns bar text to Left/Center/Right"
	print "\t/tcb col bi|ti|bu|tu R G B [a] - set the color of the bars or text"
	print "\tt[b=bar, t=text, i=interruptible, u=non-interruptible, R/G/B/A are numbers from 0-1"
	print "\t/tcb alpha # - Sets overall alpha (Range 0-1)"
	print "\t/tcb channel - Toggles channeled spell reversal"
	print "\t/tcb border - Toggles display of border"
	print "\t/tcb background - Toggles display of background"
	print "\t/tcb texture - Toggles use of textured bar"
	print "\t/tcb texturename FILENAME - Sets FILENAME as the texture to use."
	print "\t/tcb interrupt - Toggles display of all spells or only interruptible ones"
	print "\t/tcb listprofile - Lists all saved profiles"
	print "\t/tcb loadprofile NAME - Loads the profile saved as NAME"
	print "\t/tcb saveprofile NAME - Saves the current active settings as NAME"
	print "\t/tcb undo - restores settings to how they were at loadtime"
	print "\t/tcb reset - resets all options to defaults"
end

---------------------
-- Event Handlers
---------------------

function _targetcastbar.OnUpdate()
	local t = nil
	local CastBar
	local Caster
	
	if _targetcastbar.configMode then
		CastBar = {
			uninterruptible = false,
			abilityName = "CB Configuration Mode",
			duration = 12,
			remaining = 3,
			channeled = false,
		}
		if _targetcastbar.configModeBar == "UNT" then
			CastBar.uninterruptible = true
		end

		Caster = {}
	else
		if TCB_Settings.t == "THIS" then
			t = _targetcastbar.uid
		elseif TCB_Settings.t == "FOCUS" then
			t = "focus"
		elseif TCB_Settings.t == "TARGETTARGET" then
			t = "player.target.target"
		else
			t = "player.target"
		end

		if not t then
			return
		end
	
		CastBar = Inspect.Unit.Castbar(t)
		Caster = Inspect.Unit.Lookup(t)
	end
	if CastBar then
		TCB_Settings.PCB = CastBar
		if CastBar.uninterruptible and (TCB_Settings.show == "INT") then
			return
		end
		-- Do stuff that doesn't change during the cast only once:
		if not(CastBar == PrevCastbar) then
			if CastBar.uninterruptible then
				local br,bg,bb,ba
				br=TCB_Settings.cols.bu_r
				bg=TCB_Settings.cols.bu_g
				bb=TCB_Settings.cols.bu_b
				ba=TCB_Settings.alpha.bu
				_targetcastbar.TCBFrame.solid:SetBackgroundColor(br,bg,bb,ba)
				_targetcastbar.TCBFrame.background:SetBackgroundColor(br/4,bg/4,bb/4,ba*0.75)
				br=TCB_Settings.cols.tu_r
				bg=TCB_Settings.cols.tu_g
				bb=TCB_Settings.cols.tu_b
				ba=TCB_Settings.alpha.tu
				_targetcastbar.TCBFrame.text:SetFontColor(br,bg,bb)
				_targetcastbar.TCBFrame.text:SetAlpha(ba)
			else
				local br,bg,bb,ba
				br=TCB_Settings.cols.bi_r
				bg=TCB_Settings.cols.bi_g
				bb=TCB_Settings.cols.bi_b
				ba=TCB_Settings.alpha.bi
				_targetcastbar.TCBFrame.solid:SetBackgroundColor(br,bg,bb,ba)
				_targetcastbar.TCBFrame.background:SetBackgroundColor(br/4,bg/4,bb/4,ba*0.75)
				br=TCB_Settings.cols.ti_r
				bg=TCB_Settings.cols.ti_g
				bb=TCB_Settings.cols.ti_b
				ba=TCB_Settings.alpha.ti
				_targetcastbar.TCBFrame.text:SetFontColor(br,bg,bb)
				_targetcastbar.TCBFrame.text:SetAlpha(ba)
			end
			-- Deal with unchanging text:
			if TCB_Settings.details == "" or TCB_Settings.details == "t" or TCB_Settings.details == "n" then
				if TCB_Settings.details == "" then
					_targetcastbar.TCBFrame.text:SetText((CastBar.abilityName or "UNKNOWN SPELL"))
				end
				if TCB_Settings.details == "t" then
					local d
					local sep = '\n'
					if TCB_Settings.dp == 0 then
						d = string.format("[%d]", CastBar.duration)
					elseif TCB_Settings.dp == 1 then
						d = string.format("[%.1f]", CastBar.duration)
					else
						d = string.format("[%.2f]", CastBar.duration)
					end
					if TCB_Settings.nl == 1 then
						sep = ' '
					end
					_targetcastbar.TCBFrame.text:SetText(string.format("%s%s%s", (CastBar.abilityName or "UNKNOWN SPELL"), sep, d))
				end
				if TCB_Settings.details == "n" then
					local SpellTarget
					local sep
					if _targetcastbar.configMode then
						SpellTarget = {name = "TargetName"}
					else
						SpellTarget = Inspect.Unit.Detail(Caster..".target")
					end
					local TargetName
					if SpellTarget then
						TargetName = SpellTarget.name
					else
						TargetName = "Self"
					end
					if TCB_Settings.nl == 1 then
						sep = ' '
					else
						sep = '\n'
					end
					_targetcastbar.TCBFrame.text:SetText(string.format("%s%s[%s]", (CastBar.abilityName or "UNKNOWN SPELL"), sep, TargetName))
				end
				-- Center the text:
				_targetcastbar.TCBFrame.text:ResizeToText()
				if (_targetcastbar.TCBFrame.text:GetWidth() > fWidth) and (TCB_Settings.truncate == "Y") then
					_targetcastbar.TCBFrame.text:SetWidth(fWidth)
				end
			end

			Couner = 0
			_targetcastbar.TCBFrame:SetVisible(true)
			_targetcastbar.TCBFrame.solid:SetAlpha(0.5)

			PrevCastbar = CastBar
		end

		-- Deal with changing text:
		if TCB_Settings.details == "rt" or TCB_Settings.details == "r" then
			if TCB_Settings.details == "rt" then
				local d
				local sep = '\n'
				if TCB_Settings.dp == 0 then
					d = string.format("[%d/%d]", CastBar.remaining, CastBar.duration)
				elseif TCB_Settings.dp == 1 then
					d = string.format("[%.1f/%.1f]", CastBar.remaining, CastBar.duration)
				else
					d = string.format("[%.2f/%.2f]", CastBar.remaining, CastBar.duration)
				end
				if TCB_Settings.nl == 1 then
					sep = ' '
				end
				_targetcastbar.TCBFrame.text:SetText(string.format("%s%s%s", (CastBar.abilityName or "UNKNOWN SPELL"), sep, d))
			end
			if TCB_Settings.details == "r" then
				local d
				local sep = '\n'
				if TCB_Settings.dp == 0 then
					d = string.format("[%d]", CastBar.remaining)
				elseif TCB_Settings.dp == 1 then
					d = string.format("[%.1f]", CastBar.remaining)
				else
					d = string.format("[%.2f]", CastBar.remaining)
				end				
				if TCB_Settings.nl == 1 then
					sep = ' '
				end
				_targetcastbar.TCBFrame.text:SetText(string.format("%s%s%s", (CastBar.abilityName or "UNKNOWN SPELL"), sep, d))
			end
			-- Center the text:
			_targetcastbar.TCBFrame.text:ResizeToText()
			if (_targetcastbar.TCBFrame.text:GetWidth() > fWidth) and (TCB_Settings.truncate == "Y") then
				_targetcastbar.TCBFrame.text:SetWidth(fWidth)
			end
		end
		-- Update the bar progress:
		Remaining = CastBar.remaining
		local Done = Remaining/CastBar.duration
		if TCB_Settings.m == "FILL" then
			if CastBar.channeled and TCB_Settings.chnl == "Y" then
				_targetcastbar.TCBFrame.solid:SetWidth(fWidth*Done)
			else
				_targetcastbar.TCBFrame.solid:SetWidth(fWidth*(1-Done))
			end
		else
			if CastBar.channeled and TCB_Settings.chnl == "Y" then
				_targetcastbar.TCBFrame.solid:SetWidth(fWidth*(1-Done))
			else
				_targetcastbar.TCBFrame.solid:SetWidth(fWidth*Done)
			end
		end
	else
		if  Caster ~= PrevCaster then
			Remaining = 0	-- Clear 'Interrupted' detection.
		end

		if Remaining < 0.06 and Couner == 0 then	-- Last spell completed and we're not showing 'Interrupted' fadeout?
			_targetcastbar.TCBFrame:SetVisible(false)
			_targetcastbar.TCBFrame.text:ClearPoint("CENTERLEFT")
			_targetcastbar.TCBFrame.text:ClearPoint("CENTERRIGHT")
			_targetcastbar.TCBFrame.text:ClearPoint("CENTER")
			local align
			if TCB_Settings.align == "L" then
				align="CENTERLEFT"
			elseif TCB_Settings.align == "R" then
				align="CENTERRIGHT"
			else
				align="CENTER"
			end
			_targetcastbar.TCBFrame.text:SetPoint(align, _targetcastbar.TCBFrame, align, 0,0)
		else	-- Last spell was interrupted:
			-- Show 'Interrupted' with fadeout:
			_targetcastbar.TCBFrame.solid:SetBackgroundColor(1,0.27,0.27,1)
			_targetcastbar.TCBFrame.text:SetFontColor(1, 1, 1)
			_targetcastbar.TCBFrame.text:SetText("Interrupted")

			_targetcastbar.TCBFrame.text:ResizeToText()
			_targetcastbar.TCBFrame.text:ClearPoint("CENTERLEFT")
			_targetcastbar.TCBFrame.text:ClearPoint("CENTERRIGHT")
			_targetcastbar.TCBFrame.text:SetPoint("CENTER", _targetcastbar.TCBFrame, "CENTER", 0,0)
			_targetcastbar.TCBFrame.solid:SetWidth(fWidth)
			if Couner == 0 then	-- We're starting the fadeout?
				Couner = 10
			else	-- We're in the fadeout:
				Couner = Couner-1
				_targetcastbar.TCBFrame.solid:SetAlpha(Couner/20)
			end
			Remaining = 0	-- Clear 'Interrupted' detection.
		end
		PrevCastbar = nil	-- Update tracking var.
	end
	PrevCaster = Caster	-- Update tracking var.
end


function _targetcastbar.VariablesLoaded(addon)
	if not (addon == "TCB") then
		return
	end
	-- check that all our defaults are in the saved variables
	_MiscUtility.MergeTable(TCB_Settings, defaults)
	TCBBU_Settings = _MiscUtility.CopyTable(TCB_Settings)

	_targetcastbar.SetupFrames()
	_targetcastbar.Resize()
	_targetcastbar.TCBFrame:ClearPoint("CENTER")
	_targetcastbar.TCBFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", TCB_Settings.x, TCB_Settings.y)
	_targetcastbar.TCBFrame.borderT:SetVisible((TCB_Settings.bd=="Y"))
	_targetcastbar.TCBFrame.borderB:SetVisible((TCB_Settings.bd=="Y"))
	_targetcastbar.TCBFrame.borderL:SetVisible((TCB_Settings.bd=="Y"))
	_targetcastbar.TCBFrame.borderR:SetVisible((TCB_Settings.bd=="Y"))
	local align
	if TCB_Settings.align == "L" then
		align="CENTERLEFT"
	elseif TCB_Settings.align == "R" then
		align="CENTERRIGHT"
	else
		align="CENTER"
	end
	_targetcastbar.TCBFrame.text:SetPoint(align, _targetcastbar.TCBFrame, align, 0,0)
	_targetcastbar.TCBFrame.background:SetVisible((TCB_Settings.bg == "Y"))
	_targetcastbar.TCBFrameTexture:SetTexture("TCB", TCB_Settings.texturename)
	_targetcastbar.TCBFrameTexture:SetVisible((TCB_Settings.texture == "Y") and (TCB_Settings.bg == "Y"))
	table.insert(Event.System.Update.Begin, { _targetcastbar.OnUpdate, "TCB", "OnUpdate" })
	
	if (not TCB_Profiles) then
		TCB_Profiles = {}
	end
end

---------------------
-- Register Events
---------------------

table.insert(Event.Addon.SavedVariables.Load.End, { _targetcastbar.VariablesLoaded, "TCB", "VariablesLoaded" })
table.insert(Command.Slash.Register("tcb"), { _targetcastbar.SlashHandler, "TCB", "SlashHandler" })

print("v".._targetcastbar.version.." loaded. Type /tcb to see options.")